/* -*- C++ -*- */

/* -*- C++ -*- */

/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Crystal animation and 3D modeling application
 *
 * Authors:   Tommi Ilmonen 2001-2004
 * Copyright: Tommi Ilmonen and/or Tekes 2001-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#include <crystal_action.h>

#include <crystal_action_creator.h>
#include <crystal_audio_action.h>
#include <crystal_blow_recorder.h>
#include <crystal_emitter_recorder.h>
#include <crystal_mesh_recorder.h>
#include <crystal_vortex_recorder.h>
#include <crystal_remove_action.h>

namespace Crystal { 

  /** Writes both the beginning time and end time of the action. */
  
  void Action::writeDomTimeStamp(QDomElement &parent, QDomDocument &doc)
  {
    char buf[64];

    m_time.write(buf);
    QDomElement elem = doc.createElement("time");
    elem.appendChild(doc.createTextNode(buf));
    parent.appendChild(elem);

    m_endTime.write(buf);
    QDomElement elem2 = doc.createElement("endtime");
    elem2.appendChild(doc.createTextNode(buf));
    parent.appendChild(elem2);    
  }

  void Action::readDomTimeStamp(QDomElement &elem)
  {
    QString str = elem.namedItem("time").firstChild().toText().data();
    m_time.read(str.ascii());
    str = elem.namedItem("endtime").firstChild().toText().data();
    m_endTime.read(str.ascii());
  }

  /** A factory function that can be used to create actions based on
      their class name. */

  Action * Action::create(const char *str)
  {
    if(strcmp(str, "ActionCreator") == 0)
      return new ActionCreator;
    if(strcmp(str, "AudioActionControl") == 0)
      return new AudioActionControl;
    if(strcmp(str, "AudioActionSourceLocation2") == 0)
      return new AudioActionSourceLocation2;
    if(strcmp(str, "AudioActionNoise") == 0)
      return new AudioActionNoise;
    if(strcmp(str, "AudioActionNoteoff") == 0)
      return new AudioActionNoteoff;
    if(strcmp(str, "AudioActionNoteParameter") == 0)
      return new AudioActionNoteParameter;
    if(strcmp(str, "AudioActionGranular") == 0)
      return new AudioActionGranular;
    if(strcmp(str, "AudioActionSample") == 0)
      return new AudioActionSample;
    if(strcmp(str, "AudioActionMessage") == 0)
      return new AudioActionMessage;

    if(strcmp(str, "CreateEmitterAction") == 0)
      return new CreateEmitterAction;
    if(strcmp(str, "CreateMeshAction") == 0)
      return new CreateMeshAction;
    if(strcmp(str, "CreateVortexAction") == 0)
      return new CreateVortexAction;
    if(strcmp(str, "CreateBlowAction") == 0)
	      return new CreateBlowAction;

    if(strcmp(str, "DeleteMeshAction") == 0)
      return new DeleteMeshAction;

    if(strcmp(str, "RemoveAction") == 0)
      return new RemoveAction;
  
    return 0;
  }

}
