/* -*- C++ -*- */

/* -*- C++ -*- */

/* -*- C++ -*- */

/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Crystal animation and 3D modeling application
 *
 * Authors:   Tommi Ilmonen 2001-2004
 * Copyright: Tommi Ilmonen and/or Tekes 2001-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef CRYSTAL_ACTION_H
#define CRYSTAL_ACTION_H

#include <di_types.h>

#include <Fluid/TimeStamp.hpp>

#include <qdom.h> 


namespace Crystal { 

  class ActionList;

  class Action
  {
  public:
    Action() : m_specialId(-1) {}
    Action(const Fluid::TimeStamp &t) : m_time(t), m_specialId(-1) {}

    virtual ~Action() {}

    virtual void act(ActionList *) = 0;
  
    const Fluid::TimeStamp & getTimeStamp() const { return m_time; }
    void setTimeStamp(const Fluid::TimeStamp &ts) { m_time = ts; }

    const Fluid::TimeStamp & getEndTimeStamp() const { return m_endTime; }
    void setEndTimeStamp(const Fluid::TimeStamp &ts) { m_endTime = ts; }

    virtual QDomElement writeDom(QDomDocument &doc) = 0;
    virtual bool readDom(QDomElement &elem) = 0;

    void writeDomTimeStamp(QDomElement &parent, QDomDocument &doc);
    void readDomTimeStamp(QDomElement &elem);

    static Action * create(const char *);

    void setSpecialId(int id) { m_specialId = id; }
    int specialId() const { return m_specialId; }

  protected:
  
    Fluid::TimeStamp m_time;
    Fluid::TimeStamp m_endTime;

    int m_specialId;
  };

}

#endif
