/* -*- C++ -*- */

/* -*- C++ -*- */

/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Crystal animation and 3D modeling application
 *
 * Authors:   Tommi Ilmonen 2001-2004
 * Copyright: Tommi Ilmonen and/or Tekes 2001-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#include <crystal_action_creator.h>

#include <crystal_action_list.h>
#include <crystal_dom_util.h>
#include <crystal_engine.h>
#include <crystal_particle_editor.h>
#include <crystal_tools.h>

#include <vee_error.h>
#include <vee_object.h>
#include <vee_scene.h>

namespace Crystal { 

  ActionCreator::~ActionCreator()
  {}

  void ActionCreator::act(ActionList *al)
  {
    VEE_SceneBox * scene = al->engine()->scene();

    VEE_Object * o = 
      al->engine()->tools()->particleEditor()->createParticle(m_id);
  
    if(!o)
      VEE_fatal("ActionCreator::act # NULL object");

    o->setLocation(m_visual.location());
    o->setVelocity(m_visual.velocity());
  
    scene->addNewObject(o);

    o->update(1.0e-5);

    m_visual = *o;
  }

  QDomElement ActionCreator::writeDom(QDomDocument &doc)
  {
    QDomElement elem = doc.createElement("ActionCreator");

    writeDomTimeStamp(elem, doc);

    addTextChild(elem, doc, "location", m_visual.location());
    addTextChild(elem, doc, "velocity", m_visual.velocity());
    addTextChild(elem, doc, "id", m_id);

    return elem;
  }

  bool ActionCreator::readDom(QDomElement &elem)
  {
    if(elem.tagName() != "ActionCreator")
      return false;

    readDomTimeStamp(elem);
  
    m_visual.setLocation(getVector3(elem, "location"));
    m_visual.setVelocity(getVector3(elem, "velocity"));

    m_id = getInt(elem, "id");
  
    return true;
  }

}
