/* -*- C++ -*- */

/* -*- C++ -*- */

/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Crystal animation and 3D modeling application
 *
 * Authors:   Tommi Ilmonen 2001-2004
 * Copyright: Tommi Ilmonen and/or Tekes 2001-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#include <crystal_audio_allocator.h>

namespace Crystal { 

  AudioAllocator::AudioAllocator()
    : m_counter(1)
  {}

  AudioAllocator::~AudioAllocator()
  {}

  int AudioAllocator::allocateChannel()
  {
    int oldest = -1, age = m_counter;

    for(uint i=0; i < m_channels.size(); i++) {
      int tmp = m_channels[i];
      if(tmp >= 0 && tmp < age) {
	age = tmp;
	oldest = i;
      }
    }

    if(oldest < 0)
      return -1;

    m_channels[oldest] = -1;
  
    return oldest;
  }

  void AudioAllocator::deallocateChannel(int c)
  {
    if((uint) c >= m_channels.size())
      return;

    m_channels[c] = m_counter++;
  }

  void AudioAllocator::expand(uint n)
  {
    uint os = m_channels.size();
    m_channels.resize(n);
  
    for(; os < n; os++) {
      m_channels[os] = 0;
    }
  }

  void AudioAllocator::clearAllocations()
  {
    for(uint os = 0; os < m_channels.size(); os++) {
      m_channels[os] = 0;
    }
  }

}

