/* -*- C++ -*- */

/* -*- C++ -*- */

/* -*- C++ -*- */

/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Crystal animation and 3D modeling application
 *
 * Authors:   Tommi Ilmonen 2001-2004
 * Copyright: Tommi Ilmonen and/or Tekes 2001-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef CRYSTAL_BLOW_RECORDER_H
#define CRYSTAL_BLOW_RECORDER_H

#include <crystal_action.h>
#include <crystal_recorder.h>
#include <vee_blow.h>

#include <Fluid/Vector3.hpp>

namespace Crystal { 

  class AudioActionControl;
  class AudioActionNoteon;
  class AudioActionSourceLocation2;

  /** Creates a blow-object to the action list.  */

  class CreateBlowAction : public Action
  {
  public:
    CreateBlowAction() : m_id(-1) { m_location.clear(); }

    CreateBlowAction(int id,
		     const Vector3 &location, 
		     const TimeStamp &ts)
      : Action(ts), m_location(location), m_id(id) {}

    virtual ~CreateBlowAction();
  
    virtual void act(ActionList *al);
    virtual QDomElement writeDom(QDomDocument &doc);
    virtual bool readDom(QDomElement &elem);

  protected:
    Vector3 m_location;
    int m_id;
  };

  /////////////////////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////////////////////

  /// Records blow activity.
  class BlowRecorder : public Recorder
  {
  public:
    BlowRecorder(bool motion = true);
    virtual ~BlowRecorder();

    virtual void prepare(ActionList *);

    virtual void beginRecording(ActionList *, 
				const TimeStamp &);

    virtual void endRecording(ActionList *, 
			      const TimeStamp &);

    virtual void record(ActionList *, const TimeStamp &);

    virtual void render(Engine *, GlData *);
  protected:
    bool m_motion;
    int  m_blowId;
    int  m_audioSourceId;
    int  m_noteOnActionId;
    long m_trackerCount;

    AudioActionSourceLocation2 * m_audioLocator;
    AudioActionControl * m_rateControl;
    
    float m_range;
    float m_magnitude;
    Vector3 m_location;
    Vector3 m_direction;
  };


}

#endif
