/* -*- C++ -*- */

/* -*- C++ -*- */

/* -*- C++ -*- */

/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Crystal animation and 3D modeling application
 *
 * Authors:   Tommi Ilmonen 2001-2004
 * Copyright: Tommi Ilmonen and/or Tekes 2001-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef CRYSTAL_DOM_UTIL_H
#define CRYSTAL_DOM_UTIL_H

#include <crystal.h>

#include <Fluid/Matrix3.hpp>
#include <Fluid/TimeStamp.hpp>

#include <vee_color.h>
#include <vee_matrix3.h>
#include <vee_vector3.h>

#include <qdom.h>
#include <qstring.h>
#include <qtextstream.h>

namespace Crystal { 

  QString toStr(const Vector3 &v);
  QString toStr(const Matrix3 &v);
  QString toStr(const VEE_Rgba &);
  QString toStr(const VEE_Hsva &);

  Vector3 toVector3(const QString &);
  Matrix3 toMatrix3(const QString &);
  VEE_Hsva toHsva(const QString &);
  VEE_Rgba toRgba(const QString &);
  TimeStamp toTimeStamp(const QString &);

  void addTextChild(QDomElement &, QDomDocument &doc,
		    const QString &tag,  const QString &value);
  void addTextChild(QDomElement &, QDomDocument &doc,
		    const QString &tag,  const char *value);
  void addTextChild(QDomElement &, QDomDocument &doc,
		    const QString &tag,  int value);
  void addTextChild(QDomElement &, QDomDocument &doc,
		    const QString &tag,  float value);
  void addTextChild(QDomElement &, QDomDocument &doc,
		    const QString &tag,  const Vector3 &v);
  void addTextChild(QDomElement &, QDomDocument &doc,
		    const QString &tag,  const Matrix3 &v);
  void addTextChild(QDomElement &, QDomDocument &doc,
		    const QString &tag,  const TimeStamp &v);

  float     getFloat(QDomElement &, const QString &tag, float def=0.0f);
  int       getInt(QDomElement &, const QString &tag, int def=0);
  Vector3   getVector3(QDomElement &, const QString &tag, 
		       const Vector3 & def = VEE_Vector3ZERO);
  Matrix3   getMatrix3(QDomElement &, const QString &tag,
		       const Matrix3 &def = VEE_Matrix3IDENTITY);
  QString   getString(QDomElement &, const QString &tag, const char * def = 0);
  TimeStamp getTimeStamp(QDomElement &e, const QString &tag);

}

inline QTextStream & operator << (QTextStream &s, const Fluid::Vector3 &v)
{
  return s << Crystal::toStr(v);
}

inline QTextStream & operator << (QTextStream &s, const Fluid::Matrix3 &v)
{
  return s << Crystal::toStr(v);
}

QTextStream & operator >> (QTextStream &s, Fluid::Vector3 &v);
QTextStream & operator >> (QTextStream &s, Fluid::Matrix3 &v);



#endif

