/* -*- C++ -*- */

/* -*- C++ -*- */

/* -*- C++ -*- */

/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Crystal animation and 3D modeling application
 *
 * Authors:   Tommi Ilmonen 2001-2004
 * Copyright: Tommi Ilmonen and/or Tekes 2001-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef CRYSTAL_EMITTER_RECORDER_H
#define CRYSTAL_EMITTER_RECORDER_H

#include <crystal_action.h>
#include <crystal_recorder.h>

#include <vee_time.h>

#include <Fluid/Vector3.hpp>

#include <vector>

class VEE_Emitter;

namespace Crystal { 

  class AudioActionControl;
  class AudioActionNoteon;
  class AudioActionSourceLocation2;

  class EmitterRecorder : public Recorder
  {
  public:
    EmitterRecorder();
    virtual ~EmitterRecorder();

    virtual void prepare(ActionList *);

    virtual void beginRecording(ActionList *, 
				const Fluid::TimeStamp &);

    virtual void endRecording(ActionList *, 
			      const Fluid::TimeStamp &);

    virtual void record(ActionList *, const Fluid::TimeStamp &);

  protected:
    int  m_emitterId;
    int  m_audioSourceId;
    int  m_noteOnActionId;
    long m_trackerCount;
    long m_gloveCount;

    AudioActionSourceLocation2 * m_audioLocator;
    AudioActionControl * m_rateControl;

    std::vector<float> m_params;
  };

  /////////////////////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////////////////////

  class EmitterRecorder2 : public Recorder
  {
  public:
    EmitterRecorder2();
    virtual ~EmitterRecorder2();

    virtual void prepare(ActionList *);

    virtual void beginRecording(ActionList *, 
				const Fluid::TimeStamp &);

    virtual void endRecording(ActionList *, 
			      const Fluid::TimeStamp &);

    virtual void record(ActionList *, const Fluid::TimeStamp &);

  protected:
    VEE_Emitter * m_emitter;
    long     m_trackerCount;
    int      m_particleId;
    VEE_Time m_prevTime;

    std::vector<float> m_params;
  };

  /////////////////////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////////////////////

  /** Creates a emitter-object to the action list.  */

  class CreateEmitterAction : public Action
  {
  public:
    CreateEmitterAction()
      : m_id(-1), m_emitterType(-1) { m_location.clear(); }

    CreateEmitterAction(int id,
				int emitterType,
				const Fluid::Vector3 &location, 
				const Fluid::TimeStamp &ts)
      : Action(ts), 
	m_location(location), 
	m_id(id), 
	m_emitterType(emitterType) 
    {}

    virtual ~CreateEmitterAction() {}
  
    virtual void act(ActionList *al);

    virtual QDomElement writeDom(QDomDocument &doc);
    virtual bool readDom(QDomElement &);

  protected:
    Fluid::Vector3 m_location;
    int m_id;
    int m_emitterType;
  };

}

#endif
