/* -*- C++ -*- */

/* -*- C++ -*- */

/* -*- C++ -*- */

/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Crystal animation and 3D modeling application
 *
 * Authors:   Tommi Ilmonen 2001-2004
 * Copyright: Tommi Ilmonen and/or Tekes 2001-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef CRYSTAL_EXPLOSION_RECORDER_H
#define CRYSTAL_EXPLOSION_RECORDER_H

#include <crystal_action.h>
#include <crystal_recorder.h>

#include <Fluid/MessageSink.hpp>


namespace Crystal { 

  /** Creates a explosion-object to the action list.  */

  class CreateExplosionAction : public Action
  {
  public:
    CreateExplosionAction(const Fluid::Vector3 &location, 
				  float range,
				  float magnitude,
				  const Fluid::TimeStamp &ts)
      : Action(ts), m_location(location), 
	m_range(range), m_magnitude(magnitude)  {}

    virtual ~CreateExplosionAction() {}
  
    virtual void act(ActionList *al);

    virtual QDomElement writeDom(QDomDocument &doc);
    virtual bool readDom(QDomElement &elem);

  protected:
    Fluid::Vector3 m_location;
    float m_range, m_magnitude;
  };

  /////////////////////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////////////////////

  class ExplosionRecorder : public Recorder, 
			    public Fluid::MessageSink
  {
  public:
    ExplosionRecorder();
    virtual ~ExplosionRecorder();

    virtual void prepare(ActionList *) {}

    virtual void beginRecording(ActionList *, 
				const Fluid::TimeStamp &);

    virtual void endRecording(ActionList *, 
			      const Fluid::TimeStamp &);

    virtual void record(ActionList *, const Fluid::TimeStamp &);

    virtual void render(Engine *, GlData *);

    virtual bool msgProcess(const char *id, Fluid::Message *);

    // virtual void onEvent(const Fluid::Event &);

  protected:
    bool m_explodeNow;
    Vector3 m_center;
    float   m_diameter;
  };

}

#endif
