/* -*- C++ -*- */

/* -*- C++ -*- */

/* -*- C++ -*- */

/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Crystal animation and 3D modeling application
 *
 * Authors:   Tommi Ilmonen 2001-2004
 * Copyright: Tommi Ilmonen and/or Tekes 2001-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef CRYSTAL_FORCE_EDITOR_H
#define CRYSTAL_FORCE_EDITOR_H

#include <crystal_dom_util.h>
#include <crystal_editor.h>
#include <crystal_widget.h>

#include <Fluid/MessageSink.hpp>

namespace Crystal { 

  class GlData;
  class Tools;

  class ForceEditor : public Editor,
		      public Fluid::MessageSink
  {
  public:
    enum Param {
      MAGNITUDE,
      SENSITIVITY,
      Params
    };

    class Item
    {
    public:
      Item() {}
      ~Item() {}

      float magnitude() const { return m_magnitude; }
      float sensitivity() const { return m_sensitivity; }

      QDomElement writeDom(QDomDocument &doc)
      {
	QDomElement elem = doc.createElement("ForceItem");

	addTextChild(elem, doc, "magnitude", m_magnitude);
	addTextChild(elem, doc, "sensitivity", m_sensitivity);

	return elem;
      }

      bool readDom(QDomElement &elem)
      {
	if(elem.tagName() != "ForceItem")
	  return false;
	
	m_magnitude = getFloat(elem, "magnitude", 1.0f);
	m_sensitivity = getFloat(elem, "sensitivity", 0.5f);

	return true;
      }

      
      Widget * m_button;
      float    m_magnitude;
      float    m_sensitivity;
      QString  m_id;
    };

    ForceEditor(Tools *);
    virtual ~ForceEditor();

    virtual bool msgProcess(const char *id, Fluid::Message *);

    void render(GlData *);

    void update();
    virtual void beforeEvents() { m_widgets.beforeEvents(); }
    void handleEvent(const InEvent *e) { m_widgets.handleEvent(e); }

    Tools *host() { return m_host; }

    void selectForce(int);

    virtual QDomElement writeDom(QDomDocument &doc);
    virtual bool readDom(QDomElement &elem);

    Item * current() 
    { return m_selectedForce >= 0 ?  & m_forces[m_selectedForce] : 0; }

  protected:

    Tools      *m_host;
    Widgets     m_widgets;


    std::vector<Item> m_forces;
    int m_selectedForce;

    Slider     *m_params[Params];
  };

}

#endif
