/* -*- C++ -*- */

/* -*- C++ -*- */

/* -*- C++ -*- */

/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Crystal animation and 3D modeling application
 *
 * Authors:   Tommi Ilmonen 2001-2004
 * Copyright: Tommi Ilmonen and/or Tekes 2001-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef CRYSTAL_GEE_POOL_H
#define CRYSTAL_GEE_POOL_H

#include <crystal.h>

#include <gee_profile.h>

#include <vee_color.h>
#include <vee_value.h>
#include <vee_reference_object.h>

#include <Fluid/MessageSink.hpp>

#include <map>
#include <string>

namespace Crystal { 
  
  class Engine;

  class GeeConfig : public Fluid::MessageSink
  {
  public:
    typedef std::map<std::string, VEE_SafePtr<VEE_Value> > container;
    typedef container::iterator iterator;

    GeeConfig(Engine *);
    virtual ~GeeConfig();

    void init();

    virtual bool msgProcess(const char *id, Fluid::Message *);

    void setValue(const std::string &name, const VEE_Value &v);
    void setValueInt(const std::string &name, int v);
    void setValueFloat(const std::string &name, float v);
    void setValueString(const std::string &name, const std::string &val);

    VEE_Value * getValue(const std::string &name);
    int   getValueInt(const std::string &name, int def = 0);
    float getValueFloat(const std::string &name, float def = 1.0);
    std::string getValueString(const std::string &name, 
			       const std::string &def = "");
    VEE_Rgba getValueRgba(const std::string &name, 
			  const VEE_Rgba & def = VEE_Rgba::Red);
    VEE_Rgba constructRgba(const std::string &name);
    
    GEE_Material material(const std::string &);

    // void setProfile(const GEE_Profile &p) { m_profile = p; }
    const GEE_Profile & profile(const std::string &);

    // GEE_Material & material() { return m_material; }
    // void setMaterial(const GEE_Material &m) { m_material = m; }

    void selectProfile(const char * name, Message * m = 0);
    
    // const VEE_Rgba & color() const { return m_color;}

    int lightSet() const { return m_lightSet; }
    
  protected:

    container m_values;
    
    /// Current tool profiles:
    std::map<std::string, GEE_Profile> m_profile;
    /// Predefined profiles:
    std::map<std::string, GEE_Profile> m_profiles;
    Engine * m_engine;
    int  m_lightSet;

    GEE_Profile m_empty;
  };

}

#endif
