/* -*- C++ -*- */

/* -*- C++ -*- */

/* -*- C++ -*- */

/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Crystal animation and 3D modeling application
 *
 * Authors:   Tommi Ilmonen 2001-2004
 * Copyright: Tommi Ilmonen and/or Tekes 2001-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef CRYSTAL_GEE_EDITOR_H
#define CRYSTAL_GEE_EDITOR_H

#include <crystal_editor.h>
#include <crystal_widget.h>
#include <Fluid/MessageSink.hpp>

#include <gee_particle_object.h>

namespace Crystal { 

  class GlData;
  class Tools;

  class GeeEditor : public Editor,
		    public Fluid::MessageSink
  {
  public:

    GeeEditor(Tools *);
    virtual ~GeeEditor();

    virtual bool msgProcess(const char *id, Fluid::Message *);

    virtual void render(GlData *);

    virtual void update();
    virtual void handleEvent(const InEvent *e) { m_widgets.handleEvent(e); }
    
    virtual QDomElement writeDom(QDomDocument &doc);
    virtual bool readDom(QDomElement &elem);

    Tools *host() { return m_host; }

  protected:

    void updateColor(const VEE_Rgba & color);

    Tools      *m_host;
    Widgets     m_widgets;

    VEE_Rgba    m_color;

    GEE_ParticleData *   m_pd;
    GEE_id_t             m_pdId;
    GEE_ParticleObject  *m_po;
    VEE_RefPtr<GEE_Geometry> m_pdd;
  };

}

#endif
