/* -*- C++ -*- */

/* -*- C++ -*- */

/* -*- C++ -*- */

/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Crystal animation and 3D modeling application
 *
 * Authors:   Tommi Ilmonen 2001-2004
 * Copyright: Tommi Ilmonen and/or Tekes 2001-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef CRYSTAL_GEE_RECORDER_H
#define CRYSTAL_GEE_RECORDER_H

class GEE_Engine;

#include <crystal.h>

#include <Fluid/MessageSink.hpp>
#include <Fluid/TimeStamp.hpp>

#include <gee_operator.h>

namespace Crystal { 

  class GlData;
  class Engine;

  class GeeRecorder : public Fluid::MessageSink
  {
  public:

    GeeRecorder(Crystal::Engine *, 
		GEE_Engine *);

    virtual ~GeeRecorder();

    /// Sets the hand this recorder uses as the primary hand.
    void setHand(Hand h) { m_hand = h; }

    virtual void activate(const TimeStamp &now);
    virtual void deactivate(const TimeStamp &now);

    virtual void start(const TimeStamp &now);
    virtual void record(const TimeStamp &now);
    virtual void stop(const TimeStamp &now);

    virtual void update(const TimeStamp &now);
    
    virtual bool msgProcess(const char *id, Fluid::Message *);

    virtual void render(GlData *);

    bool recording() const { return m_recording; }

    VEE_RefPtr<GEE_OperatorGroup> & operatorGroup() { return m_operatorGroup; }

    const TimeStamp & beginRealTime() { return m_beginRealTime; }

  protected:

    VEE_RefPtr<GEE_OperatorGroup> m_operatorGroup;

    Crystal::Engine *m_host;
    GEE_Engine      *m_engine;
    bool             m_recording;

    TimeStamp        m_time;
    TimeStamp        m_beginRealTime;
    Hand             m_hand;
  };


}

#endif
