/* -*- C++ -*- */

/* -*- C++ -*- */

/* -*- C++ -*- */

/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Crystal animation and 3D modeling application
 *
 * Authors:   Tommi Ilmonen 2001-2004
 * Copyright: Tommi Ilmonen and/or Tekes 2001-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef CRYSTAL_GENERAL_EDITOR_H
#define CRYSTAL_GENERAL_EDITOR_H

#include <crystal_editor.h>
#include <crystal_transformation.h>
#include <crystal_widget.h>

#include <Fluid/MessageSink.hpp>

namespace Crystal { 

  class GlData;
  class Tools;

  class GeneralEditor : public Editor,
			public Fluid::MessageSink,
			public Transformation
  {
  public:
    enum Param {
      SPEED,
      GRAVITY,
      BELLS_SOUND_LEVEL,
      PARTICLE_SOUND_LEVEL,
      SOUNDTRACK_SOUND_LEVEL,
      SLIDERS
    };

    GeneralEditor(Tools *);
    ~GeneralEditor();

    virtual bool msgProcess(const char *id, Fluid::Message *);

    void render(GlData *);

    void update();

    virtual void beforeEvents() { m_widgets.beforeEvents(); }
    virtual void handleEvent(const InEvent *e) { m_widgets.handleEvent(e); }

    void selectScene(int);

    virtual QDomElement writeDom(QDomDocument &doc);
    virtual bool readDom(QDomElement &elem);

  protected:
  
    Tools                *m_host;
    Widgets               m_widgets;
    Slider               *m_sliders[SLIDERS];
    CheckButton          *m_forceToggle;
    float                         m_values[SLIDERS];

    std::vector<CubeWidget *> m_scenes;

  };

}

#endif
