/* -*- C++ -*- */

/* -*- C++ -*- */

/* -*- C++ -*- */

/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Crystal animation and 3D modeling application
 *
 * Authors:   Tommi Ilmonen 2001-2004
 * Copyright: Tommi Ilmonen and/or Tekes 2001-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef CRYSTAL_MESH_RECORDER_H
#define CRYSTAL_MESH_RECORDER_H

#include <crystal.h>
#include <crystal_action.h>
#include <crystal_recorder.h>

#include <Fluid/Matrix3.hpp>

namespace Crystal { 

  /** Creates a mesh-object to the action list.  */

  class CreateMeshAction : public Action
  {
  public:
    CreateMeshAction() : m_id(-1), m_meshType(-1) { }

    CreateMeshAction(int id,
		     int meshType,
		     const Vector3 &location, 
		     const Matrix3 &rotation, 
		     const TimeStamp &ts)
      : Action(ts), 
	m_id(id),
	m_meshType(meshType),
	m_location(location), 
	m_rotation(rotation) 
    {}

    virtual ~CreateMeshAction();
  
    virtual void act(ActionList *al);
    virtual QDomElement writeDom(QDomDocument &doc);
    virtual bool readDom(QDomElement &elem);

  protected:
    int m_id;
    int m_meshType;
    Vector3 m_location;
    Matrix3 m_rotation;
  };

  /////////////////////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////////////////////

  /** Deletes a mesh-object from the action list.  */

  class DeleteMeshAction : public Action
  {
  public:
    DeleteMeshAction() : m_id(-1) {}

    DeleteMeshAction(int id, const TimeStamp &ts) 
      : Action(ts), m_id(id) { }

    virtual ~DeleteMeshAction();
  
    virtual void act(ActionList *al);
    virtual QDomElement writeDom(QDomDocument &doc);
    virtual bool readDom(QDomElement &elem);

  protected:
    int m_id;
  };

  /////////////////////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////////////////////

  class MeshRecorder : public Recorder
  {
  public:
    MeshRecorder();
    virtual ~MeshRecorder();

    virtual void prepare(ActionList *);

    virtual void beginRecording(ActionList *, 
				const TimeStamp &);

    virtual void endRecording(ActionList *, 
			      const TimeStamp &);

    virtual void record(ActionList *, const TimeStamp &);

    virtual void render(Engine *, GlData *);

  protected:

    int  m_meshId;
    long m_trackerCount;

    Vector3 m_location;
    Matrix3 m_rotation;
  };

}

#endif
