/* -*- C++ -*- */

/* -*- C++ -*- */

/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Crystal animation and 3D modeling application
 *
 * Authors:   Tommi Ilmonen 2001-2004
 * Copyright: Tommi Ilmonen and/or Tekes 2001-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#include <crystal_model.h>

#include <vee_strs.h>
#include <vee_value.h>

namespace Crystal { 

  Model::Model()
  {}
  
  Model::~Model()
  {}
    
  bool Model::setValue(const char *id, VEE_Value *msg)
  {
    bool ok = false;

    if(VEE_Strs::equals(id, VEE_Strs::location)) {
      VEE_Vector3 v;
      
      ok = msg->getVector3(&v);
      
      if(ok)
	m_object.setLocation(v);
    }
    else if(VEE_Strs::equals(id, VEE_Strs::rotation)) {
      VEE_Matrix3 m;
      
      ok = msg->getMatrix3(&m);
      
      if(ok)
	m_object.setRotation(m);
    }
    else if(VEE_Strs::equals(id, "visible")) {
      int i;
      
      ok = msg->getInt(&i);
      
      if(ok)
	m_object.setVisible(i);
    }

    
    return ok;
  }

}
