/* -*- C++ -*- */

/* -*- C++ -*- */

/* -*- C++ -*- */

/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Crystal animation and 3D modeling application
 *
 * Authors:   Tommi Ilmonen 2001-2004
 * Copyright: Tommi Ilmonen and/or Tekes 2001-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef CRYSTAL_RECORDER_H
#define CRYSTAL_RECORDER_H

#include <crystal.h>
#include <crystal_tool_display.h>


#include <Fluid/TimeStamp.hpp>
#include <Fluid/Vector3.hpp>

#include <vee_reference_object.h>

namespace Crystal { 

  class ActionList;
  class Engine;
  class GlData;

  /** Abstract base class for classes that record data to action
      lists. */

  class Recorder
  {
  public:

    enum Mode {
      RECORD,
      MUTE
    };

    Recorder();
    virtual ~Recorder();

    virtual void prepare(ActionList *) = 0;

    virtual void beginRecording(ActionList *, 
				const Fluid::TimeStamp &) = 0;

    virtual void endRecording(ActionList *, 
			      const Fluid::TimeStamp &) = 0;

    virtual void record(ActionList *, const Fluid::TimeStamp &) = 0;

    virtual void render(Engine *, GlData *);

    void setDisplay(ToolDisplay *);

  protected:
    VEE_RefPtr<ToolDisplay> m_display;

    Recorder(const Recorder &) {}

    Mode m_mode;

  };
}


#endif
