/* -*- C++ -*- */

/* -*- C++ -*- */

/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Crystal animation and 3D modeling application
 *
 * Authors:   Tommi Ilmonen 2001-2004
 * Copyright: Tommi Ilmonen and/or Tekes 2001-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#include <crystal_remove_action.h>

#include <crystal_action_list.h>
#include <crystal_dom_util.h>

#include <vee_object.h>

namespace Crystal { 

  RemoveAction::~RemoveAction()
  {}

  void RemoveAction::act(ActionList *al)
  {
    al->deleteObject(m_objectId);
  }

  QDomElement RemoveAction::writeDom(QDomDocument &doc)
  {
    QDomElement elem = doc.createElement("RemoveAction");

    writeDomTimeStamp(elem, doc);

    addTextChild(elem, doc, "id", QString().setNum(m_objectId));

    return elem;
  }

  bool RemoveAction::readDom(QDomElement &elem)
  {
    if(elem.tagName() != "RemoveAction")
      return false;

    readDomTimeStamp(elem);

    m_objectId = getInt(elem, "id", -1);

    return true;
  }

}
