/* -*- C++ -*- */

/* -*- C++ -*- */

/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Crystal animation and 3D modeling application
 *
 * Authors:   Tommi Ilmonen 2001-2004
 * Copyright: Tommi Ilmonen and/or Tekes 2001-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#include <crystal_solid_editor.h>

#include <Fluid/MessageString.hpp>

namespace Crystal { 

  SolidEditor::Element::Element()
    : m_texture(0),
      m_hsva(VEE_Hsva::Red)
  {

  }

  /////////////////////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////////////////////

  SolidEditor::SolidEditor(Tools *host)
    : m_host(host),
      m_current(0),
      m_selected(-1)
  {}

  SolidEditor::~SolidEditor()
  {}

  bool SolidEditor::msgProcess(const char *id, Fluid::Message *m)
  {
    
    return false;
  }

  void SolidEditor::render(GlData *gld)
  {
    m_widgets.renderGl(gld);
  }

  void SolidEditor::update()
  {}

  QDomElement SolidEditor::writeDom(QDomDocument &)
  {
    return QDomElement();
  }

  bool SolidEditor::readDom(QDomElement &)
  {
    return false;
  }

  bool SolidEditor::selectObject(uint i)
  {
    if(i >= m_objects.size())
      return false;

    m_current = m_objects[i].ptr();
    
    return true;
  }

  bool SolidEditor::selectTexture(uint t)
  {
    if(!m_current)
      return false;

    m_current->m_texture = t;

    return true;
  }

  uint SolidEditor::expandOne()
  {
    uint r = m_objects.size();

    m_objects.resize(r + 1);

    Element * elem = m_objects[r].ptr();

    char buf[32];
    
    sprintf(buf, "material_%u", r);

    elem->m_materialName = buf;

    return r;
  }

}
