/* -*- C++ -*- */

/* -*- C++ -*- */

/* -*- C++ -*- */

/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Crystal animation and 3D modeling application
 *
 * Authors:   Tommi Ilmonen 2001-2004
 * Copyright: Tommi Ilmonen and/or Tekes 2001-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef CRYSTAL_SOLID_EDITOR_H
#define CRYSTAL_SOLID_EDITOR_H

#include <crystal_editor.h>
#include <crystal_widget.h>

#include <Fluid/MessageSink.hpp>

#include <Solar/GlMaterial.hpp>
#include <Solar/Model.hpp>

namespace Crystal { 

  class GlData;
  class Tools;

  class SolidEditor : public Editor,
		      public Fluid::MessageSink
  {
  public:
    
    class Element 
    {
    public:
      Element();

      Solar::Model m_model;
      int          m_texture;
      VEE_Hsva     m_hsva;
      VEE_Rgba     m_rgba;

      Solar::GlMaterial m_material;
      std::string       m_materialName;
    };

    SolidEditor(Tools *);
    virtual ~SolidEditor();

    virtual bool msgProcess(const char *id, Fluid::Message *);

    void render(GlData *);

    void update();
    void handleEvent(const InEvent *e) { m_widgets.handleEvent(e); }

    Tools *host() { return m_host; }

    virtual QDomElement writeDom(QDomDocument &doc);
    virtual bool readDom(QDomElement &elem);

    bool selectObject(uint);
    bool selectTexture(uint);

    uint expandOne();

  protected:


    Tools      *m_host;
    Widgets     m_widgets;

    Element    *m_current;

    std::vector<VEE_RefPtr<Element> > m_objects;

    int         m_selected;

  };

}

#endif
