/* -*- C++ -*- */

/* -*- C++ -*- */

/* -*- C++ -*- */

/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Crystal animation and 3D modeling application
 *
 * Authors:   Tommi Ilmonen 2001-2004
 * Copyright: Tommi Ilmonen and/or Tekes 2001-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef CRYSTAL_TIMING_H
#define CRYSTAL_TIMING_H

#include <Fluid/TimeStamp.hpp>

namespace Crystal { 

  class Timing
  {
  public:
    Timing() 
      : m_zeroTime(0), m_offset(0), m_playSpeed(1.0), m_playSpeed2(1.0), m_time(0.0) {}

    Fluid::TimeStamp realTimeToRecordTime(const Fluid::TimeStamp & t) const
    {
      Fluid::TimeStamp r = t > m_zeroTime ? (t - m_zeroTime) : 0;
      r *= m_playSpeed2;
      return r + m_offset;
    }

    Fluid::TimeStamp currentTimeToRecordTime() const
    { return realTimeToRecordTime(m_now); }

    void setRunning(bool run) { m_playSpeed2 = run ? m_playSpeed : 0.0; }
    void updateTime() { m_time = currentTimeToRecordTime().secondsD(); }

    Fluid::TimeStamp   m_now;
    Fluid::TimeStamp   m_zeroTime;
    Fluid::TimeStamp   m_offset;
    double             m_playSpeed;
    double             m_playSpeed2;
    double             m_time;
  };

}

#endif
