/* -*- C++ -*- */

/* -*- C++ -*- */

/* -*- C++ -*- */

/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Crystal animation and 3D modeling application
 *
 * Authors:   Tommi Ilmonen 2001-2004
 * Copyright: Tommi Ilmonen and/or Tekes 2001-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef CRYSTAL_TRANSFORMATION_H
#define CRYSTAL_TRANSFORMATION_H

#include <Fluid/Matrix3.hpp>

#include <crystal.h>

namespace Crystal { 

  /** This is the hierarchical transformation-graph. Excellent ! */

  class Transformation
  {
  public:
    Transformation(Transformation * host = 0);
    virtual ~Transformation();

    void setHostTransformation(Transformation * host)  { m_host = host; }
    Transformation * hostTransformation() { return m_host; }
    void setTransformation(const Transformation &that) { *this = that; }

    void setLocation(const Vector3 & loc) { m_location = loc; }
    void setLocation(float x, float y, float z) { m_location.make(x, y, z); }
    void setRotation(const Matrix3 & rot) { m_rotation = rot; }
    void setScale(float scale) { m_scale = scale; }

    const Matrix3 & rotation() const { return m_rotation; }
    const Vector3 & location() const { return m_location; }
    float scale() { return m_scale; }

    Matrix3 worldRotation() const;
    Matrix3 worldRotation(const Matrix3 &) const;

    Vector3 worldLocation() const;
    Vector3 worldLocation(const Vector3 &) const;

    Vector3 applyMyTransform(const Vector3 &) const;
    Vector3 unapplyMyTransform(const Vector3 &) const;

    Matrix3 applyMyTransform(const Matrix3 &) const;
    Matrix3 unapplyMyTransform(const Matrix3 &) const;

    float totalScale() const;

  protected:

    Matrix3 m_rotation;
    Vector3 m_location;
    float   m_scale;
    Transformation * m_host;
  };

}


#endif
