/* -*- C++ -*- */

/* -*- C++ -*- */

/* -*- C++ -*- */

/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Crystal animation and 3D modeling application
 *
 * Authors:   Tommi Ilmonen 2001-2004
 * Copyright: Tommi Ilmonen and/or Tekes 2001-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef CRYSTAL_VALUE_ACTION_H
#define CRYSTAL_VALUE_ACTION_H

#include <crystal_action.h>

#include <string>

#include <Fluid/Matrix3.hpp>

class VEE_Value;

namespace Crystal { 

  /** Gives an arbitrary message to a VEE_Object. */
  class ValueAction : public Action
  {
  public:
    ValueAction() : m_objId(-1), m_msg(0) {}

    ValueAction(const ValueAction &);

    ValueAction(int objId, 
			const std::string &msgId,
			VEE_Value *msg,
			const Fluid::TimeStamp &)
      : m_objId(objId), m_msgId(msgId), m_msg(msg) {}

    ValueAction(int obj, 
			const std::string &msgId,
			float v,
			const Fluid::TimeStamp &);

    ValueAction(int obj, 
			const std::string &msgId,
			int v,
			const Fluid::TimeStamp &);

    ValueAction(int obj, 
			const std::string &msgId,
			const Fluid::Vector3 & v,
			const Fluid::TimeStamp &);

    ValueAction(int obj, 
			const std::string &msgId,
			const Fluid::Matrix3 & m,
			const Fluid::TimeStamp &ts);

    virtual ~ValueAction();

    virtual void act(ActionList *);

    void setValue(VEE_Value *m);

    ValueAction & operator = (const ValueAction &);

  protected:
    int m_objId;

    std::string  m_msgId;
    VEE_Value  *m_msg;

  };

}

#endif
