/* -*- C++ -*- */

/* -*- C++ -*- */

/* -*- C++ -*- */

/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Crystal animation and 3D modeling application
 *
 * Authors:   Tommi Ilmonen 2001-2004
 * Copyright: Tommi Ilmonen and/or Tekes 2001-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef CRYSTAL_VALUE_GRAPHS_H
#define CRYSTAL_VALUE_GRAPHS_H

#include <crystal_value_graph.h>

#include <vee_reference_object.h>

#include <map>
#include <string>

namespace Crystal { 

  class ValueGraphs
  {
  public:
    enum TargetType {
      PARTICLE,
      MODEL
    };


    typedef std::map<std::string, VEE_RefPtr<ValueGraphBase> > Graphs;

    typedef Graphs::iterator iterator;

    ValueGraphs(TargetType type = PARTICLE);
    ~ValueGraphs();

    static ValueGraphBase * create(const char * type);

    void appendFloat(const std::string &, double t, float v);
    void appendVector3(const std::string &, double t, const Fluid::Vector3 &);
    void appendMatrix3(const std::string &, double t, const Fluid::Matrix3 &);

    void deleteAll();

    void transmitValues(VEE_HasValues *, double t);

    QDomElement writeDom(QDomDocument &doc);
    bool readDom(QDomElement &elem);

    void moveTime(double offset);
  
    ValueGraphBase * findGraph(const std::string &);
    Graphs & graphs() { return m_graphs; }

    void setTargetType(TargetType t) { m_targetType = t; }
    TargetType targetType() const { return m_targetType; }

  protected:
    TargetType m_targetType;
    Graphs m_graphs;
    
  };

}

#endif
