/* -*- C++ -*- */

/* -*- C++ -*- */

/* -*- C++ -*- */

/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Crystal animation and 3D modeling application
 *
 * Authors:   Tommi Ilmonen 2001-2004
 * Copyright: Tommi Ilmonen and/or Tekes 2001-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef CRYSTAL_VISUALIZE_LOCATION_H
#define CRYSTAL_VISUALIZE_LOCATION_H

#include <crystal.h>
#include <crystal_ui_handler.h>
#include <crystal_visualize.h>

#include <string>

#include <vee_color.h>

#include <Fluid/Vector3.hpp>


namespace Crystal { 

  class VisualizeLocation : public Visualize,
			    public UiHandler
  {
  public:
    VisualizeLocation();
    virtual ~VisualizeLocation();
  
    // From UiHandler:
    virtual void handleInput();
    virtual void update();
    virtual void render(GlData *glData);
    virtual void start();
    virtual void stop();

    // From Visualize:
    virtual void visualize(ActionList *, GlData *);

    virtual QDomElement writeDom(QDomDocument &doc);
    virtual bool readDom(QDomElement &elem);

    void set(int object, const std::string &param)
    { m_objectId = object; m_parameterName = param; }

  protected:
    int         m_objectId;
    std::string m_parameterName;
    VEE_Rgba    m_color, m_color2;
    long        m_samples;
    long        m_mouseSamples;
    int         m_selection;
    int         m_nextSelection;
    int         m_radius;
    bool        m_onDrag;
    Vector3     m_prevLoc;
  };

}

#endif
