/* -*- C++ -*- */

/* -*- C++ -*- */

/* -*- C++ -*- */

/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Crystal animation and 3D modeling application
 *
 * Authors:   Tommi Ilmonen 2001-2004
 * Copyright: Tommi Ilmonen and/or Tekes 2001-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef CRYSTAL_VISUALIZE_PARTICLES_H
#define CRYSTAL_VISUALIZE_PARTICLES_H

#include <crystal.h>
#include <crystal_ui_handler.h>
#include <crystal_visualize.h>

#include <Fluid/Vector3.hpp>

namespace Crystal { 

  class VisualizeParticles : public Visualize,
			     public UiHandler
  {
  public:
    VisualizeParticles();
    virtual ~VisualizeParticles();
  
    // From UiHandler:
    virtual void handleInput();
    virtual void update();
    virtual void render(GlData *glData);
    virtual void start();
    virtual void stop();

    // From Visualize:
    virtual void visualize(ActionList *, GlData *);

    virtual QDomElement writeDom(QDomDocument &doc);
    virtual bool readDom(QDomElement &elem);
  protected:

    void move(Vector3 direction, Vector3 location, float radius);

    long        m_samples;
    long        m_mouseSamples;
    float       m_radius;
    bool        m_onDrag;
    Vector3     m_prevLoc;

  };
}

#endif
