/* -*- C++ -*- */

/* -*- C++ -*- */

/* -*- C++ -*- */

/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Crystal animation and 3D modeling application
 *
 * Authors:   Tommi Ilmonen 2001-2004
 * Copyright: Tommi Ilmonen and/or Tekes 2001-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef CRYSTAL_SWIRL_RECORDER_H
#define CRYSTAL_SWIRL_RECORDER_H

#include <crystal_action.h>
#include <crystal_recorder.h>

#include <Fluid/Matrix3.hpp>

namespace Crystal { 

  class VortexRecorder : public Recorder
  {
  public:
    VortexRecorder(bool motion = true);
    virtual ~VortexRecorder();

    virtual void prepare(ActionList *);

    virtual void beginRecording(ActionList *, 
				const Fluid::TimeStamp &);

    virtual void endRecording(ActionList *, 
			      const Fluid::TimeStamp &);

    virtual void record(ActionList *, const Fluid::TimeStamp &);

    virtual void render(Engine *, GlData *);
  protected:
    bool m_motion;
    int  m_vortexId;
    long m_trackerCount;
    long m_gloveCount;

    float m_range;
    float m_magnitude;
    Vector3 m_location;
    Vector3 m_axes;
  };

  /** Creates a vortex-object to the action list.  */

  class CreateVortexAction : public Action
  {
  public:
    CreateVortexAction() : m_id(-1) { m_location.clear(); }
    CreateVortexAction(int id,
		      const Fluid::Vector3 &location, 
		      const Fluid::TimeStamp &ts)
      : Action(ts), m_location(location), m_id(id) {}

    virtual ~CreateVortexAction();
  
    virtual void act(ActionList *al);
    virtual QDomElement writeDom(QDomDocument &doc);
    virtual bool readDom(QDomElement &elem);
  protected:

    Fluid::Vector3 m_location;
    int m_id;
  };

}
#endif
