/* -*- C++ -*- */

/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Crystal animation and 3D modeling application
 *
 * Authors:   Tommi Ilmonen 2001-2004
 * Copyright: Tommi Ilmonen and/or Tekes 2001-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef CRYSTAL_VRSMUGGLER_H
#define CRYSTAL_VRSMUGGLER_H

#include <VrSmuggler.hpp>

#include <vee_time.h>

#include <di_thread_data.h>

#include <ConfigReader.hpp>

class VEE_GlRenderer;

namespace Crystal { 
  
  class Engine;
  class GlData;

  class VrSmuggler : public VRS_FluidGlApp
  {
  public:

    VrSmuggler(Engine *engine);
    virtual ~VrSmuggler();
  
    virtual void init();

    void loadConfig(const char * filename);

  protected:

    virtual void contextInit(VRS_Window * context);
    virtual void draw(VRS_Window * context, int );
    virtual void preFrame();

    typedef std::map<uint, GlData *> container;
    
    container  m_glData;

    GlData    *m_sampleGl;  
    
    Engine    *m_engine;

    uint       m_frameCount;
    uint       m_lastFrameCount;
    VEE_Time   m_lastFrameTime;
    VEE_Time   m_lastFrameEnd;

    long        m_updateUSCount;
    long        m_renderUSCount;
    long        m_displayListCount;
    
    ConfigReader::Config m_config;
    FILE        *m_statistics;
  };

}

#endif

