/* -*- C++ -*- */

/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Crystal animation and 3D modeling application
 *
 * Authors:   Tommi Ilmonen 2001-2004
 * Copyright: Tommi Ilmonen and/or Tekes 2001-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef CRYSTAL_Q_MAIN_H
#define CRYSTAL_Q_MAIN_H

#include <vee_qt.h>

#include <crystal_gl_data.h>


namespace Crystal { 
  
  class Engine;
  class GlData;

}
class CRYSTAL_QSettings;

class VEE_RManRenderer;

class QPopupMenu;

class CRYSTAL_QMain : public VEE_QtHidden
{
  Q_OBJECT
public:
  CRYSTAL_QMain(VEE_Qt * host,
		Crystal::Engine *,
		QWidget * parent = 0,
		const char * name = 0);

  virtual ~CRYSTAL_QMain();

  virtual void initializeGL();

  virtual void reFresh();

  void setConfigFile(const QString &file) { m_configFile = file; }

public slots:

  void play();
  void record();
  void stop();

  void showSettings();
  void headTrack();
  void extraSleep();

protected:

  virtual void veeRender(bool clear = true);

  void renderRibFrame();

  void nextRibSegment();
  void beginRibSegment();
  void finalizeRibSegment();

  Crystal::GlData  m_glData;
  Crystal::Engine *m_engine;

  CRYSTAL_QSettings *m_settings;

  int m_ribFrame;
  int m_ribFramesPerSegment;
  /// The index of RIB file segment
  int m_ribIndex;
  /// The name of the current RIB file
  QString m_ribName;
  QString m_ribBase;
  QString m_frameBase;
  QString m_configFile;
  int m_frameWidth, m_frameHeight;
  float m_extraSleep;

#ifdef VEE_WITH_RENDERMAN
  VEE_RManRenderer *m_rmanRenderer;
#endif

  QPopupMenu *m_controls;
  int m_playId, m_recordId, m_stopId;
  bool m_headTrack;
};

#endif
