/* -*- C++ -*- */

/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Crystal animation and 3D modeling application
 *
 * Authors:   Tommi Ilmonen 2001-2004
 * Copyright: Tommi Ilmonen and/or Tekes 2001-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef CRYSTAL_Q_SETTINGS_H
#define CRYSTAL_Q_SETTINGS_H

#include <qwidget.h>

class CRYSTAL_QSettings : public QWidget
{
  Q_OBJECT
public:
  CRYSTAL_QSettings(QWidget * parent = 0,
		    const char * name = 0);
  virtual ~CRYSTAL_QSettings();

  double getFrameRate() { return m_frameRate; }
  
public slots:

  void setFrameFileName(const QString &);
  void getFrameFileName(QString *s) { *s = m_frameName; }

  void setRibFileName(const QString &);
  void getRibFileName(QString *s) { *s = m_ribName; }

  void setFramesPerFile(int);
  void getFramesPerFile(int *i) { *i = m_framesPerFile; }

  void setFrameRate(double);
  void getFrameRate(double *d) { *d = m_frameRate; }
  
protected:
  QString m_frameName;
  QString m_ribName;
  int m_framesPerFile;
  double m_frameRate;

};

#endif
