/* -*- C++ -*- */

/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Crystal animation and 3D modeling application
 *
 * Authors:   Tommi Ilmonen 2001-2004
 * Copyright: Tommi Ilmonen and/or Tekes 2001-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef CRYSTAL_VRJUGGLER_H
#define CRYSTAL_VRJUGGLER_H

#include <Kernel/GL/vjGlApp.h>
#include <Kernel/GL/vjGlContextData.h>

#include <Input/InputManager/vjPosInterface.h>
#include <Input/InputManager/vjAnalogInterface.h>
#include <Input/InputManager/vjDigitalInterface.h>

#include <vee_time.h>

#include <di_thread_data.h>

#include <ConfigReader.hpp>

class VEE_GlRenderer;

namespace Crystal { 
  
  class Engine;
  class GlData;

  class VrJuggler : public vjGlApp
  {
  public:

    VrJuggler(Engine *engine);
    virtual ~VrJuggler();
  
    virtual void init();

    virtual void apiInit();

    virtual void preFrame();
    virtual void intraFrame();
    virtual void postFrame();
    virtual void contextInit();
    virtual void draw();

    void loadConfig(const char * filename);

  protected:


    // DI_ThreadData<GlData *>    m_glData; 
    vjGlContextData<GlData *>  m_glData; 
    GlData                    *m_sampleGl;  
    
    Engine *m_engine;

    std::string  m_imagePath;
    std::string  m_pyramidTextureName;

    uint         m_frameCount;
    uint         m_lastFrameCount;
    VEE_Time     m_lastFrameTime;
    VEE_Time     m_lastFrameEnd;

    long        m_updateUSCount;
    long        m_renderUSCount;
    long        m_displayListCount;

    ConfigReader::Config m_config;
    FILE        *m_statistics;
  };

}

#endif

