/* COPYRIGHT
 *
 * This file is part of FLUID
 *
 * Author: Tommi Ilmonen, Janne Kontkanen 1999-2002.
 * Tommi.Ilmonen@hut.fi, Janne.Kontkanen@hut.fi
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. 
 *    
 */

#include "Fluid/DataSource.hpp"
#include "Fluid/Mouse.hpp"

namespace Fluid
{

  /**@func Fluid::DataSource<Sample>::DataSource(int bufferSize)
   * Constructs a data source.
   * 
   * Data source is constructed with given bufferSize. BufferSize
   * determines how frequently data source must be read to avoid
   * buffer input data flooding
   *
   * @param bufferSize = size of the internal buffer in samples
   */

  /**@func void Fluid::StreamDataSource::get(Sample& s) = 0
   * Reads one sample from data source.
   *
   * This is the only abstract function that a class must
   * implement to be a functional StreamDataSource. When 
   * the stream data source is started by function start(),
   * it begins calling this function (get()) continuosly to
   * fetch the data from the source.
   *
   * Note that get() is expected to block until new sample is
   * available.
   *
   * @param s = the resulting sample
   *
   */

}
