/* COPYRIGHT
 *
 * This file is part of FLUID
 *
 * Author: Tommi Ilmonen, Janne Kontkanen 1999-2002.
 * Tommi.Ilmonen@hut.fi, Janne.Kontkanen@hut.fi
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. 
 *    
 */

#ifndef FLUID_DEBUG_HPP
#define FLUID_DEBUG_HPP

#include <iostream>

/**
 * Log stream - by default this is redirected into log file 
 *
 * All the non critical information printed out by the Input 
 * Library is output into this stream.
 */
extern std::ostream & logStream;

/**
 * Error stream - by default this is redirected to user's
 * console (std::cerr)
 *
 * All the errors that are detected by Input Library 
 * are reported by outputting into this stream
 */
extern std::ostream & errStream;

#endif
