/* COPYRIGHT
 *
 * This file is part of FLUID
 *
 * Author: Tommi Ilmonen, Janne Kontkanen 1999-2002.
 * Tommi.Ilmonen@hut.fi, Janne.Kontkanen@hut.fi
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. 
 *    
 */

#ifndef FLUID_DIRECTORY_HPP
#define FLUID_DIRECTORY_HPP

#include <string>

struct dirent;

namespace Fluid
{

/**
 * Class for reading filenames in a directory. This exists because
 * there exists no portable way to read directories (which is sad)
 */
  
class Directory
{
public:
              Directory(const std::string& pathname);
              ~Directory();
  int         getFileCount() const;
  std::string getFileName(int n) const;
private:
  struct dirent **namelist;
  int n;
};

} // namespace

#endif
