/* COPYRIGHT
 *
 * This file is part of FLUID
 *
 * Author: Tommi Ilmonen, Janne Kontkanen 1999-2002.
 * Tommi.Ilmonen@hut.fi, Janne.Kontkanen@hut.fi
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. 
 *    
 */

/*
Tavoitteita:
1) Playback nytt identtiselt alkuperiseen inputtiin verrattuna
  (ohjelman suoritus voi kuitenkin menn eri tavalla, jos pohjelma
   suoritetaan eritehoisessa koneessa)

Ongelmia dumppauksessa:

-Miss vliss mritelln halutaanko dumpata tiedostoon?
 v: konfiguraatiotiedostossa dumpFile="tiedosto" 

-Miss vliss datasink konstruoidaan?
 -> kuuluuko datasink deviceen vai datasourceen?
 -> Tavoite1 -> data-sourceen
 -> konstruoidaan data sourcen konstruktorissa

-Milloin datasink tuhotaan?
 (thn voi liitty flushaus joten tm on trke)
 -> kun datasource tuhotaan, eli?
 -> ongelmallista on tietysti suuren puskurin kanssa,
    kun dataa j kirjoittamatta

Ongelmia playbackissa:

-jos data on talletettu muodossa startupStamp,timestamp1,sample1,timestamp2,sample2
 -> 
-Config::init() tallettaa startupStampin

-Millainen device tmmist osaa tunkea sisn?
 JATKAPA TST?

*/

#include <string>
#include <di_mutex.h>
#include <di_condition.h>
#include <di_data_buffer.h>
#include <stdio.h>

template <class Sample>
class DumpFile
{
public:
  DumpFile(const std::string& fname)
    :fp(0),fname(fname)
  {
  }

  ~DumpFile()
  {
    if(fp) fclose(fp);
  }

  /*
    
  */

  void open()
  {
    fp = fopen(fname.c_str(),"wb");
  }

  void write(long long timeStamp, const Sample& s)
  {
    if(!fp) open();
    
    if(!fp) return;
    
    buffer.rewind();
    buffer.writeInt64(timeStamp);
    s.write(buffer);
    buffer.write(fp, true);

    // 12 = maximum that "size" and timestamp might take if padded
    /* unsigned int sz = s.getMaxSerializedSize() + 16; 
    if(sz > buffer.size()) buffer.resize(sz);
    buffer.rewind();
    buffer.writeInt64(timeStamp);
    s.write(buffer); // in future this is done by worker thread
    int tmp = buffer.positionLE();
    fwrite(&tmp, 4, 1, fp);
    fwrite(buffer.buffer(), buffer.position(), 1, fp);
    fflush(fp);
    */
  }

private:
  FILE *fp;
  DI_DataBuffer2 buffer;
  std::string fname;
};
