/* COPYRIGHT
 *
 * This file is part of FLUID
 *
 * Author: Tommi Ilmonen, Janne Kontkanen 1999-2002.
 * Tommi.Ilmonen@hut.fi, Janne.Kontkanen@hut.fi
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. 
 *    
 */

#include <Fluid/Exec.hpp>

#include <sys/types.h>
#include <stdlib.h>
#include <unistd.h>

namespace Fluid
{
  /** Executes a command (or script) in parallel within a
      sub-thread. In UNIX this call forks a new process. */

  void ExecuteParallel(const char *script)
  {
    pid_t pid = fork();
    
    if(pid == 0) {
      // child process
      system(script);
      // sleep(5);
      exit(0);
    }
  }

}
