/* COPYRIGHT
 *
 * This file is part of FLUID
 *
 * Author: Tommi Ilmonen, Janne Kontkanen 1999-2002.
 * Tommi.Ilmonen@hut.fi, Janne.Kontkanen@hut.fi
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. 
 *    
 */

#ifndef FLUID_FLUID_HPP
#define FLUID_FLUID_HPP

/** @file Fluid.hpp
    
    Global definitions for Fluid. At the moment this header only
    includes version information and macros
*/

/** Fluid version. The version number is a four-byte integer that is
    packed as follows: 0MIS, whewre "M" is the major release, "I" is
    the minor release and "S" is the subminor release. 
    
    For example version 1.4.9 would be 0x010409.
*/

#define FLUID_VERSION 0x000200

#define FLUID_VERSION_MAJOR(v)     (v >> 16) & 0xFF
#define FLUID_VERSION_MINOR(v)     (v >> 8)  & 0xFF
#define FLUID_VERSION_SUBMINOR(v)  v & 0xFF

#endif
