/* COPYRIGHT
 *
 * This file is part of FLUID
 *
 * Author: Tommi Ilmonen, Janne Kontkanen 1999-2002.
 * Tommi.Ilmonen@hut.fi, Janne.Kontkanen@hut.fi
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. 
 *    
 */

#include <Fluid/Mutex.hpp>
#include <di_mutex.h>

namespace Fluid
{
  
Mutex::Mutex()
{
  mutex = new DI_MutexAuto();
}
Mutex::~Mutex()
{
  delete mutex;
}

void Mutex::lock()
{
  mutex->lock();
}

void Mutex::unlock()
{
  mutex->unlock();
}

} // namespace
