/* COPYRIGHT
 *
 * This file is part of FLUID
 *
 * Author: Tommi Ilmonen, 1999-2001.
 * Tommi.Ilmonen@hut.fi
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. 
 *    
 */

#include <Fluid/Speech.hpp>

#include <mj_ringbuffertmpl.h>


namespace Fluid {

  Phrase::Phrase()
  {}

  Phrase::~Phrase()
  {}

  void Phrase::read(DI_DataBuffer2 &buffer)
  {
    time = buffer.readInt64();
    buffer.readString(&phrase);
  }
  
  void Phrase::write(DI_DataBuffer2 &buffer) const
  {
    buffer.writeInt64(time.stamp());
    buffer.writeString(&phrase);
  }

  Speech::~Speech() 
  {}
  
  std::string Speech::getClassName() const
  {
    return "Speech";
  }

}

template class MJ_RingBuffer<Fluid::Phrase>;
