/* COPYRIGHT
 *
 * This file is part of the Geometry Engine - GEE
 *
 * Read the "GEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen 2003
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef _BGL_PROJECTIONS_HPP_
#define _BGL_PROJECTIONS_HPP_

#include <CaveProj.hpp>

/** A class that pushes projection matrices to BGL renderers. Also
    takes care of BGL window management. */

class BglProjections
{
public:

  class RendererInfo 
  {
  public:
    RendererInfo() {}
    ~RendererInfo() {}

    std::string m_wallName;
    int         m_id;
    int         m_wall;
    int         m_eye;
  };

  BglProjections();
  ~BglProjections();

  bool init(const char * caveProjFile,
	    const char * bglConfigFile);

  void setProjectionMatrices();

  CaveProj::Cave & cave() {return m_cave; }

  const std::string & address() { return m_address; }

protected:

  CaveProj::Cave m_cave;
  
  std::vector<RendererInfo> m_renderers;

  std::string m_address;
};

#endif
