/* COPYRIGHT
 *
 * This file is part of FLUID
 *
 * Author: Tommi Ilmonen, 1999-2001.
 * Tommi.Ilmonen@hut.fi
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. 
 *    
 */

#ifndef FLUID_CMATRIX3_H
#define FLUID_CMATRIX3_H

#include <Fluid/CVector3.h>

#ifdef __cplusplus
extern "C" {
#endif

typedef struct __FLUID_CMatrix3
{
  float m[3][3];
} FLUID_CMatrix3;

FLUID_CMatrix3 FLUID_CMatrix3_multiplyMM(const FLUID_CMatrix3 *,
					const FLUID_CMatrix3 *);

FLUID_CVector3 FLUID_CMatrix3_multiplyMV(const FLUID_CMatrix3 *,
					const FLUID_CVector3 *);

void FLUID_CMatrix3_transpose(FLUID_CMatrix3 *);
void FLUID_CMatrix3_clear(FLUID_CMatrix3 *);
void FLUID_CMatrix3_identity(FLUID_CMatrix3 *);
void FLUID_CMatrix3_printf(const FLUID_CMatrix3 *, FILE *);

#ifdef __cplusplus
}
#endif

#endif  /* FLUID_CMATRIX3_H */
