/* COPYRIGHT
 *
 * This file is part of FLUID
 *
 * Author: Tommi Ilmonen, 1999-2001.
 * Tommi.Ilmonen@hut.fi
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. 
 *    
 */

#include <Fluid/CTracker.h>

#include <Fluid/Tracker.hpp>

using namespace Fluid;

int FLUID_CTrackerSample_getSensorCount(const FLUID_CTrackerSample *s)
{
  return ((TrackerSample *) s)->getSensorCount();
}

const FLUID_CMatrix3 *FLUID_CTrackerSample_getRotation
(const FLUID_CTrackerSample *s, int i)
{
  return (const FLUID_CMatrix3 *) 
    & ((TrackerSample *) s)->getRotation(i);
}

const FLUID_CVector3 *FLUID_CTrackerSample_getLocation
(const FLUID_CTrackerSample *s, int i)
{
  return (const FLUID_CVector3 *) 
    & ((TrackerSample *) s)->getLocation(i);
}

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////

int FLUID_CTracker_findSensor(FLUID_CTracker *t, const char *s)
{
  return ((Tracker *) t)->findSensor(s ? s : "");
}

int FLUID_CTracker_getSensorCount(const FLUID_CTracker *t)
{
  return ((Tracker *) t)->getSensorCount();
}

long FLUID_CTracker_getLatestIndex(const FLUID_CTracker *t)
{
  return ((Tracker *) t)->getLatestIndex();
}

FLUID_CTrackerSample *FLUID_CTracker_getSample(const FLUID_CTracker *t, int i)
{
  return (FLUID_CTrackerSample *) & ((Tracker *) t)->getSample(i);
}

FLUID_CTrackerSample *FLUID_CTracker_getLatestSample(const FLUID_CTracker *t)
{
  return (FLUID_CTrackerSample *) & ((Tracker *) t)->getLatestSample();
}
