/* COPYRIGHT
 *
 * This file is part of FLUID
 *
 * Author: Tommi Ilmonen, 1999-2001.
 * Tommi.Ilmonen@hut.fi
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. 
 *    
 */

#ifndef FLUID_CTRACKER_H
#define FLUID_CTRACKER_H

#include <Fluid/CMatrix3.h>

#ifdef __cplusplus
extern "C" {
#endif

typedef struct __FLUID_CTrackerSample FLUID_CTrackerSample;

int FLUID_CTrackerSample_getSensorCount(const FLUID_CTrackerSample *);

const FLUID_CMatrix3 *FLUID_CTrackerSample_getRotation
(const FLUID_CTrackerSample *, int);

const FLUID_CVector3 *FLUID_CTrackerSample_getLocation
(const FLUID_CTrackerSample *, int);
  
typedef struct __FLUID_CTracker FLUID_CTracker;

int FLUID_CTracker_findSensor(FLUID_CTracker *, const char *);
int FLUID_CTracker_getSensorCount(const FLUID_CTracker *);
long FLUID_CTracker_getLatestIndex(const FLUID_CTracker *);
FLUID_CTrackerSample *FLUID_CTracker_getSample(const FLUID_CTracker *, int);
FLUID_CTrackerSample *FLUID_CTracker_getLatestSample(const FLUID_CTracker *);

#ifdef __cplusplus
}
#endif

#endif /* FLUID_CTRACKER_H */ 
