/* COPYRIGHT
 *
 * This file is part of FLUID
 *
 * Author: Tommi Ilmonen, 1999-2001.
 * Tommi.Ilmonen@hut.fi
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. 
 *    
 */

#include <Fluid/CVector3.h>

#include <Fluid/Vector3.hpp>

using namespace Fluid;

/// Add v2 and v1
FLUID_CVector3 FLUID_CVector3_add(const FLUID_CVector3 *v1,
				  const FLUID_CVector3 *v2)
{
  const Vector3 *fm1 = (const Vector3 *) v1;
  const Vector3 *fm2 = (const Vector3 *) v2;

  Vector3 r((*fm1) + (*fm2));

  return * (FLUID_CVector3 *) &r;
}

/// Subtract v2 from v1
FLUID_CVector3 FLUID_CVector3_sub(const FLUID_CVector3 *v1,
				  const FLUID_CVector3 *v2)
{
  const Vector3 *fm1 = (const Vector3 *) v1;
  const Vector3 *fm2 = (const Vector3 *) v2;

  Vector3 r((*fm1) - (*fm2));

  return * (FLUID_CVector3 *) &r;
}

void FLUID_CVector3_printf(const FLUID_CVector3 *v, FILE *f)
{
  fprintf(f, "[%4.4f   %4.4f   %4.4f]", v->v[0], v->v[1], v->v[2]);  
}
