#!/bin/sh

export SYSTEMTYPE=`uname -s`

if test $SYSTEMTYPE = Linux  ; then
  export PLATFORM=Linux-`uname -m`
  export CONFBASE=Linux
fi

if test $SYSTEMTYPE = IRIX64  ; then
  SYSTEMTYPE=IRIX
fi

if test $SYSTEMTYPE = Linux  ; then
  export PLATFORM=Linux-`uname -m`
  export CONFBASE=Linux
fi

if test $SYSTEMTYPE = FreeBSD  ; then
  export PLATFORM=FreeBSD-`uname -m`
  export CONFBASE=Linux
fi

if test $SYSTEMTYPE = IRIX  ; then
  export PLATFORM=IRIX
  export CONFBASE=IRIX-CC
fi

echo "Platform set to $PLATFORM"

if test ! -e $PLATFORM; then
    mkdir $PLATFORM
    echo "Created $PLATFORM"
fi 

cd $PLATFORM
ln -sf ../$CONFBASE/Make* .
cd ..

if test ! -e ../include; then
    mkdir ../include
    echo "Created ../include"
fi

if test ! -e ../include/Fluid; then
    mkdir ../include/Fluid
    echo "Created ../include/Fluid"
fi

#if test ! -e ../include/$PLATFORM; then
#    mkdir ../include/$PLATFORM
#    echo "Created ../include/$PLATFORM"
#fi 

if test ! -e ../lib; then
    mkdir ../lib
    echo "Created ../lib"
fi

if test ! -e ../lib/$PLATFORM; then
    mkdir ../lib/$PLATFORM
    echo "Created ../lib/$PLATFORM"
fi

if test ! -e ../plugins; then
    mkdir ../plugins
    echo "Created ../plugins"
fi

if test ! -e ../plugins/$PLATFORM; then
    mkdir ../plugins/$PLATFORM
    echo "Created ../plugins/$PLATFORM"
fi

if test ! -e ../bin; then
    mkdir ../bin
    echo "Created ../bin"
fi

if test ! -e divabase/$PLATFORM; then
    mkdir divabase/$PLATFORM
    echo "Created divabase/$PLATFORM"
fi

if test -e config.cache; then
  echo "Removing old config.cache"
  rm -rf config.cache
fi

echo ""
echo "  You can now configure FLUID with:"
echo ""
echo "  ./configure"
echo ""
