/* COPYRIGHT
 *
 * This file is part of FLUID
 *
 * Author: Tommi Ilmonen, 1999-2001.
 * Tommi.Ilmonen@hut.fi
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. 
 *    
 */

#ifndef _SERIAL5DT_HPP
#define _SERIAL5DT_HPP

#include <string>


class Serial5DT
{
public:

  enum Commands {
    RESET = 0x41,
    TEST_SERIAL_IO = 0x42,
    SET_REPORT_DATA = 0x43,
    SET_DATA_STREAM_MODE = 0x44,
    REQUEST_GLOVE_INFORMATION = 0x47,
  };
  
  enum Results {
    RECEIVED = 0x55
  };

  Serial5DT();
  ~Serial5DT();
  
  bool init(const char * device = "/dev/fglove");

  bool shutdown();
  bool reset();
  void flexures(float * data);
  bool isRightHanded() const { return m_rightHanded; }
  int sensorCount() const { return m_sensorCount; }

protected:

  int m_fd;
  int m_times;
  int m_sensorCount;
  bool m_rightHanded;
  bool m_autoCalibrate;

  unsigned char m_min[5], m_max[5];

  std::string m_gloveId;
};



#endif
