
#include <WL/MostarPack.h>

wlMostarPack::wlMostarPack()
{
    sequence = 0;
    time = 0;
    milleseconds = 0;
    num_records = 0;
}

wlMostarPack::wlMostarPack(PacketHeader& hdr, unsigned char* raw)
{
    sequence = hdr.Sequence();
    time = hdr.Time();
    milleseconds = Milleseconds();

    num_records = 0;
    int n = hdr.NumDataBytes();
    int idx = 0;
    while (idx < n)
    {
	int sz = wlMostarRec::RawRecordSize(&raw[idx]);
	records[num_records++].FromRaw(&raw[idx]);
	idx += sz;
    }
}

void
wlMostarPack::FromRaw(PacketHeader& hdr, unsigned char* raw)
{
    sequence = hdr.Sequence();
    time = hdr.Time();
    milleseconds = Milleseconds();

    num_records = 0;
    int n = hdr.NumDataBytes();
    int idx = 0;
    while (idx < n)
    {
	int sz = wlMostarRec::RawRecordSize(&raw[idx]);
	records[num_records++].FromRaw(&raw[idx]);
	idx += sz;
    }
}

int
wlMostarPack::GetRecord(int which, wlMostarRec& record)
{
    if (which < 0 || which >= num_records)
	return 0;

    record = records[which];

    return 1;
}


