/* -*- C++ -*- */

#ifndef __MOSTARREC_H__
#define __MOSTARREC_H__

#include <WL/MostarDefs.h>

///
class wlMostarRec : public wlMostarDefs
{
  int			fbb_addr;
  int			btn_flag;
  int			data_size;
  int			data_fmt;
  int			good_data;

  unsigned char	data[24];
  unsigned char	btn_data[2];

public:			
  /// 
  wlMostarRec();
  /// Get data from raw data
  wlMostarRec(unsigned char* raw);
  /// Get data from raw data
  void		FromRaw(unsigned char* raw);
  
  int			FBBAddress() { return fbb_addr; }
  ///
  int			ButtonFlag() { return btn_flag; }
  ///
  int			DataSize() { return data_size; }
  ///
  int			DataFormat() { return data_fmt; }

  /// Get position.
  void		GetPos(float pos[3], float scaling=144.0);
  /// Get angles.
  void		GetAng(float ang[3]);
  /// Get quaternion.
  void		GetQuat(float quat[4]);
  /// Get 3*3 rotation Marix.
  void		GetMat(float mat[3][3]);
  /// Everything ???
  void		GetXform(float mat[4][4], float scaling=144.0);
  ///
  void		GetRawData(float* d);
  /// Is data ok ?
  int			GoodData() { return good_data; }
  
  static int		RawRecordSize(unsigned char* raw);
};

#endif
