/* -*- C++ -*- */

#ifndef __MOSTARSYS_H__
#define __MOSTARSYS_H__

#include <WL/MostarDefs.h>

/// System data for Asc. Motionstar
class wlMostarSys : public wlMostarDefs
{
  unsigned char	all;
  unsigned char	fbb_error;
  unsigned char	flock_count;
  unsigned char	server_count;
  unsigned char	xmitter_addr;
  char		measurement_rate[6];
  unsigned char	chassis_id;
  unsigned char	chassis_count;
  unsigned char	first_addr;

  unsigned char	fbb_status[120];

public:			
  ///
  wlMostarSys();		
  ///
  wlMostarSys(unsigned char* raw);
  ///
  void		FromRaw(unsigned char* raw);		
  ///
  void		ToRaw(unsigned char* raw);
  ///
  int			IsRunning()
    { return (all & SYS_RUNNING) == SYS_RUNNING; }		
  ///
  int			HasError()
    { return (all & SYS_ERROR) == SYS_ERROR; }		
  ///
  int			HasFBBError()
    { return (all & SYS_FBB_ERROR) == SYS_FBB_ERROR; }		
  ///
  int			IsMaster()
    { return (all & SYS_MASTER) == SYS_MASTER; }		
  ///
  int			HasHostSync()
    { return (all & SYS_HOSTSYNC) == SYS_HOSTSYNC; }		
  ///
  int			HasCRTSync()
    { return (all & SYS_CRTSYNC) == SYS_CRTSYNC; }
  ///
  unsigned char	FBBError() { return fbb_error; }		
  ///
  unsigned char	FlockCount() { return flock_count; }		
  ///
  unsigned char 	ServerCount() { return server_count; }
  ///
  unsigned char	TransmitterAddress() { return xmitter_addr; }
  ///
  unsigned char 	ChassisID() { return chassis_id; }
  ///
  unsigned char 	ChassisCount() { return chassis_count; }
  ///
  unsigned char	FirstAddress() { return first_addr; }		
  ///
  int			MeasurementRate();		
  ///
  void		SetMeasurementRate(int rate);		
  ///
  void		SetTransmitterAddress(unsigned char addr);
  ///
  int			DeviceIsAccessible(unsigned char which);
  ///
  int			DeviceIsRunning(unsigned char which);	
  ///
  int			DeviceHasReceiver(unsigned char which);
  ///
  int			DeviceIsAnERC(unsigned char which);
  ///
  void		Print(ostream&);
};
    
#endif
