/* COPYRIGHT
 *
 * This file is part of FLUID
 *
 * Author: Tommi Ilmonen, 1999-2001.
 * Tommi.Ilmonen@hut.fi
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. 
 *    
 */

#ifndef FLUID_MEDIAN_FILTER3_HPP
#define FLUID_MEDIAN_FILTER3_HPP

template <typename T>
class MedianFilter3
{
public:
  MedianFilter3() {}
  ~MedianFilter3() {}
  
  void reset(T def = 0) { m_v[0] = m_v[1] = m_v[2] = def; m_index = 0; }

  void put(T v) { m_v[m_index++ % 3] = v; }

  T get() const
  {
    T v0 = m_v[0];
    T v1 = m_v[1];
    T v2 = m_v[2];

    if(v0 < v1) {
      if(v1 < v2)
	return v1;
      if(v0 < v2)
	return v2;
      return v0;
    }
    else {
      if(v0 < v2)
	return v0;
      if(v1 > v2)
	return v2;
      return v0;
    }
  }

protected:
  T    m_v[3];
  uint m_index;
};

#endif
