/* COPYRIGHT
 *
 * This file is part of FLUID
 *
 * Author: Tommi Ilmonen, 1999-2001.
 * Tommi.Ilmonen@hut.fi
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. 
 *    
 */

#ifndef KEYBOARD_TRACKER_WIDGET_HPP
#define KEYBOARD_TRACKER_WIDGET_HPP

#include <qwidget.h>

#include <Fluid/Keyboard.hpp>

#include <vector>

class QTimer;
class QTKeyboardSource;

class KeyboardTrackerWidget : public QWidget
{
  Q_OBJECT
public:
  enum Button
  {
    BUTTON_LEFT,
    BUTTON_MIDDLE,
    BUTTON_RIGHT,
    BUTTONS
  };

  KeyboardTrackerWidget(QTKeyboardSource *driver, int sampleRate, bool grab);
  ~KeyboardTrackerWidget();

  // void finish();

  int keyCount() const { return m_keys.size(); }
  Fluid::KeyboardSample popKey();

private slots:
  void timeout();
private:
  // void paintEvent(QPaintEvent* e);

  // virtual void mousePressEvent(QMouseEvent *e);
  // virtual void mouseReleaseEvent(QMouseEvent *e);
  virtual void keyPressEvent ( QKeyEvent * );

  QTimer* internalTimer;

  int sampleRate;

  bool grab;
  bool grabbed;

  QTKeyboardSource *driver;
  std::vector<Fluid::KeyboardSample> m_keys;

};

#endif
