/* COPYRIGHT
 *
 * This file is part of FLUID
 *
 * Author: Tommi Ilmonen, 1999-2001.
 * Tommi.Ilmonen@hut.fi
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. 
 *    
 */
#ifndef QTKEYBOARD_HPP
#define QTKEYBOARD_HPP

#include <KeyboardTrackerWidget.hpp>

#include <Fluid/Keyboard.hpp>
#include <Fluid/InputDevices.hpp>
#include <Fluid/ConfigReader.hpp>

#include <qapplication.h>
#include <qtimer.h>
#include <unistd.h>
#include <iostream>

using namespace Fluid;


class QTKeyboardSource : public DI_Thread, public DataSource<KeyboardSample>
{
public:
                  QTKeyboardSource(int sampleRate, int bufferSize, bool grab);
                  ~QTKeyboardSource();
  virtual void    start();
  virtual void    stop();
  virtual float   getSampleRate() const;
  void            notify();
  virtual void    childLoop();
  std::string     getDriverName() const { return "QTKeyboard"; }
private:
  QApplication *app;
  KeyboardTrackerWidget *widget;

  bool started;

  int sampleRate;
  bool grab;
};

#endif
