/* COPYRIGHT
 *
 * This file is part of FLUID
 *
 * Author: Tommi Ilmonen, 1999-2001.
 * Tommi.Ilmonen@hut.fi
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. 
 *    
 */

#ifndef MOUSE_TRACKER_WIDGET_HPP
#define MOUSE_TRACKER_WIDGET_HPP

#include <qwidget.h>

class QTimer;
class QTMouseSource;

class MouseTrackerWidget : public QWidget
{
  Q_OBJECT
public:
  enum Button
  {
    BUTTON_LEFT,
    BUTTON_MIDDLE,
    BUTTON_RIGHT,
    BUTTONS
  };

  MouseTrackerWidget(QTMouseSource *driver, int sampleRate, bool grab);
  ~MouseTrackerWidget();
  int  getCurrentX();
  int  getCurrentY();
  int  getButtonState();
  void setSampleRate(int hz);
  int  getSampleRate() const { return sampleRate; }
  void finish();
private slots:
  void timeout();
private:
  void paintEvent(QPaintEvent* e);

  virtual void mousePressEvent(QMouseEvent *e);
  virtual void mouseReleaseEvent(QMouseEvent *e);
  virtual void keyPressEvent ( QKeyEvent * );
  QTimer* internalTimer;
  int x;
  int y;
  int sampleRate;
  bool grab;
  int  buttonState;
  bool grabbed;
  QTMouseSource *driver;
};

#endif
