/* COPYRIGHT
 *
 * This file is part of FLUID
 *
 * Author: Tommi Ilmonen, 1999-2001.
 * Tommi.Ilmonen@hut.fi
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. 
 *    
 */
#ifndef QTMOUSE_HPP
#define QTMOUSE_HPP

#include <MouseTrackerWidget.hpp>

#include <Fluid/Mouse.hpp>
#include <Fluid/InputDevices.hpp>
#include <Fluid/ConfigReader.hpp>

#include <qapplication.h>
#include <qtimer.h>
#include <unistd.h>
#include <iostream>

using namespace Fluid;


class QTMouseSource : public DI_Thread, public DataSource<MouseSample>
{
public:
                  QTMouseSource(int sampleRate, int bufferSize, bool grab);
                  ~QTMouseSource();
  virtual void    start();
  virtual void    stop();
  virtual float   getSampleRate() const;
  void            notify();
  virtual void    childLoop();
  std::string     getDriverName() const { return "QTMouse"; }
private:
  QApplication *app;
  MouseTrackerWidget *widget;
  int  x;
  int  y;
  bool buttons[Mouse::BUTTONS];
  bool started;

  int sampleRate;
  bool grab;
};

#endif
