/* COPYRIGHT
 *
 * This file is part of FLUID
 *
 * Author: Tommi Ilmonen, 1999-2001.
 * Tommi.Ilmonen@hut.fi
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. 
 *    
 */

#ifndef FLUID_SPEECH_DRIVER_HPP
#define FLUID_SPEECH_DRIVER_HPP

#include <di_HUTcave_navig.h>

#include <Fluid/Speech.hpp>

#include <Fluid/DataSource.hpp>


using namespace Fluid;

namespace Fluid {
  class ConfigChunk;
}

/* ViaVoice Speech driver. Relies on DIVA Speech classes by Jarmo
   Hiipakka. */

class SpeechViaVoice : public DI_HUTCaveNavig, 
		       public DataSource<Phrase>, 
		       public DI_Thread
	   
{
public:
  SpeechViaVoice(const std::string & grammar, 
		 const std::string & lang, 
		 int bufferSize);
  virtual ~SpeechViaVoice();

  virtual void start();
  virtual void stop();
  virtual void childLoop();

  std::string getDriverName() const { return "SpeechViaVoice"; }

  static SpeechViaVoice * create(Fluid::ConfigChunk * chunk);

protected:

  virtual void deliver(const char *);

  std::string m_grammarName;
  std::string m_lang;
  bool        m_continue;
};


#endif
