/* -*- C++ -*- */

//
// DIVA Library. Copyright (C) Jarmo Hiipakka, 1999-2000.
//
// $Log: di_HUTcave_navig.h,v $
// Revision 1.1  2002/10/16 08:45:54  tilmonen
// Wonderful Speech recognition system by
//  - IBM: ViaVoice.
//  - Jarmo Hiipakka: C++ wrapping
//  - Tommi Ilmonen: Fluid wrapping
//

#ifndef DI_HUTCAVE_NAVIG_H
#define DI_HUTCAVE_NAVIG_H

#include "di_socket.h"
#include "di_speech_reco_base.h"

class DI_HUTCaveNavig : public DI_SpeechRecoBase
{
public:

  /**name Constructors */

  //@{
  
  ///
  
  DI_HUTCaveNavig();

  ///
  
  ~DI_HUTCaveNavig();

  //@}

  /**name Access */

  //@{

  ///

  DI_Socket &socket() { return m_socket; }

  //@}
  
  /**name Reply functions */

  //@{

  ///
  
  SmHandler recoWordReply(SM_MSG *reply, void * call_data);

  ///
  
  SmHandler recoPhraseReply(SM_MSG *reply, void * call_data);
  
  //@}

  /**name Recognizer state */

  //@{

  ///

  bool running() const { return m_running; }
  
  //@}

protected:
  virtual void deliver(const char *);

private:

  DI_Socket  m_socket;
  char      *m_buffer;
  bool       m_running;
};

#endif  // DI_HUTCAVE_NAVIG_H
