
#ifndef _SERIALMOUSE_HPP
#define _SERIALMOUSE_HPP

#include <string>

class SerialMouseState
{
public:

  unsigned int m_buttonStates;
  int m_xMotion;
  int m_yMotion;
};


class SerialMouse
{
public:

  SerialMouse();
  ~SerialMouse();
  
  bool init(const char * device = "/dev/ttyS0");

  bool shutdown();

  bool nextState(SerialMouseState *state, 
		 /// Time-out in milliseconds
		 int timeoutMs = 500);

protected:

  int m_fd;
  
  unsigned int  m_buttonState;
  unsigned char m_memory;
  bool m_middle;

  std::string m_mouseId;
};



#endif
