/*
  g++ serialprint.cpp -o serialprint

*/

#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/stat.h>

#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <termios.h>
#include <stdio.h>
#include <string.h>

int main()
{
  printf("M3 = %x %x", (uint) 'M', (uint) '3');

  int fd = open("/dev/ttyS0", O_RDWR);
  
  if(1) {
    struct termio sttyArgs;
    ioctl(fd, TCGETA , &sttyArgs);
    if(1) {
      sttyArgs.c_cflag &= ~CBAUD;
      sttyArgs.c_cflag |=  B1200;
      
      sttyArgs.c_cflag &= ~CSIZE;
      sttyArgs.c_cflag |= CSIZE & CS8;
      
      sttyArgs.c_cflag |= CREAD;	/* Allow reading */
      sttyArgs.c_cflag |= CLOCAL;	/* No modem between us and device */
      
      sttyArgs.c_cc[VMIN] = 0;	/* Return read even if no chars */
      sttyArgs.c_cc[VTIME] = 0;	/* Return without waiting */
    }

    // sttyArgs.c_iflag = (IGNBRK | IGNPAR);  /* Ignore break & parity errs */
    sttyArgs.c_oflag = 0;                  /* Raw output, leave tabs alone */
    sttyArgs.c_lflag = 0;              /* Raw input (no KILL, etc.), no echo */
  
    if ( ioctl(fd, TCSETA, &sttyArgs) == -1 ) {
      printf("ioctl failed (%s)", strerror(errno));
      close(fd);
      return -1;
    }
  }

  // char reset = 0xFF;
  // write(fd, &reset, 1);

  while(1) {

    unsigned char byte = 0;
    int n = read(fd, &byte, 1);
    
    if(n == 1) {
      printf("\n%.2x = ", (uint) byte, byte);
      for(uint i=0; i < 8; i++)
	printf("%d", (int) ((byte >> (7-i)) & 0x1));
      fflush(0);
    }
    
    
  }

}
