/* COPYRIGHT
 *
 * This file is part of FLUID
 *
 * Author: Tommi Ilmonen, 1999-2001.
 * Tommi.Ilmonen@hut.fi
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. 
 *    
 */

#ifndef FLUID_MOUSE_BUTTONS_HPP
#define FLUID_MOUSE_BUTTONS_HPP

#include <Fluid/MessageSource.hpp>
#include <Fluid/ProcessorNode.hpp>

#include <Fluid/Mouse.hpp>

namespace Fluid {
  
  class MouseButton : public MessageSource,
		      public ProcessorNodeContinuous
  {
  public:
    MouseButton(Processors *, const char * id, const std::string &nodeName);
    virtual ~MouseButton();
    
    virtual bool start();
    virtual bool stop();
    
    virtual void update();

    bool ok() const { return m_input != 0; }
    
  protected:
    IONodeBuffer<MouseSample> * m_input;
    ulong m_count;
    int  m_buttonState;

    std::string m_nodeName;

  };

}

#endif
