/* COPYRIGHT
 *
 * This file is part of FLUID
 *
 * Author: Tommi Ilmonen, 1999-2001.
 * Tommi.Ilmonen@hut.fi
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. 
 *    
 */

#ifndef FLUID_NAPRA_TO_MOUSE_HPP
#define FLUID_NAPRA_TO_MOUSE_HPP

#include <Fluid/Mouse.hpp>
#include <Fluid/Napra.hpp>
#include <Fluid/ProcessorNode.hpp>

namespace Fluid {

  /** Converts the switch data from napra to mouse button presses. */

  class NapraToMouse : public IOSource,
		       public ProcessorNodeContinuous
  {
  public:
    NapraToMouse(Processors * host, 
		 const std::string &id,
		 const std::string & napraBufferName,
		 int hand);
    virtual ~NapraToMouse();

    virtual bool start();
    virtual bool stop();
    
    virtual void update();
    
    virtual IONode *ioGetOutput(const char *);
    virtual std::string ioGetOutputName(unsigned);

  protected:
    std::string m_napraName;

    int m_hand;

    IONodeBuffer<NapraSample> * m_source;
    IONodeBuffer<MouseSample>   m_buffer;
    
  };

}

#endif
