/* COPYRIGHT
 *
 * This file is part of FLUID
 *
 * Author: Tommi Ilmonen, 1999-2001.
 * Tommi.Ilmonen@hut.fi
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. 
 *    
 */

#ifndef FLUID_MESSAGE_H
#define FLUID_MESSAGE_H

#include <Fluid/TimeStamp.hpp>

namespace Fluid {

  class Message
  {
  public:
    Message() { m_time.getTimeOfDay(); }
    Message(const TimeStamp &time) : m_time(time) {}

    virtual ~Message() {}
    
    const TimeStamp &getTime() const { return m_time; }
    void setTime(const TimeStamp &t) { m_time = t; }
    
  protected:
    TimeStamp       m_time;
    
  };

}
#endif
