/* COPYRIGHT
 *
 * This file is part of FLUID
 *
 * Author: Tommi Ilmonen, 1999-2001.
 * Tommi.Ilmonen@hut.fi
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. 
 *    
 */

#ifndef FLUID_MESSAGE_FLOAT_HPP
#define FLUID_MESSAGE_FLOAT_HPP

#include <Fluid/Message.hpp>

namespace Fluid {
  
  class MessageFloat : public Message
  {
  public:
    MessageFloat() {}
    MessageFloat(float v) : m_val(v) {}
    MessageFloat(float v, const TimeStamp &t) : Message(t), m_val(v) {}
    
    virtual ~MessageFloat() {}
    
    float  value() const { return m_val; }
    void setValue(float v) { m_val = v; }
    
  private:
    float m_val;
  };

}

#endif

