/* COPYRIGHT
 *
 * This file is part of FLUID
 *
 * Author: Tommi Ilmonen, 1999-2001.
 * Tommi.Ilmonen@hut.fi
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. 
 *    
 */

#ifndef FLUID_MESSAGE_INT_HPP
#define FLUID_MESSAGE_INT_HPP

#include <Fluid/Message.hpp>

namespace Fluid {
  
  class MessageInt : public Message
  {
  public:
    MessageInt() {}
    MessageInt(int v) : m_val(v) {}
    MessageInt(int v, const TimeStamp &t) : Message(t), m_val(v) {}
    
    virtual ~MessageInt() {}
    
    int  value() const { return m_val; }
    void setValue(int v) { m_val = v; }
    
  private:
    int m_val;
  };

}

#endif

