/* COPYRIGHT
 *
 * This file is part of FLUID
 *
 * Author: Tommi Ilmonen, 1999-2001.
 * Tommi.Ilmonen@hut.fi
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. 
 *    
 */

#include <Fluid/MessagePrinter.hpp>

#include <Fluid/Message.hpp>

#include <typeinfo>

#include <assert.h>

namespace Fluid {
  
  MessagePrinter::MessagePrinter()
    : m_output(0)
  {}
  
  MessagePrinter::~MessagePrinter()
  {}
  
  bool MessagePrinter::msgProcess(const char *id, Message *msg)
  {
    if(!m_output) m_output = & std::cout;
    
    assert(msg);
    
    (*m_output) << "String event: type = \"" << typeid(*msg).name() << "\"" 
		<< "id = \"" << id<< "\""
		<< std::endl;
    
    return true;
  }
  
} // namespace Fluid
