/* COPYRIGHT
 *
 * This file is part of FLUID
 *
 * Author: Tommi Ilmonen, 1999-2001.
 * Tommi.Ilmonen@hut.fi
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. 
 *    
 */

#include <Fluid/MessageSink.hpp>

#include <Fluid/MessageSource.hpp>

#include <assert.h>

namespace Fluid {
  
  MessageSink::MessageSink()
  {}

  MessageSink::~MessageSink()
  {
    msgBreakLinks();
  }
  
  void MessageSink::msgBreakLinks()
  {
    while(m_sources.size()) {
      MessageSource *source = * m_sources.begin();

      source->msgRemoveSink(this);
      m_sources.erase(m_sources.begin());
    }
  }
  
  void MessageSink::msgAddSource(MessageSource *source)
  {
    assert(source);

    m_sources.insert(source);
  }

  void MessageSink::msgForgetSource(MessageSource *source)
  {
    assert(source);

    std::set<MessageSource *>::iterator it = m_sources.find(source);

    if(it != m_sources.end())
      m_sources.erase(it);
  }
}
