/* COPYRIGHT
 *
 * This file is part of FLUID
 *
 * Author: Tommi Ilmonen, 1999-2001.
 * Tommi.Ilmonen@hut.fi
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. 
 *    
 */

#ifndef FLUID_MESSAGE_SINK_H
#define FLUID_MESSAGE_SINK_H

#include <set>

namespace Fluid {
  
  class Message;
  class MessageSource;

  class MessageSink
  {
  public:
    MessageSink();
    virtual ~MessageSink();
    
    virtual bool msgProcess(const char *id, Message *) = 0;
    
    void msgBreakLinks();
    void msgAddSource(MessageSource *);
    void msgForgetSource(MessageSource *);

  private:
    std::set<MessageSource *> m_sources;
  };
  
}
#endif

