/* COPYRIGHT
 *
 * This file is part of FLUID
 *
 * Author: Tommi Ilmonen, 1999-2001.
 * Tommi.Ilmonen@hut.fi
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. 
 *    
 */

#ifndef FLUID_MESSAGE_STRING_HPP
#define FLUID_MESSAGE_STRING_HPP

#include <Fluid/Message.hpp>

#include <string>

namespace Fluid {
  
  class MessageString : public Message
  {
  public:
    MessageString() {}
    MessageString(const std::string &str) : m_str(str) {}
    MessageString(const std::string &str, const TimeStamp &t) 
      : Message(t), m_str(str) {}
    
    virtual ~MessageString() {}
    
    const std::string & string() const { return m_str; }
    void setString(const std::string &str) { m_str = str; }
    
  private:
    std::string m_str;
  };

}

#endif
