/* COPYRIGHT
 *
 * This file is part of FLUID
 *
 * Author: Tommi Ilmonen, 1999-2001.
 * Tommi.Ilmonen@hut.fi
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. 
 *    
 */


#include <Fluid/MessageStringPrinter.hpp>
#include <Fluid/Error.hpp>

namespace Fluid {
  
MessageStringPrinter::MessageStringPrinter()
  : m_output(0)
{}

MessageStringPrinter::~MessageStringPrinter()
{}


bool MessageStringPrinter::msgProcess(const char *id, Message *msg)
{
  // Trace("MessageStringPrinter::msgProcess # \"%s\" %p", id, msg);

  if(!m_output) m_output = & std::cout;

  MessageString *ms = dynamic_cast<MessageString *> (msg);

  if(!ms) return false;

  (*m_output) << "String event: \"" << ms->string().c_str() << "\"" 
	      << ", id = \"" << id<< "\""
	      << std::endl;

  return true;
}

} // namespace Fluid
