/*
  18.8.2004 Marq
*/

#ifndef GLX_WRAPPER_H
#define GLX_WRAPPER_H

/* Ikkunan liput */
#define GLX_LOCAL 0x1   /* Paikallinen ikkuna, nopea direct rendering */
#define GLX_REMOTE 0

#define GLX_NODECOR 0x2 /* Ei kehyksi ikkunaan */
#define GLX_DECOR 0

#define GLX_USE_STEREO 0x4

#ifdef __cplusplus
extern "C" {
#endif

  typedef struct glx_t GLX;

  GLX * GLX_Create();

  void GLX_Free(GLX *);
  
  /* Avaa akkunan. Liput voi orrata yhteen (ks. yll)
     Palauttaa nollan jos kaikki meni hyvin. */
  int GLX_Open(GLX *glx, const char *display,
	       int x,int y,int xs,int ys,
	       int flags);

  /* Asettaa GL-kontekstin */
  void GLX_SetActive(GLX *glx);

  /* Reads in X events. Return 1 if "Esc" was pressed. */
  int GLX_GetEvents(GLX *glx);

  /* Stuff to do before actual swap can be done. */
  void GLX_PreSwap(GLX *glx);

  /* Vaihtaa nytettvn bufferin. */
  void GLX_Swap(GLX *glx);

  /* Tuhoaa akkunan */
  void GLX_Close(GLX *glx);

#ifdef __cplusplus
}
#endif

#endif
