/* COPYRIGHT
 *
 * This file is part of FLUID
 *
 * Author: Tommi Ilmonen, 1999-2001.
 * Tommi.Ilmonen@hut.fi
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. 
 *    
 */

#ifndef FLUID_VRJ_TRACKER_EXPORT_H
#define FLUID_VRJ_TRACKER_EXPORT_H

#include <di_data_buffer.h>

#include <Input/vjPosition/vjPosition.h>

namespace Fluid {

class Tracker;

  /** Class that hides the FLUID tracker behind the VRJ tracker
      interface. */ 

class VrjTrackerExport : public vjPosition 
{
public:
  VrjTrackerExport();
  virtual ~VrjTrackerExport();

  virtual bool config(vjConfigChunk *);
  virtual int startSampling();
  virtual int stopSampling();
  virtual int sample();
  virtual void updateData();

  inline char* getDeviceName (void) {
    return "FluidVrjTrackerExport";
  }

  virtual vjMatrix* getPosData(int dev = 0);
  virtual vjTimeStamp* getPosUpdateTime(int d);
  
  static std::string getChunkType()
  { return "FluidVrjTracker"; }

  static void configInit();

protected:
  Tracker *m_tracker;
  uint      m_sensors;
  
};

} // namespace Fluid

#endif

