/* COPYRIGHT
 *
 * This file is part of FLUID
 *
 * Author: Tommi Ilmonen, 1999-2001.
 * Tommi.Ilmonen@hut.fi
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. 
 *    
 */


#include <Fluid/VrjTrackerExport.hpp>

#include <Fluid/Error.hpp>

#include <Kernel/vjKernel.h>

int main(int argc, char **argv)
{
  // Allocate the kernel object and the application object
  vjKernel* kernel = vjKernel::instance();
  
  // IF not args passed to the program
  //    Display usage information and exit
  if (argc <= 1)
    {
      std::cout << "\n\n";
      std::cout << "Usage: " << argv[0] << " vjconfigfile[0] vjconfigfile[1] ... vjconfigfile[n]" << std::endl;
      exit(1);
    }

  Fluid::VrjTrackerExport::configInit();

  // Load any config files specified on the command line
  for(int i = 1; i < argc; i++)
    kernel->loadConfigFile(argv[i]);
  
  Fluid::Trace("Done FLuid::VrjTrackerExport::configInit()");

  // Start the kernel running
  kernel->start();
  
  return 0;
}

