% Example: 
%  [b,a] = cheby1(5, 0.5, 0.3)
%  freqz_mj(b, a);
%

function r = freqz_mj(b, a)

points = 300;

r = zeros(1,points);

xvect = ((1:points) / points) .^3 - (1 / points) .^ 3 + 0.0001;

for n=1:points;
  r(n) = transf(b, a, xvect(n));
end

subplot(2,1,1)
% plot(xvect, 20 * log10(abs(r))); grid on, zoom on
semilogx(xvect, 20 * log10(abs(r))); grid on, zoom on

subplot(2,1,2)
% plot(xvect, phase(r) / pi * 180); grid on, zoom on
semilogx(xvect, phase(r) / pi * 180); grid on, zoom on
