% High-shelving EQ
%
% http://shoko.calarts.edu/~majordom/music-dsp/1998c/msg00555.html
%
% 
% [b,a] = high_shelf2(2340, 44100, 4.5, 1.0, 1.0);
%
% S = slope
% freqz_mj(b, a)

function [b, a] = high_shelf2(frequency, sample_rate, dBgain, Q, S)

    A     =  10^(dBgain/40)   %  (for for peaking andshelving EQ filters only)

    omega = 2*pi*frequency/sample_rate
    
    sn    = sin(omega)
    cs    = cos(omega)

    alpha = sn/(2*Q)

    beta  = sqrt( (A^2 + 1)/S - (A-1)^2 ) %   (for shelving EQ filters only)

b = zeros(1,3);
a = zeros(1,3);

                a(1) =        (A+1) - (A-1)*cs + beta*sn;
                a(2) =    2*( (A-1) - (A+1)*cs           );
                a(3) =        (A+1) - (A-1)*cs - beta*sn;

                b(1) =    A*( (A+1) + (A-1)*cs + beta*sn );
                b(2) = -2*A*( (A-1) + (A+1)*cs           );
                b(3) =    A*( (A+1) + (A-1)*cs - beta*sn );

b = b / a(1)
a = a / a(1)
