% High-shelving EQ
%
% http://shoko.calarts.edu/~majordom/music-dsp/1998c/msg00555.html
%
% 
% [b,a] = low_shelf(1000, 44100, 3.0, 1.0, 1.0);
%
% S = slope
% freqz_mj(b, a)

function [b, a] = low_shelf(frequency, sample_rate, dBgain, Q, S)

    A     =  10^(dBgain/40);  %  (for for peaking andshelving EQ filters only)

    omega = 2*pi* (0.5 - frequency/sample_rate);
    
    sn    = sin(omega);
    cs    = cos(omega);

    alpha = sn/(2*Q);

    beta  = sqrt( (A^2 + 1)/S - (A-1)^2 ); %   (for shelving EQ filters only)

b = zeros(1,3);
a = zeros(1,3)

                b(1) =    A*( (A+1) + (A-1)*cs + beta*sn );
                b(2) =  2*A*( (A-1) + (A+1)*cs           );
                b(3) =    A*( (A+1) + (A-1)*cs - beta*sn );
                a(1) =        (A+1) - (A-1)*cs + beta*sn;
                a(2) =   -2*( (A-1) - (A+1)*cs           );
                a(3) =        (A+1) - (A-1)*cs - beta*sn;

b = b / a(1)
a = a / a(1)
