% parmeq.m - second-order parametric EQ filter design
%
% [b, a] = parmeqB(gain, freq, bw)
%
% Example: [b, a] = parmeqB(3.0, 0.3, 1.0)
% freqz_mj(b, a)
% 
%
% Resource: http://shoko.calarts.edu/~majordom/music-dsp/1997c/msg00099.html


function [b, a] = parmeqB(gain, omega, bw)

K = 10 ^ (gain/20);

F = 10 ^ (gain/40);



gamma = sqrt(K*(F*F-1)/(K*K-F*F)) * sinh ((log(2)/2)*bw*(omega/sin(omega)))*sin(omega);

        b(1) = (1 + gamma*sqrt(K))/(1 + gamma/sqrt(K))
        b(2) = (-2*cos(omega))/(1 + gamma/sqrt(K))
        b(3) = (1 - gamma*sqrt(K))/(1 + gamma/sqrt(K))
	a(1) = 1.0
        a(2) = b(2)
        a(3) = (1 - gamma/sqrt(K))/(1 + gamma/sqrt(K))
