
//
// DIVA Library. Copyright (C) Jarmo Hiipakka & Tommi Ilmonen, 1999-2000.
//
// $Log: ac_buffer.C,v $
// Revision 1.3  2002/06/05 10:08:50  tilmonen
// Updates.
//
// Revision 1.2  2002/02/18 14:54:16  tilmonen
// Added a possibility to control the gain and pitch of an active note.
//
// Revision 1.1  2001/07/26 08:57:48  tilmonen
// New auralization control toolkit.
//

#include "ac_buffer.h"

#include <stdlib.h>
#include <stdio.h>

const char * AC_MsgTypeKeys[AC_MT_SIZEOF] = {
  "PLAY_SAMPLE",
  "CHANGE_SOURCE_LOCATION",
  "CHANGE_SOURCE_ORIENTATION",
  "SET_MATERIAL",
  "SET_CHANNEL",
  "FADE",
  "IS_OK",
  "CLOSE",
  "START",
  "STARTED",
  "STOP",
  "STOPPED"
};

void AC_Buffer::writeHeader(long long timestamp, int msgID, AC_MsgType type,
			    int sourceID)
{
  rewind();

  writeInt64(timestamp);
  writeInt32(msgID);
  writeInt32(type);
  writeInt32(sourceID);
}

bool AC_Buffer::readHeader(long long *timestamp, int *msgID, AC_MsgType *type,
			   int *sourceID)
{
  rewind();

  if (m_size < headerLength()) return false;

  *timestamp = readInt64();
  *msgID = readInt32();
  *type = (AC_MsgType) readInt32();
  *sourceID = readInt32();

  return true;
}
