/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of Mustajuuri LGPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2004.
 * e-mail: firstname.lastname(at)hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. Extra clauses can be found from the file
 * MUSTAJUURI_LGPL and further explanations from the file
 * MUSTAJUURI_LICENSE. The license text can be found in file
 * "LGPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *    
 */

#ifndef AC_ERROR_H
#define AC_ERROR_H

#include "ac_error_enums.h"


extern void AC_failure(AC_ErrorLevel level,
		       AC_ErrorCode  code, 
		       const char *c1, const char *c2 = 0, const char *c3 = 0);

extern void AC_warning(AC_ErrorCode  code, const char *c1, const char *c2 = 0);

extern void AC_error(AC_ErrorCode  code, const char *c1, const char *c2 = 0);
extern void AC_error(AC_ErrorCode  code, 
		     const char *c1, 
		     const char *c2,
		     const char *c3);
extern void AC_error2(AC_ErrorCode  code, const char *msg, ...);

extern void AC_fatal(AC_ErrorCode  code, const char *c1, const char *c2 = 0);

extern void AC_trace(AC_ErrorCode  code, const char *c1, const char *c2 = 0);
extern void AC_trace(const char *c1, const char *c2 = 0);
extern void AC_trace(const char *c1, const char *c2, int i);
extern void AC_trace(const char *c1, int i);
extern void AC_trace2(const char *msg, ...);


extern bool     AC_errorsToFile;

#endif  // AC_ERROR_H
