

#include "ac_buffer.h"

#include <stdio.h>

int main()
{
  AC_Buffer acb;

  long long ts = 111222333, ts2;
  float f1 = 0.42, f2 = 99.0;
  int i1 = 18, i2 = 20;
  char * text = "Lauri poika lappalainen\nPaha poika pikkarainen";

  ts *= 123456;

  acb.writeHeader(AC_MT_MOVE_IMAGE_SOURCE, ts);
  acb.writeFloat32(f1);
  acb.writeFloat32(f2);
  acb.writeInt32(i1);
  acb.writeInt32(i2);
  acb.writeInt32(i2);
  acb.writeInt64(ts);
  acb.writeString(text);
  acb.finalize(); // DO REMEMBER

  printf("MESSAGE WRITTEN, size = %d\n", 
	 acb.bytesUsed() - AC_Buffer::headerLength());
  fflush(0);

  // END WRITE; BEGIN READ

  AC_MsgType type;
  uint size;
  
  acb.readHeader(&type, &ts2, &size);
  
  if(type >= AC_MT_SIZEOF) {
    puts("BAD TYPE");
    exit(0);
  }

  printf("Type = \"%s\", size = %d\n", AC_MsgTypeKeys[type], size);
  
  float ef1 = acb.readFloat32() - f1;
  float ef2 = acb.readFloat32() - f2;

  int e1 = acb.readInt32() - i1;
  int e2 = acb.readInt32() - i2;
  int e3 = acb.readInt32() - i2;

  long long tserr = acb.readInt64() - ts;
  
  printf("ef1 = %f, ef2 = %f, e1 = %d, e2 = %d, e3 = %d, tserr = %d \n",
	 ef1, ef2, e1, e2, e3, (int) tserr);
  
  fflush(0);

  char buf[AC_BufferBase::maxString()];
  acb.readString(buf);
  puts(buf);

  return 0;
}
