#! /c/bin/zsh -f

export CONFDIR=Linux-i686-g++

# Uncomment this line to use a more generic setup
# export CONFDIR=Linux-anycpu-g++

export SOURCEDIR=Linux
export SOURCEMIDI=oss

echo ""

# Check for ALSA libraries
if test  -e /usr/include/sys/asoundlib.h ; then 
    echo "It seems you have ALSA installed, setting up links for ALSA"

    export ALSA_APPEARS_0_9beta3=$(grep snd_pcm_mmap_writei /usr/include/sys/asoundlib.h|cut -b1)
    export ALSA_APPEARS_0_9beta7=$(grep snd_pcm_mmap_commit /usr/include/sys/asoundlib.h|cut -b1)
    export ALSA_APPEARS_0_9beta9=$(grep snd_pcm_mmap_commit /usr/include/alsa/pcm.h|cut -b1)

    export ALSA_APPEARS_1_0=$(grep 1.0 /usr/include/alsa/version.h | grep _STR |cut -b2)

   echo $ALSA_APPEARS_0_9beta9
   echo $ALSA_APPEARS_1_0

    if test ! -z $ALSA_APPEARS_0_9beta3 ; then
        echo "ALSA version seems to be 0.9beta3"
        echo "ALSA 0.9.0-3 beta versions may cause system crashes (!!)"
        export SOURCEAUDIO=alsa-0.9beta3

    elif test ! -z $ALSA_APPEARS_1_0 ; then
        echo "ALSA version seems to be 1.0 or higher"
        export SOURCEAUDIO=alsa-1.0

    elif test ! -z $ALSA_APPEARS_0_9beta7 ; then
        echo "ALSA version seems to be 0.9beta7"
        export SOURCEAUDIO=alsa-0.9beta7

    elif test ! -z $ALSA_APPEARS_0_9beta9 ; then
        echo "ALSA version seems to be 0.9beta9 or higher"
        export SOURCEAUDIO=alsa-0.9beta7

    else
        echo "ALSA version seems to be 0.5.x"
        export SOURCEAUDIO=alsa
    fi

else
    echo "Setting up the audio system to use the OSS interface"
    export SOURCEAUDIO=oss
fi
