/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of DIVA base library.
 *
 * Author(s): Jarmo Hiipakka and Tommi Ilmonen, 2000-2001.
 * Jarmo.Hiipakka@hut.fi Tommi.Ilmonen@hut.fi
 *
 * DIVA - Digital Interactive Virtual Acoustics group 
 * Telecommunications Software and Multimedia Laboratory
 * Helsinki University of Technology
 * Finland
 *
 * http://www.tml.hut.fi/Research/DIVA/
 *
 * DIVA base library is licensed under GNU Lesser General Public
 * License (LGPL). The LGPL conditions can be found in file "LGPL"
 * that is distributed with this source package or obtained from the
 * GNU organization (www.gnu.org).
 * 
 */
/* COPYRIGHT
 *
 * This file is part of Mustajuuri.
 *
 * Author: Tommi Ilmonen, 1999-2001.
 * Tommi.Ilmonen@hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * Mustajuuri is licensed under GNU Lesser General Public License
 * (LGPL). The LGPL conditions can be found in file "LGPL" that is
 * distributed with this source package. The Mustajuuri license
 * interpretation that further clarifes LGPL can be found in file
 * "MUSTAJUURI_LICENSE" that is distributed with the Mustajuuri source code.
 *    
 */

#ifndef DI_CONDITION_H
#define DI_CONDITION_H

#include <qwaitcondition.h> 

#include <di_mutex.h>

/// Condition for threads.
class DI_Condition
{
public:
  DI_Condition() {}

  ~DI_Condition() { }

  int wait(DI_Mutex &mutex)
  { return !m_cond.wait(mutex.qmutex()); }

  int broadcast() 
  { m_cond.wakeAll(); return 0; }

  int broadcast2(DI_Mutex &mutex) 
  { 
    mutex.lock();
    m_cond.wakeAll();
    mutex.unlock();
    return 0;
  }

  int signal() 
  { m_cond.wakeOne(); return 0; }

  int signal2(DI_Mutex &mutex) 
  {
    mutex.lock();
    m_cond.wakeOne();
    mutex.unlock();
    return 0;
  }

protected:
  QWaitCondition m_cond;
};

#endif
