/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of DIVA base library.
 *
 * Author(s): Jarmo Hiipakka and Tommi Ilmonen, 2000-2001.
 * Jarmo.Hiipakka@hut.fi Tommi.Ilmonen@hut.fi
 *
 * DIVA - Digital Interactive Virtual Acoustics group 
 * Telecommunications Software and Multimedia Laboratory
 * Helsinki University of Technology
 * Finland
 *
 * http://www.tml.hut.fi/Research/DIVA/
 *
 * DIVA base library is licensed under GNU Lesser General Public
 * License (LGPL). The LGPL conditions can be found in file "LGPL"
 * that is distributed with this source package or obtained from the
 * GNU organization (www.gnu.org).
 * 
 */

#ifndef DI_THREAD_H
#define DI_THREAD_H

#define DI_NULL_THREADS 1

class DI_Mutex;

/** EMPTY CLASS */
class DI_Thread
{
public:
  typedef int id_t;

  static id_t myThreadId() { return 0; }

  DI_Thread() {}
  
  virtual ~DI_Thread() {}

  bool run(bool prefer_system = true) { return true; }
  
  bool runSystem() { return true; }
  bool runProcess() { return true; }

  bool waitEnd()  { return true; }

  void kill() {}

  static void test() {}

protected:
  virtual void childLoop() = 0;
};

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////

/** EMPTY CLASS
 */
class DI_ThreadAvailable
{
public:
  DI_ThreadAvailable() {}
  ~DI_ThreadAvailable() {}

  static bool systemLevelWorks() { return true; }
  /// Returns true if process-level threads seem to work.
  static bool processLevelWorks() { return true; }
  static void check()  { }

};

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////

/// EMPTY CLASS
class DI_ThreadTest : public DI_Thread
{
public:
  DI_ThreadTest() {}
  ~DI_ThreadTest() {}

  int count() { return 0; }
  void requestEnd() {}
  
protected:
  void childLoop() {}
};

#endif
