#include <windows.h>
#include "dlfcn.h"

void * dlopen(const char *pathname, int mode){
    WCHAR wpath[256 + 1];
    MultiByteToWideChar(
		CP_ACP,
		MB_PRECOMPOSED,
		pathname,
		-1,
		wpath,
		256);
	return LoadLibrary(wpath);
}

void *dlsym(void *handle, const char *name){
	return GetProcAddress((HMODULE)handle,name);
}

int dlclose(void *handle){
	return FreeLibrary((HMODULE)handle);
}

char *dlerror(){
	static char errBuffer[256];
	LPVOID lpMsgBuf;
	FormatMessage( 
		FORMAT_MESSAGE_ALLOCATE_BUFFER | 
		FORMAT_MESSAGE_FROM_SYSTEM | 
		FORMAT_MESSAGE_IGNORE_INSERTS,
		NULL,
		GetLastError(),
		0, // Default language
		(LPTSTR) &lpMsgBuf,
		0,
		NULL 
		);
	WideCharToMultiByte(
		CP_ACP,
		WC_DEFAULTCHAR, 
		(LPTSTR) lpMsgBuf, 
		-1, 
		errBuffer, 
		256, 
		"_", 
		NULL);
	LocalFree(lpMsgBuf);
	return errBuffer; 
}
