/* COPYRIGHT
 *
 * This file is part of Mustajuuri LGPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2001.
 * Tommi.Ilmonen@hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. Extra clauses can be found from the file
 * MUSTAJUURI_LGPL and further explanations from the file
 * MUSTAJUURI_LICENSE. The license text can be found in file
 * "LGPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *    
 */

#ifndef MJ_RTC_HZ_H
#define MJ_RTC_HZ_H

/** Dummy declarations for IRIX + other systems where the RTC is not
    needed. Created for compatibility reasons. */

class MJ_RtcHz 
{
public:
  MJ_RtcHz() {}
  ~MJ_RtcHz() {}
  
  bool open(const char *d = 0) { (void) d; return false; }
  bool startPeriodic() { return false; }
  bool close() { return false; }
  bool isOpen() { return false; }
  bool setHz(int) { return false; }
  int getHz() { return -1; }
  bool waitTicks(int) { return false; }
  static bool isImplemented() { return false; }
protected:
};

#endif
