/* COPYRIGHT
 *
 * This file is part of Mustajuuri LGPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2004.
 * e-mail: firstname.lastname(at)hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. Extra clauses can be found from the file
 * MUSTAJUURI_LGPL and further explanations from the file
 * MUSTAJUURI_LICENSE. The license text can be found in file
 * "LGPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *    
 */

#include <mj_audio_buf_params.h>

#include <mj_prefs.h>

MJ_AudioBufParams::MJ_AudioBufParams()
{
  setRangesMs(MJ_prefs.minimumLatency(), 
	      MJ_prefs.maximumLatency());
  
  initRun();
}

void MJ_AudioBufParams::initRun()
{ 
  m_lowestBufferMs = m_maxBufferMs; 
  m_highestBufferMs = 0; 
  m_underFlows = 0;
}
