/* COPYRIGHT
 *
 * This file is part of Mustajuuri LGPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2004.
 * e-mail: firstname.lastname(at)hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. Extra clauses can be found from the file
 * MUSTAJUURI_LGPL and further explanations from the file
 * MUSTAJUURI_LICENSE. The license text can be found in file
 * "LGPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *    
 */

#include <mj_cpu_count.h>

MJ_CpuCount::MJ_CpuCount()
{
  reset();
}

MJ_CpuCount::~MJ_CpuCount()
{}

void MJ_CpuCount::reset()
{
  M_xLatest = clock();
  M_lSum = 0;
  M_lDiff = 0;
}

void MJ_CpuCount::update()
{
  clock_t  xNew = clock();
  M_lDiff = (ulong) (xNew - M_xLatest);
  M_lSum += M_lDiff / 1000;  // From usec to msec.
  M_xLatest = xNew;
}
