
/* COPYRIGHT
 *
 * This file is part of Mustajuuri LGPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2004.
 * e-mail: firstname.lastname(at)hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. Extra clauses can be found from the file
 * MUSTAJUURI_LGPL and further explanations from the file
 * MUSTAJUURI_LICENSE. The license text can be found in file
 * "LGPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *    
 */

#include <mj_file_load_info.h>

bool MJ_FileLoadInfo::needsLoading(const QString &file)
{
  QFileInfo fi(file);
  
  if(!fi.exists())
    return false;

  return m_loadTime <= fi.lastModified() || m_file != file;
}

/** The argument file is assumed to exist. */

bool MJ_FileLoadInfo::needsLoading(const QFileInfo &file)
{
  return m_loadTime <= file.lastModified() || m_file != file.filePath();
}

void MJ_FileLoadInfo::nowLoaded(const QString &file)
{
  m_file = file;
  m_loadTime = QDateTime::currentDateTime();
}

void MJ_FileLoadInfo::clear()
{
  m_file.truncate(0);
  m_loadTime.setTime_t(0);
}
