/* COPYRIGHT
 *
 * This file is part of Mustajuuri LGPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2004.
 * e-mail: firstname.lastname(at)hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. Extra clauses can be found from the file
 * MUSTAJUURI_LGPL and further explanations from the file
 * MUSTAJUURI_LICENSE. The license text can be found in file
 * "LGPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *    
 */

#include <mj_menu_test.h>

#include <qapplication.h>
#include <qpopupmenu.h> 
#include <qpushbutton.h> 

MJ_MenuTest::MJ_MenuTest(QWidget * parent, const char * name)
  : QWidget(parent, name),
    m_menu(new QPopupMenu(this)),
    m_button(new QPushButton("Press this", this))
{
  connect(m_button, SIGNAL(pressed()),
	  this, SLOT(showMenu()));

  m_menu->insertItem("Entry 1");
  m_menu->insertItem("Entry 2");
  m_menu->insertItem("Entry 3");

  // connect(m_menu, SIGNAL(pressed);
} 

void MJ_MenuTest::test(QApplication *qa)
{
  MJ_MenuTest mt;
  qa->setMainWidget(&mt);
  mt.show();
  qa->exec();
}

MJ_MenuTest::~MJ_MenuTest()
{
  delete m_menu;
}

void MJ_MenuTest::showMenu()
{
  m_menu->exec(mapToGlobal(QPoint(20, 20)));
  m_button->setDown(false);
}
