/* COPYRIGHT
 *
 * This file is part of Mustajuuri LGPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2004.
 * e-mail: firstname.lastname(at)hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. Extra clauses can be found from the file
 * MUSTAJUURI_LGPL and further explanations from the file
 * MUSTAJUURI_LICENSE. The license text can be found in file
 * "LGPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *    
 */

#include <mj_message_multi2.h>

#include <mj_message_string.h>
#include <mj_messages.h>


MJ_Message *MJ_MessageMulti2::duplicate()
{
  return new MJ_MessageMulti2(*this);
}

MJ_Message *MJ_MessageMulti2::createNew()
{
  return new MJ_MessageMulti2;
}

QString MJ_MessageMulti2::getQString
(const std::string &id, const char * def)
{
  MJ_Message *msg = getChild(id);

  if(!msg) return def;
  
  QString r;
  
  MJ_MessageString *mstr = dynamic_cast<MJ_MessageString *> (msg);

  if(mstr) return mstr->string();

  MJ_MessageStlString *mstlstr = dynamic_cast<MJ_MessageStlString *> (msg);
  
  return mstlstr ?  QString(mstlstr->string().c_str()) : QString(def);
}
