/* COPYRIGHT
 *
 * This file is part of Mustajuuri LGPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2004.
 * e-mail: firstname.lastname(at)hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. Extra clauses can be found from the file
 * MUSTAJUURI_LGPL and further explanations from the file
 * MUSTAJUURI_LICENSE. The license text can be found in file
 * "LGPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *    
 */

#include <mj_midi_conf_gui.h>

#include <mj_midi_conf.h>

#include <mj_strs.h>
#include <mj_tr.h>

MJ_MidiConfGui::MJ_MidiConfGui(QWidget      *parent, 
			     const char   *name)
  : MJ_IoConfGui(parent, name)
{
  draw();

  if(!parent) {
    QString label(MJ_Tr::tr("MIDI IO"));
    
    setCaption(label);
    setIconText(label);
  }
}

MJ_MidiConfGui::~MJ_MidiConfGui()
{}

QString MJ_MidiConfGui::ioTypeName(bool input)
{
  return MJ_Tr::tr(input ? MJ_Strs::MIDIInput : MJ_Strs::MIDIOutput);
}

QString MJ_MidiConfGui::ioName(bool input, int index)
{
  MJ_MidiDeviceType adt = (MJ_MidiDeviceType) ! input;

  int devices = MJ_MidiConf::midiDevices(adt);

  if(index >= devices) return QString::null;

  return MJ_Tr::tr("%1 %2 (%3)")
    .arg(MJ_MidiDeviceTypeKeys2[adt])
    .arg(index+1)
    .arg(MJ_MidiConf::midiDevice(adt, index));
}
