/* COPYRIGHT
 *
 * This file is part of Mustajuuri LGPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2004.
 * e-mail: firstname.lastname(at)hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. Extra clauses can be found from the file
 * MUSTAJUURI_LGPL and further explanations from the file
 * MUSTAJUURI_LICENSE. The license text can be found in file
 * "LGPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *    
 */

#include <mj_multi_int.h>

#include <qtextstream.h> 

void MJ_writeMultiInt(const int *data, unsigned count, QTextStream *s)
{
  for(uint i=0; i < count; i++) {
    (*s) << data[i] << "  ";
  }
}

void MJ_readMultiInt(int *data, unsigned count, QTextStream *s)
{
  for(uint i=0; i < count; i++) {
    (*s) >> data[i];
  }
  QIODevice *d = s->device();
  d->at(d->at() + 1); // Skip the two characters.
}
