/* COPYRIGHT
 *
 * This file is part of Mustajuuri LGPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2004.
 * e-mail: firstname.lastname(at)hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. Extra clauses can be found from the file
 * MUSTAJUURI_LGPL and further explanations from the file
 * MUSTAJUURI_LICENSE. The license text can be found in file
 * "LGPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *    
 */

#include <mj_strs.h>

const char *MJ_Strs::address = "address";

const char *MJ_Strs::Amplitude = "Amplitude";
const char *MJ_Strs::amplitude = "amplitude";

const char *MJ_Strs::Apply = "Apply";

const char *MJ_Strs::AudioSend = "Audio send";
const char *MJ_Strs::AudioSource = "Audio source";

const char *MJ_Strs::AudioInput = "Audio input";
const char *MJ_Strs::AudioOutput = "Audio output";

const char *MJ_Strs::authorTommi = "Ilmonen Tommi <Tommi.Ilmonen@hut.fi>";

const char *MJ_Strs::Attack = "Attack";
const char *MJ_Strs::attack = "attack";

const char *MJ_Strs::azi = "azi";

const char *MJ_Strs::Band = "Band";

const char *MJ_Strs::Bands = "Bands";
const char *MJ_Strs::bands = "bands";

const char *MJ_Strs::Bandwidth = "Bandwidth";
const char *MJ_Strs::bandwidth = "bandwidth";

const char *MJ_Strs::bits = "bits";
const char *MJ_Strs::Bits = "Bits";

const char *MJ_Strs::Buses = "Buses";
const char *MJ_Strs::buses = "buses";

const char *MJ_Strs::Bypass = "Bypass";
const char *MJ_Strs::bypass = "bypass";

const char *MJ_Strs::channel  = "channel";
const char *MJ_Strs::channels = "channels";

const char *MJ_Strs::Close = "Close";
const char *MJ_Strs::close = "close";

const char *MJ_Strs::del = "del";

const char *MJ_Strs::delay = "delay";

const char *MJ_Strs::device = "device";

const char *MJ_Strs::dis = "dis";

const char *MJ_Strs::directgain = "directgain";

const char *MJ_Strs::dspAppendWith="_CREATE_DSPMODULE";

const char *MJ_Strs::ele = "ele";

const char *MJ_Strs::end = "end";

const char *MJ_Strs::feedback = "feedback";

const char *MJ_Strs::filename = "filename";

const char *MJ_Strs::Flatten = "Flatten";
const char *MJ_Strs::flatten = "flatten";

const char *MJ_Strs::foo = "foo";

const char *MJ_Strs::format = "format";

const char *MJ_Strs::framesPerCycle = "framesPerCycle";

const char *MJ_Strs::Frequency = "Frequency";
const char *MJ_Strs::frequency = "frequency";

const char *MJ_Strs::Gain = "Gain";
const char *MJ_Strs::gain = "gain";

const char *MJ_Strs::inchannells = "inchannells";

const char *MJ_Strs::input = "input";

const char *MJ_Strs::Interval = "Interval";
const char *MJ_Strs::interval = "interval";

const char *MJ_Strs::instrument = "instrument";

const char *MJ_Strs::Loop  = "Loop";
const char *MJ_Strs::loop  = "loop";

const char *MJ_Strs::LADSPA_  = "LADSPA_";

const char *MJ_Strs::MIDI = "MIDI";
const char *MJ_Strs::MIDIdevice = "MIDI-device";
const char *MJ_Strs::MIDIInput = "MIDI input";
const char *MJ_Strs::MIDIOutput = "MIDI output";

const char *MJ_Strs::mode = "mode";

const char *MJ_Strs::MUSTAJUURI_FRAME_SIZE = "MUSTAJUURI_FRAME_SIZE";

const char *MJ_Strs::notecontrol = "notecontrol";
const char *MJ_Strs::noteoff = "noteoff";
const char *MJ_Strs::noteoffnow = "noteoffnow";
const char *MJ_Strs::noteon = "noteon";

const char *MJ_Strs::notes[12] = {
  "A",
  "Bb",
  "B",
  "C",
  "C#",
  "D",
  "D#",
  "E",
  "F",
  "F#",
  "G",
  "G#"
};

const char *MJ_Strs::outchannells = "outchannells";

const char *MJ_Strs::output = "output";

const char *MJ_Strs::overwrite = "overwrite";

const char *MJ_Strs::sample = "sample";

const char *MJ_Strs::Pan = "Pan";
const char *MJ_Strs::pan = "pan";

const char *MJ_Strs::Parameter = "Parameter";

const char *MJ_Strs::pitch = "pitch";

const char *MJ_Strs::pluginFactoryFunction = "MJ_createPlugin";
  
const char *MJ_Strs::wetratio = "wet-ratio";

const char *MJ_Strs::rate = "rate";

const char *MJ_Strs::Ratio = "Ratio";
const char *MJ_Strs::ratio = "ratio";

const char *MJ_Strs::sampleRate = "sampleRate";

const char *MJ_Strs::Slope = "Slope";

const char *MJ_Strs::tap = "tap";

const char *MJ_Strs::Tempo = "Tempo";
const char *MJ_Strs::tempo = "tempo";

const char *MJ_Strs::Threshold = "Threshold";
const char *MJ_Strs::threshold = "threshold";

const char *MJ_Strs::Time = "Time";
const char *MJ_Strs::time = "time";

