/* COPYRIGHT
 *
 * This file is part of Mustajuuri LGPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2004.
 * e-mail: firstname.lastname(at)hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. Extra clauses can be found from the file
 * MUSTAJUURI_LGPL and further explanations from the file
 * MUSTAJUURI_LICENSE. The license text can be found in file
 * "LGPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *    
 */

#include <mj_dsp_plugin_filters.h>
#include <mj_failure_diagnose.h>
#include <mj_filter_iir2.h>
#include <mj_filter_ap1.h>
#include <mj_gui_numeric.h>
#include <mj_int_remap.h>
#include <mj_led.h>
#include <mj_level_display.h>
#include <mj_malloc.h>
#include <mj_message_carrier.h>
#include <mj_math.h>
#include <mj_midi_sequence.h>
#include <mj_module_dsp.h>
#include <mj_module_rtaudio.h>
#include <mj_multi_int.h>
#include <mj_multi_sample.h>
#include <mj_parameter.h>
#include <mj_plugin_base.h>
#include <mj_plugin_db_tree.h>
#include <mj_ringbuffer.h>
#include <mj_rt_control.h>
#include <mj_slider.h>
#include <mj_undo_info.h>

#include <mj_arraytmpl.C>
#include <mj_vectortmpl.C>
#include <mj_listtmpl.C>

#include <qobject.h>


template class MJ_Array<char>;
template class MJ_Array<short>;
template class MJ_Array<int>;
template class MJ_Array<uint>;
template class MJ_Array<long>;
template class MJ_Array<ulong>;

template class MJ_Array<float>;
template class MJ_Vector<float>;
template class MJ_Vector2<float>;

template class MJ_Array<double>;
template class MJ_Vector<double>;
template class MJ_Vector2<double>;

template class MJ_Array<MJ_DualSample>;
template class MJ_Array<MJ_TriSample>;
template class MJ_Array<MJ_QuadSample>;

template class MJ_Array<MJ_2Int>;
template class QList<MJ_2Int>;
template class MJ_Array<MJ_3Int>;
template class QList<MJ_3Int>;


// template class MJ_Array<QString>;
template class MJ_Array<QString *>;
template class MJ_Array<MJ_GuiDoubleSlider>;
template class MJ_Array<MJ_Slider *>;
template class MJ_Array<MJ_SignalSink>;
template class MJ_Array<MJ_SignalSource>;
template class MJ_Array<MJ_ModuleDsp*>;
template class MJ_Array<MJ_ModuleRtAudio *>;
template class MJ_Array<MJ_MessageCarrier *>;

// Filters.
template class MJ_Array<MJ_RingBuffer2<float> >;
template class MJ_Array<MJ_FilterAP1<float> >;
/*template class MJ_Array<MJ_RingBuffer2<double> >;
  template class MJ_Array<MJ_FilterAP1<double> >;*/

template class MJ_Array<MJ_FilterIIR2<MJ_Sample> >;

template class MJ_Array<MJ_MidiTrack>;


template class MJ_List<MJ_SignalSourceDef>;

template class QList<MJ_Parameter>;

template class QList<MJ_IntRemap>;
template class MJ_List<MJ_IntRemap>;

template class QArray<MJ_LevelDisplay *>;

template class MJ_Array<void *>;
template class MJ_Array<QWidget *>;

template class QList<QObject>;
template class QList<QColor>;
template class QList<QString>;


template class QList<int>;
template class QList<double>;

template class QList<MJ_FailureDiagnose>;
template class QList<MJ_MessageCarrier>;
template class QList<MJ_MessageRemap>;
template class QList<MJ_Malloc::Unit>;
template class QList<MJ_ModuleDsp>;
template class QList<MJ_PluginDbTreeNode>;
template class QList<MJ_PluginDbeBase>;
template class QList<MJ_RtControl>;
template class QList<MJ_SignalSourceDef>;
template class QList<MJ_UndoInfo>;

template class QList<MJ_PluginFilter>;
