/* COPYRIGHT
 *
 * This file is part of Mustajuuri LGPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2004.
 * e-mail: firstname.lastname(at)hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. Extra clauses can be found from the file
 * MUSTAJUURI_LGPL and further explanations from the file
 * MUSTAJUURI_LICENSE. The license text can be found in file
 * "LGPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *    
 */

#include <qdatetime.h> 

#include <mj_cpu_count.h>

#include <mj_time_monitor.h>

MJ_TimeMonitor::MJ_TimeMonitor()
  : M_xpCpuTime(new MJ_CpuCount()),
    M_xpDateTime(new QTime()),
    M_fLoad(0.0)
{
  M_xpDateTime->start();
}
 
MJ_TimeMonitor::~MJ_TimeMonitor()
{
  if(M_xpCpuTime)  delete M_xpCpuTime;
  if(M_xpDateTime) delete M_xpDateTime;
}

void MJ_TimeMonitor::update()
{
  int iDateMS = M_xpDateTime->restart();
  M_xpCpuTime->update();
  int iCpuMS  = (int) M_xpCpuTime->cpuTimeDiffMS();

  if(!iDateMS) return;  // No division by zero.
  
  M_fLoad = (float) iCpuMS / (float) iDateMS;
}
