/* COPYRIGHT
 *
 * This file is part of Mustajuuri LGPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2004.
 * e-mail: firstname.lastname(at)hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. Extra clauses can be found from the file
 * MUSTAJUURI_LGPL and further explanations from the file
 * MUSTAJUURI_LICENSE. The license text can be found in file
 * "LGPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *    
 */

/* Miscellanous DSP-related template instantations.*/

#include <mj_math.h>
#include <mj_level_meter.h> 
#include <mj_multi_sample.h> 

#include <mj_filter_fir_tmpl.C>
#include <mj_filter_iir_tmpl.C>
#include <mj_filter_iir2_tmpl.C>
#include <mj_ringbuffertmpl.C> 

template class MJ_RingBuffer<float>;
template class MJ_RingBufferDelay<float>;
template class MJ_RingBuffer2<float>;

template class MJ_RingBuffer<double>;
template class MJ_RingBufferDelay<double>;
template class MJ_RingBuffer2<double>;

template class MJ_RingBuffer<ulong>;
template class MJ_RingBufferDelay<ulong>;
template class MJ_RingBuffer2<ulong>;

template class MJ_RingBuffer<int>;
template class MJ_RingBufferDelay<int>;
template class MJ_RingBuffer2<int>;

template class MJ_RingBuffer<MJ_DualSample>;
template class MJ_RingBufferDelay<MJ_DualSample>;

// FIR filters
template class MJ_FilterFIR<float>;
template class MJ_FilterFIR<double>;

// IIR filters
template class MJ_FilterDFII<float>;
template class MJ_FilterDFII<double>;

// Second order IIRs:
template class MJ_FilterIIR2<float>;
template class MJ_FilterIIR2<double>;

// Level meters:
template class MJ_LevelMeter<float>;
template class MJ_LevelMeter<double>;
