/* COPYRIGHT
 *
 * This file is part of Mustajuuri LGPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2004.
 * e-mail: firstname.lastname(at)hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. Extra clauses can be found from the file
 * MUSTAJUURI_LGPL and further explanations from the file
 * MUSTAJUURI_LICENSE. The license text can be found in file
 * "LGPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *    
 */


#include <mj_ringbuffermulti.h>


template <class T>
bool MJ_RingBufferMulti<T>::resize(uint newSize, uint channels)
{
  uint j = 1;
  while (j < newSize)
    j = j << 1;
  
  
  if(j == m_size) return true;

  if(m_line) delete [] m_line;
  
  if(!newSize) {
    m_line = 0;
    m_size = 0;
    m_mask = 0;
    m_channels = 0;
    return true;
  }

  m_line = new T[j * channels];

  if(!m_line) {
    m_size = 0;
    m_mask = 0;
    m_channels = 0;
    return false;
  }

  m_size = j;
  m_mask = m_size - 1;
  m_channels = channels;

  return true;
}
