/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of Mustajuuri GPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2004.
 * Tommi.Ilmonen(at)hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the General Public License (GPL),
 * versions 2. Extra clauses can be found from the file MUSTAJUURI_GPL
 * and further explanations from the file MUSTAJUURI_LICENSE. The
 * license text can be found in file "GPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *  
 */

#ifndef MJ_WAVE_OPERATIONS_H
#define MJ_WAVE_OPERATIONS_H

#include <di_io_defs.h>

#include <qstring.h>

class MJ_WaveOperations
{
public:

  enum Target {
    TmpFile,
    UserFile
  };

  static bool copySegment(const QString &oldFile, 
			  const QString &newFile, 
			  long firstFrame = 0, 
			  long lastFrame = -1,
			  Target target = UserFile,
			  DI_AudioSampleFormat preferFormat = DI_ASF_INT24);

};

#endif
