/* COPYRIGHT
 *
 * This file is part of Mustajuuri GPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2004.
 * e-mail: firstname.lastname(at)hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the General Public License (GPL),
 * versions 2. Extra clauses can be found from the file MUSTAJUURI_GPL
 * and further explanations from the file MUSTAJUURI_LICENSE. The
 * license text can be found in file "GPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *  
 */
/* -*- C++ -*- */

#ifndef MJ_MODULE_BYPASS_H
#define MJ_MODULE_BYPASS_H

#include <mj_module_dsp.h>

#include <mj_ringbuffer.h>

/** Prints any input signals to the screen. */
class MJ_ModuleBypass : public MJ_ModuleDsp
{

public:
  MJ_ModuleBypass();
  virtual ~MJ_ModuleBypass();

  virtual void dspProcessPeriod();
  
  static MJ_ModuleDsp *createNew();
protected:

  void bypassNN();
 // Smaller to bigger - for mono to stereo
  void bypassSB();
  // Bigger to smaller - for example stereo to mono
  void bypassBS(); 
};

#endif
