/* COPYRIGHT
 *
 * This file is part of Mustajuuri GPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2004.
 * e-mail: firstname.lastname(at)hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the General Public License (GPL),
 * versions 2. Extra clauses can be found from the file MUSTAJUURI_GPL
 * and further explanations from the file MUSTAJUURI_LICENSE. The
 * license text can be found in file "GPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *  
 */

#ifndef MJ_MODULE_COMPRESSOR_GUI_H
#define MJ_MODULE_COMPRESSOR_GUI_H

#include <mj_level_display.h>
#include <mj_module_dsp.h>
#include <mj_module_dsp_gui_default.h>

#include <qtimer.h> 

class MJ_LevelDisplay;

class MJ_ModuleCompressorGui : public MJ_ModuleDspGuiPostCard
{
  Q_OBJECT

public:
  MJ_ModuleCompressorGui(MJ_RtControl *rtparent,
			 MJ_ModuleDsp *module,
			 QWidget      *parent = 0,
			 const char   *name = 0);

  virtual ~MJ_ModuleCompressorGui();

  static MJ_ModuleDspGui *createNew(MJ_RtControl *rtparent,
				    MJ_ModuleDsp *module,
				    QWidget *parent, 
				    const char *name);
public slots:

  void update();

protected:
  virtual void realTimeChange (bool nowRt); 
  
  MJ_Array<float> m_gains;

  MJ_LevelDisplay          *m_ldpy;

  QTimer m_timer;
};

#endif
