/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of Mustajuuri GPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2004.
 * e-mail: firstname.lastname(at)hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the General Public License (GPL),
 * versions 2. Extra clauses can be found from the file MUSTAJUURI_GPL
 * and further explanations from the file MUSTAJUURI_LICENSE. The
 * license text can be found in file "GPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *  
 */

#ifndef MJ_MODULE_DSP_GROUP_H
#define MJ_MODULE_DSP_GROUP_H

#include <mj_module_dsp_array.h>

/** Utility class for DSP-modules with internal modules. */

class MJ_ModuleDspGroup : public MJ_ModuleDspArray
{

public:

  MJ_ModuleDspGroup();
  virtual ~MJ_ModuleDspGroup();
  
  // MJ_ModuleDsp *findModule(const char * id);

  virtual bool dspSetTimer(MJ_TimeStamp *t);
  
  // virtual bool dspPrepare();
  /* virtual bool dspPrepareFast();
  virtual void dspProcessPeriod();
  virtual bool dspStopFast();
  virtual bool dspStop(); */

  // virtual void getChildren(QList<MJ_ModuleDsp> &l, bool recursive);

  bool writeParameters(QTextStream *s);
  bool readParameters(QTextStream *s);

  /* void addModule(MJ_ModuleDsp *, bool append);
  void appendModule(MJ_ModuleDsp *);
  void prependModule(MJ_ModuleDsp *);
  void removeModule(MJ_ModuleDsp *);

  QCString allocateId(); */

  /// Run in non-threaded non-interactive mode for some time.
  void runShort(int rounds = 5000);

  static bool *groupDebug() { return & m_groupDebug; }
protected:
  
  void clearTimer();
  
  bool                     m_myTimer;

  static bool m_groupDebug;
};

#endif
