/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of Mustajuuri GPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2004.
 * e-mail: firstname.lastname(at)hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the General Public License (GPL),
 * versions 2. Extra clauses can be found from the file MUSTAJUURI_GPL
 * and further explanations from the file MUSTAJUURI_LICENSE. The
 * license text can be found in file "GPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *  
 */

#ifndef MJ_MODULE_DSP_ROW_H
#define MJ_MODULE_DSP_ROW_H

#include <mj_module_dsp_group.h>


/** A row of signal processing modules. */
class MJ_ModuleDspRow : public MJ_ModuleDspGroup
{
public:

  ///
  MJ_ModuleDspRow();

  ///
  virtual ~MJ_ModuleDspRow();

  virtual MJ_ModuleDspTui *newTui(MJ_RtControl *parent = 0,
				  const char *name = 0);
  
  /** Connect modules according to certain internal logic. 
      
      It tries to connect both audio and event signals to all
      modules.  */
  void connectModules();

  /// Create a test row.
  void testRow(int i = 0);
  /// Create a benchmark setup
  void benchMark(int sources, int version);

  void playbackRow();

  static void test();
  static void runBenchmark(int modules, int framesSize, int samples = 88200,
			   int version = 0);

protected:
  
  void clearTimer();
  
  // Tries to optimize the modules
  // void sort();

  bool                     m_myTimer;

  static bool m_rowDebug;
};



#endif
