/* COPYRIGHT
 *
 * This file is part of Mustajuuri GPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2004.
 * e-mail: firstname.lastname(at)hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the General Public License (GPL),
 * versions 2. Extra clauses can be found from the file MUSTAJUURI_GPL
 * and further explanations from the file MUSTAJUURI_LICENSE. The
 * license text can be found in file "GPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *  
 */

#ifndef MJ_MODULE_DSP_ROW_GUI_H
#define MJ_MODULE_DSP_ROW_GUI_H

#include <mj_module_dsp_row.h>

#include <mj_int_remap.h>

#include <mj_module_dsp_gui.h>
#include <mj_undo_center.h>

class QVBoxLayout;
class QPopupMenu;

/** Gui for MJ_ModuleDspRow. @see MJ_ModuleDspRow */
class MJ_ModuleDspRow_QG : public MJ_ModuleDspGui
{
  Q_OBJECT
public:
  MJ_ModuleDspRow_QG(MJ_RtControl *rtparent,
		     MJ_ModuleDsp *module,
		     QWidget      *parent = 0,
		     const char   *name = 0);
  

  virtual ~MJ_ModuleDspRow_QG();

  static void test(QApplication *xpQA, int iArgc, char **cppArgv);

  static MJ_ModuleDspGui *createNew(MJ_RtControl *rtparent,
				    MJ_ModuleDsp *module,
				    QWidget *parent, 
				    const char *name);

public slots:
  void runShort();
  void runShort2();
  void stopShort2();
  void writeCout();
  void saveAs();

  void startThreaded();
  void stopThreaded();

  void newModule(const QString &);

  void setTestMode(bool test) { m_testMode = test; }

protected:
  void draw();

  void append(MJ_ModuleDsp *);

  QVBoxLayout     *m_layout;
  
  MJ_ModuleDspRow *m_dspRow;
  
  QPopupMenu      *m_edit;

  bool             m_testMode;

  MJ_UndoCenter    m_undoControl;
};

#endif
