/* COPYRIGHT
 *
 * This file is part of Mustajuuri GPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2004.
 * e-mail: firstname.lastname(at)hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the General Public License (GPL),
 * versions 2. Extra clauses can be found from the file MUSTAJUURI_GPL
 * and further explanations from the file MUSTAJUURI_LICENSE. The
 * license text can be found in file "GPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *  
 */

#ifndef MJ_MODULE_DSP_ROW_TUI_H
#define MJ_MODULE_DSP_ROW_TUI_H

#include <mj_module_dsp_row.h>
#include <mj_module_dsp_tui_default.h>

enum MJ_DspRowTuiCommand {
  MJ_DRT_APPEND_MODULE,
  MJ_DRT_EDIT_MODULE,
  MJ_DRT_LOAD,
  MJ_DRT_PANIC,
  MJ_DRT_SAVE,
  MJ_DRT_START,
  MJ_DRT_STOP,
  MJ_DRT_UP,
  MJ_DRT_SIZEOF  
};

extern const char * MJ_DspRowTuiCommandKeys[MJ_DRT_SIZEOF];

/** Command-line TUI for MJ_ModuleDspRow. @see MJ_ModuleDspRow */
class MJ_ModuleDspRow_CT : public MJ_ModuleDspTuiDefault
{
  Q_OBJECT
public:
  MJ_ModuleDspRow_CT(MJ_RtControl *rtparent,
		     MJ_ModuleDsp *module,
		     const char *name = 0);
  
  virtual ~MJ_ModuleDspRow_CT();
  
protected:

  bool doEvent();

  void describeRow();
  void appendModule();
  void panic();
  void edit();

  MJ_ModuleDspRow *m_dspRow;
};


#endif
