/* COPYRIGHT
 *
 * This file is part of Mustajuuri GPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2004.
 * e-mail: firstname.lastname(at)hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the General Public License (GPL),
 * versions 2. Extra clauses can be found from the file MUSTAJUURI_GPL
 * and further explanations from the file MUSTAJUURI_LICENSE. The
 * license text can be found in file "GPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *  
 */

#ifndef MJ_MODULE_GAIN_MULTI_H
#define MJ_MODULE_GAIN_MULTI_H

// Include necessary definitions:
#include <mj_module_dsp.h>

#include <mj_ramp.h>

#include <vector>

/** This plugin controls signal volume. It simply multiplies signal
    values with given coefficient.
   
 */
class MJ_ModuleGainMulti : public MJ_ModuleDsp
{
public:
  MJ_ModuleGainMulti();
  virtual ~MJ_ModuleGainMulti();

  virtual bool dspPrepare();
  virtual void dspProcessPeriod();

  virtual bool msgProcess(const char *, MJ_Message *);
  virtual MJ_Parameter * msgGetInput(const char *);
  virtual QCString msgGetInputName(int);

  static bool *debugPtr() { return & m_debug; }

  void expand(uint chans);

protected:

  std::vector<MJ_Ramp<MJ_Sample> > m_gains;

  static bool m_debug;
};

#endif
