/* COPYRIGHT
 *
 * This file is part of Mustajuuri GPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2004.
 * e-mail: firstname.lastname(at)hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the General Public License (GPL),
 * versions 2. Extra clauses can be found from the file MUSTAJUURI_GPL
 * and further explanations from the file MUSTAJUURI_LICENSE. The
 * license text can be found in file "GPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *  
 */

#ifndef MJ_MODULE_IMPULSE_H
#define MJ_MODULE_IMPULSE_H

#include <mj_module_dsp.h>
#include <mj_module_dsp_gui.h>

/** Impulse generator. Modules of this kind generate single impulses
    as requested. */

class MJ_ModuleImpulse: public MJ_ModuleDsp
{
public:
  MJ_ModuleImpulse();
  virtual ~MJ_ModuleImpulse();
  
  virtual bool dspPrepare();
  virtual void dspProcessPeriod();

  void impulse(long sample = 0);

protected:
  long m_impulseTime;

};

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////

/// GUI for MJ_ModuleImpulse
class MJ_ModuleImpulse_QG : public MJ_ModuleDspGui
{
  Q_OBJECT

public:
  MJ_ModuleImpulse_QG(MJ_RtControl *rtparent,
		      MJ_ModuleDsp *module,
		      QWidget      *parent = 0,
		      const char   *name = 0);

  virtual ~MJ_ModuleImpulse_QG();

  static MJ_ModuleDspGui *createNew(MJ_RtControl *rtparent,
				    MJ_ModuleDsp *module,
				    QWidget *parent, 
				    const char *name);

public slots:

  void impulse();

protected:

  void draw();
};

#endif
