/* COPYRIGHT
 *
 * This file is part of Mustajuuri GPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2004.
 * e-mail: firstname.lastname(at)hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the General Public License (GPL),
 * versions 2. Extra clauses can be found from the file MUSTAJUURI_GPL
 * and further explanations from the file MUSTAJUURI_LICENSE. The
 * license text can be found in file "GPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *  
 */


#ifndef MJ_MODULE_IMPULSETRAIN_H
#define MJ_MODULE_IMPULSETRAIN_H

#include <mj_module_dsp.h>

#include <mj_ringbuffer.h>

/** Impulse train. Impulses are output in frequent intervals. */

class MJ_ModuleImpulseTrain : public MJ_ModuleDsp
{


public:

  MJ_ModuleImpulseTrain();
  virtual ~MJ_ModuleImpulseTrain();

  virtual bool dspPrepare();
  virtual void dspProcessPeriod();

  void setHz(double freq);

  void setInterval(ulong interval_samples)
  { 
    m_interval = interval_samples; 
    if(m_counter > m_interval) m_counter = m_interval;
  }

  virtual bool msgProcess(const char *, MJ_Message *);
  virtual MJ_Parameter * msgGetInput(const char *);
  virtual QCString msgGetInputName(int);

protected:

  ulong  m_interval;
  ulong  m_counter;
  float  m_amplitude;
};

#endif
