/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of Mustajuuri GPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2004.
 * e-mail: firstname.lastname(at)hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the General Public License (GPL),
 * versions 2. Extra clauses can be found from the file MUSTAJUURI_GPL
 * and further explanations from the file MUSTAJUURI_LICENSE. The
 * license text can be found in file "GPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *  
 */

#ifndef MJ_MODULE_MIXER_BUS_H
#define MJ_MODULE_MIXER_BUS_H

#include <mj_module_wsum.h>


/** Struct containing two integers and one sample. */
struct MJ_IntIntSample {
  int m_i1;
  int m_i2;
  MJ_Sample m_s;
};

/** The DSP module that is used as a mixer bus. */

class MJ_ModuleMixerBus : public MJ_ModuleWeightedSum
{
public:
  MJ_ModuleMixerBus();
  virtual ~MJ_ModuleMixerBus();

  virtual bool dspPrepare();
  virtual void dspProcessPeriod();

  void clearMappings();

  void addMapping(const char *sourceId, 
		  int sourceChannel,
		  int targetOutput,
		  MJ_Sample gain);
  
  bool checkChannelRanges();
  virtual bool writeParameters(QTextStream *s);
  virtual bool readParameters(QTextStream *s);

protected:

  void formArray();

  QList<MJ_IntIntSample>    m_mappingDefs;
  MJ_Array<MJ_IntIntSample> m_mappings;
};

#endif
