/* COPYRIGHT
 *
 * This file is part of Mustajuuri GPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2004.
 * e-mail: firstname.lastname(at)hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the General Public License (GPL),
 * versions 2. Extra clauses can be found from the file MUSTAJUURI_GPL
 * and further explanations from the file MUSTAJUURI_LICENSE. The
 * license text can be found in file "GPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *  
 */

#ifndef MJ_MODULE_MONODELAY_H
#define MJ_MODULE_MONODELAY_H

#include <mj_module_dsp.h>
#include <mj_ringbuffer.h>

/** Monophonic delay line. This is a very simple plugin. */
class MJ_ModuleMonoDelay : public MJ_ModuleDsp
{
public:

  MJ_ModuleMonoDelay();
  virtual ~MJ_ModuleMonoDelay();

  virtual bool dspPrepare();
  virtual void dspProcessPeriod();

  virtual bool msgProcess(const char *, MJ_Message *);
  virtual MJ_Parameter * msgGetInput(const char *);
  virtual QCString msgGetInputName(int);

  static void testTui(int argc, char **argv);
protected:

  MJ_RingBuffer2<float> m_delayBuffer;
  float                 m_time; // Samples.
  float                 m_wetRatio;
  float                 m_dryRatio;
  float                 m_feedBack;
};

#endif
