/* COPYRIGHT
 *
 * This file is part of Mustajuuri GPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2004.
 * e-mail: firstname.lastname(at)hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the General Public License (GPL),
 * versions 2. Extra clauses can be found from the file MUSTAJUURI_GPL
 * and further explanations from the file MUSTAJUURI_LICENSE. The
 * license text can be found in file "GPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *  
 */

#ifndef MJ_MODULE_NOISE_H
#define MJ_MODULE_NOISE_H

#include <mj_module_dsp.h>

#include <mj_random.h>

/** White noise source. */

class MJ_ModuleNoise : public MJ_ModuleDsp
{
public:
  MJ_ModuleNoise();
  virtual ~MJ_ModuleNoise();

  virtual bool dspPrepare();
  virtual void dspProcessPeriod();
  
protected:

  /// Random number generator.
  MJ_Random m_random;
  static bool m_debug;
};

#endif
