/* COPYRIGHT
 *
 * This file is part of Mustajuuri GPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2004.
 * e-mail: firstname.lastname(at)hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the General Public License (GPL),
 * versions 2. Extra clauses can be found from the file MUSTAJUURI_GPL
 * and further explanations from the file MUSTAJUURI_LICENSE. The
 * license text can be found in file "GPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *  
 */

#ifndef MJ_MODULE_STEREOPAN_H
#define MJ_MODULE_STEREOPAN_H

#include <mj_module_dsp.h>

/** Stereo panner. */
class MJ_ModuleStereoPan : public MJ_ModuleDsp
{
public:
  MJ_ModuleStereoPan();
  virtual ~MJ_ModuleStereoPan();

  bool dspPrepare();
  virtual void dspProcessPeriod();
  
  virtual bool msgProcess(const char *, MJ_Message *);
  virtual MJ_Parameter * msgGetInput(const char *);
  virtual QCString msgGetInputName(int);

  MJ_Sample getPan() const 
  { return -1.0 * m_targetGains[0] + 1.0 * m_targetGains[1]; }

  void setPan(MJ_Sample);

protected:

  void targetToCurr()
  { m_gains[0] = m_targetGains[0]; m_gains[1] = m_targetGains[1]; }

  /** Gain coefficients. The actual pan value is not stored at any
      time. One must access this variable to determine current
      panning.*/

  MJ_Sample m_gains[2];

  long      m_targetTime;  
  MJ_Sample m_targetGains[2];

  static bool m_debug;
};

#endif
