/* COPYRIGHT
 *
 * This file is part of Mustajuuri GPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2004.
 * e-mail: firstname.lastname(at)hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the General Public License (GPL),
 * versions 2. Extra clauses can be found from the file MUSTAJUURI_GPL
 * and further explanations from the file MUSTAJUURI_LICENSE. The
 * license text can be found in file "GPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *  
 */

#include <mj_rect_layout.h>


MJ_RectLayout::MJ_RectLayout()
  : m_objSize(140, 60),
    m_objSpacing(12, 8)
{}

QRect MJ_RectLayout::calculateGeometry(int row, int col)
{
  int x = m_objSpacing.width() * (col + 1) + 
    m_objSize.width() * col;
  int y = m_objSpacing.height() * (row + 1) + 
    m_objSize.height() * row;

  return QRect(QPoint(x, y), m_objSize);
}

QSize MJ_RectLayout::calculateSize(int rows, int cols)
{
  int width = m_objSpacing.width() * (cols + 1) + 
    m_objSize.width() * cols;
  int height = m_objSpacing.height() * (rows + 1) + 
    m_objSize.height() * rows;
  
  return QSize(width, height);
}
