/* COPYRIGHT
 *
 * This file is part of Mustajuuri LGPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2001.
 * Tommi.Ilmonen@hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. Extra clauses can be found from the file
 * MUSTAJUURI_LGPL and further explanations from the file
 * MUSTAJUURI_LICENSE. The license text can be found in file
 * "LGPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *    
 */

#include <mj_dom.h>

void MJ_addTextChild(QDomElement &base, QDomDocument &doc,
		     const QString &tag,  const QString &value)
{
  QDomElement si = doc.createElement(tag);
  si.appendChild(doc.createTextNode(value));
  base.appendChild(si);
}

void MJ_addTextChild(QDomElement &base, QDomDocument &doc,
		     const QString &tag,  int value)
{
  MJ_addTextChild(base, doc, tag, QString().setNum(value));
}

void MJ_addTextChild(QDomElement &base, QDomDocument &doc,
		     const QString &tag,  double value)
{
  MJ_addTextChild(base, doc, tag, QString().setNum(value));
}

double  MJ_getDouble(QDomElement &e, const QString &tag, double def)
{
  QDomNode c = e.namedItem(tag);

  QDomText t = c.toElement().firstChild().toText();

  bool ok = true;

  double val = t.data().toDouble(&ok);

  return ok ? val : def;
}

int MJ_getInt(QDomElement &e, const QString &tag, int def)
{
  QDomNode c = e.namedItem(tag);

  QDomText t = c.toElement().firstChild().toText();

  bool ok = true;

  int val = t.data().toInt(&ok);

  return ok ? val : def;
}
