/* COPYRIGHT
 *
 * This file is part of Mustajuuri LGPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2001.
 * Tommi.Ilmonen@hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. Extra clauses can be found from the file
 * MUSTAJUURI_LGPL and further explanations from the file
 * MUSTAJUURI_LICENSE. The license text can be found in file
 * "LGPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *    
 */

#ifndef MJ_DOM_H
#define MJ_DOM_H

#include <mj_config.h>

#include <qdom.h>

void MJ_addTextChild(QDomElement &, QDomDocument &doc,
		     const QString &tag,  const QString &value);
void MJ_addTextChild(QDomElement &, QDomDocument &doc,
		     const QString &tag,  int value);
void MJ_addTextChild(QDomElement &, QDomDocument &doc,
		     const QString &tag,  double value);

double           MJ_getDouble(QDomElement &, const QString &tag, 
			      double def=0.0f);
int              MJ_getInt(QDomElement &, const QString &tag, int def=0);


#endif
