/* COPYRIGHT
 *
 * This file is part of Mustajuuri LGPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2001.
 * Tommi.Ilmonen@hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. Extra clauses can be found from the file
 * MUSTAJUURI_LGPL and further explanations from the file
 * MUSTAJUURI_LICENSE. The license text can be found in file
 * "LGPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *    
 */

#include <mj_graphic.h>

#include <mj_graphics_context.h>

MJ_Graphic::MJ_Graphic()
  : m_id(-1),
    m_widget(0),
    m_gc(0)
{}

MJ_Graphic::~MJ_Graphic()
{
  if(m_gc) delete m_gc;
}

void MJ_Graphic::setGraphicsContext(MJ_GraphicsContext *gc, bool deleteOld)
{
  if((m_gc != 0) && deleteOld) delete m_gc;
  m_gc = gc;
}
