/* COPYRIGHT
 *
 * This file is part of Mustajuuri LGPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2001.
 * Tommi.Ilmonen@hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. Extra clauses can be found from the file
 * MUSTAJUURI_LGPL and further explanations from the file
 * MUSTAJUURI_LICENSE. The license text can be found in file
 * "LGPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *    
 */

#ifndef MJ_GRAPHIC_ELLIPSE_H
#define MJ_GRAPHIC_ELLIPSE_H

#include <mj_graphic_polygon.h>

#include <mj_point_array.h>

/** Ellipse graphic object. */

class MJ_GraphicEllipse : public MJ_GraphicPolygon
{
public:
  MJ_GraphicEllipse(float left, float bottom, 
		    float right, float top, 
		    int segments = 30);
  MJ_GraphicEllipse();

  virtual ~MJ_GraphicEllipse();
  
  void setEllipse(float left, float bottom, 
		  float right, float top, 
		  int segments = 30);

protected:
  float m_rect[4];
};

#endif
