/* COPYRIGHT
 *
 * This file is part of Mustajuuri LGPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2001.
 * Tommi.Ilmonen@hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. Extra clauses can be found from the file
 * MUSTAJUURI_LGPL and further explanations from the file
 * MUSTAJUURI_LICENSE. The license text can be found in file
 * "LGPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *    
 */

#include <mj_graphic_polyline.h>

#include <mj_painter.h>

#include <qwidget.h>

MJ_GraphicPolyLine::MJ_GraphicPolyLine(const QMemArray<float> &points)
{
  setGraph(points);
}

MJ_GraphicPolyLine::MJ_GraphicPolyLine()
{}

MJ_GraphicPolyLine::~MJ_GraphicPolyLine()
{}
  
void MJ_GraphicPolyLine::render(MJ_Painter *p)
{
  if(m_points.size())
    p->drawPolyline(m_points);
}

void MJ_GraphicPolyLine::unrender(MJ_Painter *p)
{
  render(p);
}

/** Set the control (corner) points. The number of array elements must
    be 2*n where n is integer greater than one. */
  
void MJ_GraphicPolyLine::setGraph(const QArray<float> &points)
{ 
  uint s = points.size();
  
  if(s & 1 || s < 4)
    qDebug("MJ_GraphicPolyLine::setGraph : Bad size");  
  
  m_points.qarray() = points; 
}
