/* COPYRIGHT
 *
 * This file is part of Mustajuuri LGPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2001.
 * Tommi.Ilmonen@hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. Extra clauses can be found from the file
 * MUSTAJUURI_LGPL and further explanations from the file
 * MUSTAJUURI_LICENSE. The license text can be found in file
 * "LGPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *    
 */

#ifndef MJ_GRAPHIC_POLYLINE_H
#define MJ_GRAPHIC_POLYLINE_H

#include <mj_graphic.h>

#include <mj_point_array.h>

/** Polyline graphic object. */

class MJ_GraphicPolyLine : public MJ_Graphic
{
public:
  MJ_GraphicPolyLine(const QMemArray<float> &points);
  MJ_GraphicPolyLine();
  virtual ~MJ_GraphicPolyLine();
  
  virtual void render(MJ_Painter *);
  virtual void unrender(MJ_Painter *);
  
  void setGraph(const QMemArray<float> &points);
  
  MJ_PointArray2D & points() { return m_points; }

protected:
  MJ_PointArray2D m_points;
};

#endif
