/* COPYRIGHT
 *
 * This file is part of Mustajuuri LGPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2001.
 * Tommi.Ilmonen@hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. Extra clauses can be found from the file
 * MUSTAJUURI_LGPL and further explanations from the file
 * MUSTAJUURI_LICENSE. The license text can be found in file
 * "LGPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *    
 */

#include <mj_graphic_text.h>

#include <mj_painter.h>


MJ_GraphicText::MJ_GraphicText(const QString &str, float x, float y)
  : m_str(str),
    m_x(x),
    m_y(y)
{}

MJ_GraphicText::~MJ_GraphicText()
{}
  
void MJ_GraphicText::render(MJ_Painter *p)
{
  float x, y;

  p->applyTransform(m_x, m_y, &x, &y);

  int xi((int) x), yi((int) y);

  p->qpainter().drawText(xi - 500, yi - 500, 1000, 1000, 
			 Qt::AlignCenter, m_str);
}

void MJ_GraphicText::unrender(MJ_Painter *p)
{
  render(p);
}
 
