/* COPYRIGHT
 *
 * This file is part of Mustajuuri LGPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2001.
 * Tommi.Ilmonen@hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. Extra clauses can be found from the file
 * MUSTAJUURI_LGPL and further explanations from the file
 * MUSTAJUURI_LICENSE. The license text can be found in file
 * "LGPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *    
 */


#ifndef MJ_GRAPHIC_TEXT_H
#define MJ_GRAPHIC_TEXT_H

#include <mj_graphic.h>

#include <qstring.h>

/** Polyline graphic object. */

class MJ_GraphicText : public MJ_Graphic
{
public:
  MJ_GraphicText(const QString &str = QString::null, 
		 float x = 0.0, float y = 0.0);
  virtual ~MJ_GraphicText();
  
  virtual void render(MJ_Painter *);
  virtual void unrender(MJ_Painter *);

  void setText(const QString &str) { m_str = str; }
 
protected:
  QString m_str;
  float   m_x, m_y;
};

#endif
