/* COPYRIGHT
 *
 * This file is part of Mustajuuri LGPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2001.
 * Tommi.Ilmonen@hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. Extra clauses can be found from the file
 * MUSTAJUURI_LGPL and further explanations from the file
 * MUSTAJUURI_LICENSE. The license text can be found in file
 * "LGPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *    
 */

#ifndef MJ_GRAPHICS_CONTEXT_H
#define MJ_GRAPHICS_CONTEXT_H

class QPainter;

/** Graphics context for MJ_GraphicsArea. */

class MJ_GraphicsContext
{
public:
  MJ_GraphicsContext() {}
  virtual ~MJ_GraphicsContext();

  /** Apply this context to the painter. */
  virtual void apply(QPainter *) = 0;
  /** Clone this graphics context. */
  virtual MJ_GraphicsContext * clone() = 0;

protected:

};

#endif
