/* COPYRIGHT
 *
 * This file is part of Mustajuuri LGPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2001.
 * Tommi.Ilmonen@hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. Extra clauses can be found from the file
 * MUSTAJUURI_LGPL and further explanations from the file
 * MUSTAJUURI_LICENSE. The license text can be found in file
 * "LGPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *    
 */

#include <mj_graphics_context_simple.h>

#include <qpainter.h> 

MJ_GraphicsContextPen::MJ_GraphicsContextPen()
{}

MJ_GraphicsContextPen::MJ_GraphicsContextPen(const QPen &p)
  : m_pen(p)
{}

MJ_GraphicsContextPen::~MJ_GraphicsContextPen()
{}

void MJ_GraphicsContextPen::apply(QPainter *p)
{
  p->setPen(m_pen);
}

MJ_GraphicsContext * MJ_GraphicsContextPen::clone()
{
  return new MJ_GraphicsContextPen(*this);
}

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////


MJ_GraphicsContextPenBrush::MJ_GraphicsContextPenBrush() {}

MJ_GraphicsContextPenBrush::MJ_GraphicsContextPenBrush
(const QPen &pen, const QBrush &brush)
  : m_pen(pen), m_brush(brush)
{}

MJ_GraphicsContextPenBrush::~MJ_GraphicsContextPenBrush()
{}

void MJ_GraphicsContextPenBrush::apply(QPainter *p)
{
  p->setPen(m_pen);
  p->setBrush(m_brush);
}

MJ_GraphicsContext * MJ_GraphicsContextPenBrush::clone()
{
  return new MJ_GraphicsContextPenBrush(*this);
}
