/* COPYRIGHT
 *
 * This file is part of Mustajuuri LGPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2001.
 * Tommi.Ilmonen@hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. Extra clauses can be found from the file
 * MUSTAJUURI_LGPL and further explanations from the file
 * MUSTAJUURI_LICENSE. The license text can be found in file
 * "LGPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *    
 */


#include <qlayout.h> 
#include <qwidget.h> 

// #include <typeinfo>

/** Limit the minimum size of a widget. The size hint of the widget is
    used to set the size. */

void MJ_limMinSize(QWidget *xpW, float scale, int iAddPixels)
{
  /// CPF(xpW);
  QSize s1(xpW->sizeHint() * scale);
  QSize s2(iAddPixels, iAddPixels);
  
  xpW->setMinimumSize(s1 + s2);

  // qDebug("MJ_limMinSize # %s %d %d", typeid(*xpW).name(), s1.width(), s1.height());
}

/** Limit the maximum size of a widget. The size hint of the widget is
    used to set the size. */

void MJ_limMaxSize(QWidget *xpW, float fScale, int iAddPixels)
{
  /// CPF(xpW);
  xpW->setMaximumSize(xpW->sizeHint() * fScale + 
		      QSize(iAddPixels, iAddPixels));
}

/** Limit the minimum and maximum size of a widget. The size hint of
    the widget is used to set the size. */

void MJ_limSize(QWidget *xpW, float fScale, int iAddPixels)
{
  MJ_limMinSize(xpW, fScale, iAddPixels);
  MJ_limMaxSize(xpW, fScale, iAddPixels);
}

/** Sets the row and column streches of the QGridLayout layout to some
    constants.*/

void MJ_equalStretch(QGridLayout *xpGrid, int iRowStretch, int iColStretch)
{
  int i;

  for(i=0; i < xpGrid->numRows(); i++) 
    xpGrid->setRowStretch(i, iRowStretch);
  
  for(i=0; i < xpGrid->numCols(); i++) 
    xpGrid->setColStretch(i, iColStretch);
}


/* void MJ_addLabel(QWidget *parent, QGridLayout *l, const QString &text)
{
  
}*/ 
