/* COPYRIGHT
 *
 * This file is part of Mustajuuri LGPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2001.
 * Tommi.Ilmonen@hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. Extra clauses can be found from the file
 * MUSTAJUURI_LGPL and further explanations from the file
 * MUSTAJUURI_LICENSE. The license text can be found in file
 * "LGPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *    
 */

#include <mj_has_id.h>
#include <di_types.h>
#include <stdlib.h>
#include <string.h>

MJ_HasId::MJ_HasId()
  : m_id(0)
{}

MJ_HasId::~MJ_HasId()
{
  if(m_id) free(m_id);
}

void MJ_HasId::setId(const char *id)
{
  if(m_id) free(m_id);

  if(id) m_id = strdup(id);
  else m_id = 0;
}
