/* COPYRIGHT
 *
 * This file is part of Mustajuuri LGPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2001.
 * Tommi.Ilmonen@hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. Extra clauses can be found from the file
 * MUSTAJUURI_LGPL and further explanations from the file
 * MUSTAJUURI_LICENSE. The license text can be found in file
 * "LGPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *    
 */

#ifndef MJ_HEADER_LABEL_H
#define MJ_HEADER_LABEL_H

#include <qlabel.h>

/** Header label for module guis. This is basically a QLabel with
    additional twist - it can be clicked if enabled. It also changes
    its look to suit the click-mode. */

class MJ_HeaderLabel : public QLabel
{
  Q_OBJECT
public:
  MJ_HeaderLabel(QWidget      *parent = 0,
		 const char   *name = 0);

  virtual ~MJ_HeaderLabel();
  
  void enableClicking(bool b);

  const QFont & defaultFont() { return m_defaultFont; }

signals:
  void pressed();
protected:
  virtual void mousePressEvent(QMouseEvent *);

  bool   m_enaClicks;
  QFont  m_defaultFont;
};


#endif
