/* COPYRIGHT
 *
 * This file is part of Mustajuuri LGPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2001.
 * Tommi.Ilmonen@hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. Extra clauses can be found from the file
 * MUSTAJUURI_LGPL and further explanations from the file
 * MUSTAJUURI_LICENSE. The license text can be found in file
 * "LGPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *    
 */

#ifndef MJ_LEDROW_H
#define MJ_LEDROW_H

#include <mj_led.h>

/** A row of leds. 

    @see MJ_Led

 */
class MJ_LedRow : public QWidget
{
  Q_OBJECT

public:

  MJ_LedRow(int          iLeds,
	    bool         bHorizontal = true,
	    QWidget      *xpParent=0, 
	    const char   *cpName=0);

  virtual ~MJ_LedRow();

  /// Set size of a led
  void setLedSize(const QSize &);

  /// Chose led shape
  void chooseLedShape(int);
  
  /// Return a particular led.
  MJ_Led *getLed(int iLed) { return M_xLeds.at(iLed); }

public slots:

  /// Activates all led until the argument value.
  void activeTo(int);

protected:

  void createLeds(int, bool);

  QList<MJ_Led> M_xLeds;
};

#endif
