/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of Mustajuuri LGPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2001.
 * Tommi.Ilmonen@hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. Extra clauses can be found from the file
 * MUSTAJUURI_LGPL and further explanations from the file
 * MUSTAJUURI_LICENSE. The license text can be found in file
 * "LGPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *    
 */

#ifndef MJ_STR_REMAP_H
#define MJ_STR_REMAP_H

#include <qobject.h>
#include <qstring.h>

/** Transform "void" signals to "const QString &" signals. Objects of
    this type are used to "add" string data to an other call */
class MJ_StrRemap : public  QObject
{
  Q_OBJECT
public:
  MJ_StrRemap(QObject *parent, const QString &id = QString::null)
    : QObject(parent), m_id(id) {}
  MJ_StrRemap(const QString &i="") : m_id(i.copy()) {}
  virtual ~MJ_StrRemap();
  
  void setId(const QString & i) { m_id = i; }
  const QString & id() const { return m_id; }

public slots:
  /// emits "emitCall(m_id)"
  void call() { emit emitCall(m_id); }

signals: 
  void emitCall(const QString &); 

protected:
  QString m_id;
};

#endif
