/* COPYRIGHT
 *
 * This file is part of Mustajuuri.
 *
 * Author: Tommi Ilmonen, 1999-2001.
 * Tommi.Ilmonen@hut.fi
 *
 * http://www.tcm.hut.fi/~tilmonen/mustajuuri/
 *
 * Mustajuuri is licensed under GNU Lesser General Public License
 * (LGPL). The LGPL conditions can be found in file "LGPL" that is
 * distributed with this source package. The Mustajuuri license
 * interpretation that further clarifes LGPL can be found in file
 * "MUSTAJUURI_LICENSE" that is distributed with the Mustajuuri source code.
 *    
 */

#include "mj_knob_test.h"
#include "mj_knob.h"

#include <qapplication.h>


void MJ_DoublePrinter::print(double d)
{
  qDebug("%f", d);
}

void MJ_testKnob(QApplication *qa)
{
  MJ_Knob knob;
  MJ_DoublePrinter dp;

  knob.connect(&knob, SIGNAL(emitValue(double)), &dp, SLOT(print(double)));
  
  qa->setMainWidget(&knob);
  knob.show();
  qa->exec();
}
