/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of Mustajuuri GPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2004.
 * e-mail: firstname.lastname(at)hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the General Public License (GPL),
 * versions 2. Extra clauses can be found from the file MUSTAJUURI_GPL
 * and further explanations from the file MUSTAJUURI_LICENSE. The
 * license text can be found in file "GPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *  
 */

#ifndef MJ_AUCTRL_SOCKET_MANAGER
#define MJ_AUCTRL_SOCKET_MANAGER

#include <mj_app_action.h>

#include <di_socket.h>

#include <qstring.h>

class MJ_ModuleAuCtrl;

class MJ_AppActionAuCtrl : public MJ_AppAction
{
public:
  MJ_AppActionAuCtrl(MJ_ModuleAuCtrl *);
  virtual ~MJ_AppActionAuCtrl();

  virtual void operate();

  void newAddress(const QCString &s);

  void done() { m_aucontrol = 0; m_done = true; }
  void dspStop();

protected:

  QCString     m_address;

  bool         m_socketOpen;

  DI_Socket    m_serverSocket;
  DI_Socket   *m_dataSocket;

  MJ_ModuleAuCtrl *m_aucontrol;

  DI_MutexAuto m_mutex;

  static bool m_debug;
};

#endif
