
#include <mj_module_diva_af.h>

#include <qapplication.h>

static void MJ_divaTest(QApplication *, int iArgc, char **cppArgv)
{
  const char *filename = "test.wav";

  for(int i=1; i < iArgc; i++) {
    if((strcmp(cppArgv[i], "--file") == 0) && ((i+1) < iArgc))
      filename = cppArgv[++i];
  }

  MJ_ModuleDivaAudioFileIn *mfr = new MJ_ModuleDivaAudioFileIn;
  MJ_ModuleLevel  *ml = new MJ_ModuleLevel;

  mfr->setFileName(filename);
  mfr->dspSetOutChannels(2);

  ml->dspSetInChannels(2);

  MJ_ModuleDspRow dr;
  dr.appendModule(mfr);
  dr.appendModule(ml);
  
  ml->dspConnectInput(mfr->id(), 0, 0);
  ml->dspConnectInput(mfr->id(), 1, 1);

  MJ_ModuleDspRow_QG drg(0, &dr);
  drg.setTestMode(true);

  a->setMainWidget(&drg);
  a->exec();
}


int main(int iArgc, char **cppArgv)
{
  QApplication a(iArgc, cppArgv);

  MJ_divaTest(&a, iArgc, cppArgv);
  return 0;
}
