/* COPYRIGHT
 *
 * This file is part of Mustajuuri GPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2004.
 * e-mail: firstname.lastname(at)hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the General Public License (GPL),
 * versions 2. Extra clauses can be found from the file MUSTAJUURI_GPL
 * and further explanations from the file MUSTAJUURI_LICENSE. The
 * license text can be found in file "GPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *  
 */
/* -*- C++ -*- */

#ifndef MJ_MODULE_FILE_READ_H
#define MJ_MODULE_FILE_READ_H

#include <mj_module_dsp.h>
#include <di_audio_file.h>


class QApplication;

class MJ_ModuleFileRead : public MJ_ModuleDsp
{
public:
  MJ_ModuleFileRead();
  ~MJ_ModuleFileRead();

  virtual bool dspPrepare();
  virtual void dspProcessPeriod();
  virtual bool dspStop();
  
  virtual bool msgProcess(int,MJ_Message *);

  void setFileName(const QString &name) { m_fileName = name.copy(); }

  static void test(QApplication *, int iArgc, char **cppArgv);

  static bool *debugPtr() { return &m_debug; }

protected:

  bool open();
  void close();

  QString m_fileName;

  DI_AudioFile m_file; 

  MJ_Vector<MJ_Sample> m_buffer;

  bool m_processing;

  static bool m_debug;
};

#endif
