/* COPYRIGHT
 *
 * This file is part of Mustajuuri GPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2004.
 * e-mail: firstname.lastname(at)hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the General Public License (GPL),
 * versions 2. Extra clauses can be found from the file MUSTAJUURI_GPL
 * and further explanations from the file MUSTAJUURI_LICENSE. The
 * license text can be found in file "GPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *  
 */

#ifndef MJ_MODULE_EQ1_GUI_H
#define MJ_MODULE_EQ1_GUI_H

#include <mj_module_dsp_gui_default.h>

class MJ_FreqRespGui;

class MJ_ModuleEq1_QG : public MJ_ModuleDspGuiPostCard
{
  Q_OBJECT
public:
  MJ_ModuleEq1_QG(MJ_RtControl *rtparent,
		  MJ_ModuleDsp *module,
		  QWidget      *parent = 0,
		  const char   *name = 0);

  virtual ~MJ_ModuleEq1_QG();

  virtual void moduleModified(const char *);

  static MJ_ModuleDspGui *createNew(MJ_RtControl *rtparent,
				    MJ_ModuleDsp *module,
				    QWidget *parent, 
				    const char *name);

public slots:

  void grMousePress(QMouseEvent *, float, float);
  void grMouseRelease(QMouseEvent *, float, float);

protected:
  
  void draw();

  void updateEq();

  void setPeak(float x, float y);

  MJ_FreqRespGui *m_freqResp;

  /** This variable ise used to block multiple graph updates that
      would take place unnecessarily. */
  bool m_blockDraw;
};

#endif
