/* COPYRIGHT
 *
 * This file is part of Mustajuuri GPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2004.
 * e-mail: firstname.lastname(at)hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the General Public License (GPL),
 * versions 2. Extra clauses can be found from the file MUSTAJUURI_GPL
 * and further explanations from the file MUSTAJUURI_LICENSE. The
 * license text can be found in file "GPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *  
 */

#include <mj_module_eq3_gui.h>

#include <mj_error.h>

#include <mj_module_eq2.h>


MJ_ModuleEq3_QG::MJ_ModuleEq3_QG(MJ_RtControl *rtparent,
				 MJ_ModuleDsp *module,
				 QWidget      *parent,
				 const char   *name)
  : MJ_ModuleEq2_QG(rtparent, module, false, parent, name)
{}

MJ_ModuleEq3_QG::~MJ_ModuleEq3_QG()
{}

MJ_ModuleDspGui *MJ_ModuleEq3_QG::createNew(MJ_RtControl *rtparent,
					    MJ_ModuleDsp *module,
					    QWidget *parent, 
					    const char *name)
{
  return new MJ_ModuleEq3_QG(rtparent, module, parent, name);
}

void MJ_ModuleEq3_QG::setBand(double Hz, double gainDb)
{
  char bufGain[128];
  
  lock();
  uint activeBand = ((MJ_ModuleEq2 *) m_module)->closestGraphicBand(Hz);
  unlock();
  
  MJ_ModuleEq2::formMsgId(bufGain, 0, activeBand);
  
  MJ_trace("MJ_ModuleEq3_QG::setBand", activeBand);

  if(activeBand != m_activeBand)
    grMouseRelease(0, 0.0, 0.0);

  setActiveBand(activeBand);
  
  setValue(bufGain, gainDb);
}
