/* COPYRIGHT
 *
 * This file is part of Mustajuuri GPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2004.
 * e-mail: firstname.lastname(at)hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the General Public License (GPL),
 * versions 2. Extra clauses can be found from the file MUSTAJUURI_GPL
 * and further explanations from the file MUSTAJUURI_LICENSE. The
 * license text can be found in file "GPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *  
 */

#ifndef MJ_MODULE_HIGH_PASS_H
#define MJ_MODULE_HIGH_PASS_H

/* Include base  definitions. */
#include <mj_module_dsp.h>

#include <mj_filter_iir2.h>

#include <vector>

/* Single-band parametric EQ. */
class MJ_ModuleHighPass : public MJ_ModuleDsp
{
public:
  
  typedef MJ_FilterIIR2<MJ_Sample> Filter;

  MJ_ModuleHighPass();

  virtual ~MJ_ModuleHighPass();

  virtual bool dspPrepare();
  virtual void dspProcessPeriod();
  virtual bool msgProcess(const char *, MJ_Message *);
  virtual MJ_Parameter * msgGetInput(const char *);
  virtual QCString msgGetInputName(int);

protected:

  void updateFilterCoeffs();
  void clearFilterMemories();

  double  m_cutOffHz;
  double  m_q;

  std::vector<Filter> m_filters;
};

#endif
