/* COPYRIGHT
 *
 * This file is part of Mustajuuri GPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2004.
 * e-mail: firstname.lastname(at)hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the General Public License (GPL),
 * versions 2. Extra clauses can be found from the file MUSTAJUURI_GPL
 * and further explanations from the file MUSTAJUURI_LICENSE. The
 * license text can be found in file "GPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *  
 */

#include <mj_module_graph.h>

#include <mj_dsp_plugin.h>
#include <mj_version.h>

MJ_ModuleDsp *MJ_createNew_ModuleGraph()
{
  return new MJ_ModuleGraph;
}

MJ_PluginDbeDsp *MJ_ModuleGraph_Dbe()
{
  MJ_PluginDbeDsp *dbe = new MJ_PluginDbeDsp;

  dbe->setAuthors("Ilmonen Tommi S.");
  dbe->setMenuPosition("_Hosts_Freeform graph");
  dbe->setCreator(MJ_createNew_ModuleGraph);
  dbe->setIdentifier("MUSTAJUURI_graph");
  dbe->pluginVersion()->set(0,0,1);
  dbe->options()->setChans(0,0,1,256);

  dbe->setPluginDebug(MJ_ModuleGraph::debugPtr());
  
  return dbe;
}

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////


static MJ_PluginDbeDsp *__MJ_createPlugin(int m)
{
  if(!m) return MJ_ModuleGraph_Dbe();

  return 0;
}
static QString compileDate(DATETIME);

MJ_PluginDbeDsp *MJ_createPlugin(int m)
{
  MJ_PluginDbeDsp * dbe = __MJ_createPlugin(m);

  if(dbe) dbe->setParameter(MJ_PP_COMPILE_TIME, compileDate);

  return dbe;
}


