/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of Mustajuuri GPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2004.
 * e-mail: firstname.lastname(at)hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the General Public License (GPL),
 * versions 2. Extra clauses can be found from the file MUSTAJUURI_GPL
 * and further explanations from the file MUSTAJUURI_LICENSE. The
 * license text can be found in file "GPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *  
 */

#ifndef MJ_MODULE_LADSPA_H
#define MJ_MODULE_LADSPA_H

#include <mj_module_dsp.h>

#include <ladspa.h>

class MJ_ModuleLadspa : public MJ_ModuleDsp
{
public:
  MJ_ModuleLadspa(const LADSPA_Descriptor * handle);
  virtual ~MJ_ModuleLadspa();

  virtual bool dspPrepare();
  virtual void dspProcessPeriod();
  virtual bool dspStop();

  virtual bool msgProcess(const char *, MJ_Message *);
  virtual MJ_Parameter * msgGetInput(const char *);
  virtual QCString msgGetInputName(int);

protected:
  
  void getDefaultValues();

  const LADSPA_Descriptor * m_handle;
  
  LADSPA_Handle m_plugin;

  MJ_Array<LADSPA_Data> m_data;
};

#endif
