/* COPYRIGHT
 *
 * This file is part of Mustajuuri GPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2004.
 * e-mail: firstname.lastname(at)hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the General Public License (GPL),
 * versions 2. Extra clauses can be found from the file MUSTAJUURI_GPL
 * and further explanations from the file MUSTAJUURI_LICENSE. The
 * license text can be found in file "GPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *  
 */

#include <mj_dsp_plugin.h>
#include <mj_version.h>

#include <mj_module_1ton.h>

/* This file exports the mux plugins. */

static MJ_ModuleDsp * MJ_createNew_MJ_Module1ToN() 
{
  return new MJ_Module1ToN;
}

MJ_PluginDbeDsp * MJ_createPlugin(int i)
{
  if(i) return 0;

  MJ_PluginDbeDsp *dbe = new MJ_PluginDbeDsp;

  dbe->setAuthors("Ilmonen Tommi S.");
  dbe->setMenuPosition("_Audio_Routing_Select one");
  dbe->setCreator(MJ_createNew_MJ_Module1ToN);
  dbe->setIdentifier("MUSTAJUURI:MUX:1ton");

  dbe->options()->setChans(1,1,1,MJ_Module1ToN::maxChans());
  dbe->setParameter(MJ_PP_COMPILE_TIME, DATETIME);
  
  // dbe->setParameter(MJ_PP_TRANSLATION_FILE, <mj_compressor");
  
  return dbe;
}
