/* COPYRIGHT
 *
 * This file is part of Mustajuuri GPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2004.
 * e-mail: firstname.lastname(at)hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the General Public License (GPL),
 * versions 2. Extra clauses can be found from the file MUSTAJUURI_GPL
 * and further explanations from the file MUSTAJUURI_LICENSE. The
 * license text can be found in file "GPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *  
 */

#include <mj_dsp_plugin.h>
#include <mj_version.h>

#include <mj_module_reverb.h>

static MJ_ModuleDsp * MJ_createNew_MJ_ModuleReverb1() 
{
  return new MJ_ModuleReverb1;
}

MJ_PluginDbeDsp * MJ_createPlugin(int i)
{
  if(i) return 0;

  MJ_PluginDbeDsp *dbe = new MJ_PluginDbeDsp;

  dbe->setAuthors("Ilmonen Tommi S.");
  dbe->setMenuPosition("_Audio_Tests_Reverb 1");
  dbe->setCreator(MJ_createNew_MJ_ModuleReverb1);
  dbe->setIdentifier("Tommi.Ilmonen_at_hut_fi_reverb1");

  dbe->options()->setChans(1,2,2,2);
  dbe->setParameter(MJ_PP_COMPILE_TIME, DATETIME);
    
  return dbe;  
}
