/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of Mustajuuri GPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2004.
 * e-mail: firstname.lastname(at)hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the General Public License (GPL),
 * versions 2. Extra clauses can be found from the file MUSTAJUURI_GPL
 * and further explanations from the file MUSTAJUURI_LICENSE. The
 * license text can be found in file "GPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *  
 */

#ifndef MJ_STK_SHAKERS_H
#define MJ_STK_SHAKERS_H

#include <mj_stk_voice.h>

#include <mj_math.h>

#include <Shakers.h>

/** Shaker voice that keeps on shaking forever. */

class MJ_StkVoiceShakers2 : public MJ_StkVoice<Shakers>
{
public:
  MJ_StkVoiceShakers2();
  virtual ~MJ_StkVoiceShakers2();

  virtual void synthesize(MJ_Sample *buf, uint samples);
  virtual bool msgProcess(const char *id, MJ_Message *, MJ_ModuleSynth *);

  static MJ_SynthVoice * create();

  void setRate(float rate) { m_rate = MJ_clampF(rate, 0.1f, 2000.0f); }
  void setSampleRate(float sr) { m_sr = sr; }
  void setAmplitude(float a) { m_amplitude = a; }
  void setFrequency(float f) { m_frequency = f; }

protected:

  float m_frequency;
  float m_amplitude;

  float m_rate;
  float m_sr;
  int  m_untilNext;
};

#endif
