/* COPYRIGHT
 *
 * This file is part of Mustajuuri GPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2004.
 * e-mail: firstname.lastname(at)hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the General Public License (GPL),
 * versions 2. Extra clauses can be found from the file MUSTAJUURI_GPL
 * and further explanations from the file MUSTAJUURI_LICENSE. The
 * license text can be found in file "GPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *  
 */

#include <mj_module_synth.h>

#include <mj_dsp_plugin.h>
#include <mj_error.h>
#include <mj_strs.h>

class MJ_PluginDbeDspSynth : public MJ_PluginDbeDsp
{
public:
  MJ_PluginDbeDspSynth() 
  { 
    MJ_trace("MJ_PluginDbeDspSynth::MJ_PluginDbeDspSynth", this);
    MJ_ModuleSynth::init(); 
  }
  virtual ~MJ_PluginDbeDspSynth();
protected:
};

MJ_PluginDbeDspSynth::~MJ_PluginDbeDspSynth()
{ 
  MJ_trace("MJ_PluginDbeDspSynth::~MJ_PluginDbeDspSynth", this);
  MJ_ModuleSynth::shutdown(); 
}

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////

MJ_ModuleDsp *MJ_createNew_ModuleSynth()
{
  return new MJ_ModuleSynth;
}

MJ_PluginDbeDsp *MJ_createPlugin(int i)
{
  if(i) return 0;

  MJ_PluginDbeDsp *dbe = new MJ_PluginDbeDspSynth;

  dbe->setAuthors(MJ_Strs::authorTommi);
  dbe->setMenuPosition("_Audio_Synthesis_Synth1");
  dbe->setCreator(MJ_createNew_ModuleSynth);
  dbe->setIdentifier("Tommi.Ilmonen_at_hut.fi_synth1");
  dbe->options()->setChans(0,MJ_SYNTH_MAX_CHANNELS,1,MJ_SYNTH_MAX_CHANNELS);
  dbe->setPluginDebug(&MJ_synthDebug);
  dbe->setParameter(MJ_PP_COMPILE_TIME, DATETIME);
  // dbe->setParameter(MJ_PP_TRANSLATION_FILE, mj_divaio");

  // dbe->setPluginDebug(MJ_ModuleDivaAudioFileIn::debugPtr());

  return dbe;
  
}
