/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of Mustajuuri GPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2004.
 * e-mail: firstname.lastname(at)hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the General Public License (GPL),
 * versions 2. Extra clauses can be found from the file MUSTAJUURI_GPL
 * and further explanations from the file MUSTAJUURI_LICENSE. The
 * license text can be found in file "GPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *  
 */

#ifndef MJ_SYNTH_MIDI_H
#define MJ_SYNTH_MIDI_H

#include <di_midi_event.h>

#include <di_types.h>

class DI_MidiEvent;
class MJ_ModuleSynth;

class MJ_SynthMidiConverter
{
public:
  MJ_SynthMidiConverter() {}
  virtual ~MJ_SynthMidiConverter() {}
  
  virtual bool convert(const DI_MidiEvent *, MJ_ModuleSynth *);
  virtual uint maxChannel() = 0;
};

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////


/** MIDI-related setup information for MJ_ModuleSynth. 

    @author Tommi Ilmonen

*/
class MJ_SynthMidiSetup
{
public:
  MJ_SynthMidiSetup();
  ~MJ_SynthMidiSetup();
  
  uint maximumOutputChannel() const;

  bool convert(const DI_MidiEvent *, MJ_ModuleSynth *);

  void setConverter(uint channel, MJ_SynthMidiConverter *conv)
  { delete m_channelSetups[channel]; m_channelSetups[channel] = conv; }

protected:
  MJ_SynthMidiConverter * m_channelSetups[DI_MIDI_CHANNELS];
};

#endif
