/* COPYRIGHT
 *
 * This file is part of Mustajuuri GPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2004.
 * e-mail: firstname.lastname(at)hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the General Public License (GPL),
 * versions 2. Extra clauses can be found from the file MUSTAJUURI_GPL
 * and further explanations from the file MUSTAJUURI_LICENSE. The
 * license text can be found in file "GPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *  
 */

#ifndef MJ_MODULE_UITEST_H
#define MJ_MODULE_UITEST_H

#include <mj_module_dsp.h>

/* This plugin does nothign, instead it is used to test the
   automagical UI generation.
*/
class MJ_ModuleUiTest : public MJ_ModuleDsp
{
public:
  MJ_ModuleUiTest();

  virtual ~MJ_ModuleUiTest();
  
  /** Does nothing. */
  virtual void dspProcessPeriod();

  /** Pretty-prints the message to the screen. */
  
  virtual bool msgProcess(const char *, MJ_Message *);

  virtual MJ_Parameter * msgGetInput(const char *);

  virtual QCString msgGetInputName(int);

protected:
  int m_i1, m_i2;
  double m_d1, m_d2;
  QString m_str1, m_str2;
  

  static const int m_params = 6;
};

#endif
