/* COPYRIGHT
 *
 * This file is part of Mustajuuri GPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2004.
 * e-mail: firstname.lastname(at)hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the General Public License (GPL),
 * versions 2. Extra clauses can be found from the file MUSTAJUURI_GPL
 * and further explanations from the file MUSTAJUURI_LICENSE. The
 * license text can be found in file "GPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *  
 */

#include <mj_module_vbap2.h>

#include <mj_dsp_plugin.h>
#include <mj_strs.h>


MJ_ModuleDsp * MJ_createNew_ModuleVBAP() 
{
  return new MJ_ModuleVBAP;
}

MJ_PluginDbeDsp *MJ_createPluginVBAP()
{
  MJ_PluginDbeDsp *dbe = new MJ_PluginDbeDsp;
  dbe->setAuthors(MJ_Strs::authorTommi);
  dbe->setMenuPosition("_Audio_Panning_Panorate with VBAP (multi-input)");
  dbe->setCreator(MJ_createNew_ModuleVBAP);
  dbe->setIdentifier("Tommi.Ilmonen@hut.fi_pan_VBAP_multichannel");
  // dbe->pluginVersion()->set(0,0,1);
  dbe->options()->setChans(1, 128, 1, MAX_LS_AMOUNT);
  dbe->setPluginDebug(&MJ_debugVBAP);
  
  return dbe;  
}

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////

MJ_ModuleDsp * MJ_createNew_ModuleVBAP2() 
{
  return new MJ_ModuleVBAP2;
}

MJ_PluginDbeDsp *MJ_createPluginVBAP2()
{
  MJ_PluginDbeDsp *dbe = new MJ_PluginDbeDsp;
  dbe->setAuthors(MJ_Strs::authorTommi);
  dbe->setMenuPosition("_Audio_Panning_Panorate with VBAP 2 (multi-input)");
  dbe->setCreator(MJ_createNew_ModuleVBAP2);
  dbe->setIdentifier("Tommi.Ilmonen@hut.fi_pan_VBAP_multichannel_delay");
  // dbe->pluginVersion()->set(0,0,1);
  dbe->options()->setChans(1, 128, 1, MAX_LS_AMOUNT);
  dbe->setPluginDebug(&MJ_debugVBAP);
  
  return dbe;  
}

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////

static MJ_PluginDbeDsp *__MJ_createPlugin(int i)
{
  if(i == 0) 
    return MJ_createPluginVBAP();
  else if(i == 1)
    return MJ_createPluginVBAP2();
  
  return 0;
}

static QString compileDate(DATETIME);

// Only adds the compile date information 
MJ_PluginDbeDsp *MJ_createPlugin(int m)
{
  MJ_PluginDbeDsp * dbe = __MJ_createPlugin(m);

  if(dbe) dbe->setParameter(MJ_PP_COMPILE_TIME, compileDate);

  return dbe;
}

