/* COPYRIGHT
 *
 * This file is part of Mustajuuri LGPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2004.
 * e-mail: firstname.lastname(at)hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. Extra clauses can be found from the file
 * MUSTAJUURI_LGPL and further explanations from the file
 * MUSTAJUURI_LICENSE. The license text can be found in file
 * "LGPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *    
 */


#include <qawl_preview_test.h>
#include <qawl_preview_test2.h>
#include <qawl_view.h>

#include <qapplication.h>

int main(int argc, char **argv)
{
  int test = 0;

  const char * file = 0;

  for(int i=0; i < argc; i++) {

    if(strcmp(argv[i], "-t2") == 0) {
      test = 1;
    }
    if(strcmp(argv[i], "-t3") == 0) {
      test = 2;
    }
    if(strcmp(argv[i], "-f") == 0 && (i + 1 < argc)) {
      file = argv[++i];
    }
    else
      fprintf(stderr, "Unrecognized option \"%s\"\n", argv[i]);
  }

  QApplication qa(argc, argv);

  qDebug("QAWL: test Init");
  
  QWidget * tw = 0;

  if(test == 0) {

    QAWL_PreviewTest *tester = new QAWL_PreviewTest;  
    tester->setFile(file ? file : "test.wav");

    tw = tester;
  }
  else {
    QAWL_PreviewTest2 *tester2  = new QAWL_PreviewTest2(test - 1);

    if(file)
      tester2->view()->setFile(file);
    
    tw = tester2;
    tw->resize(600, 400);
  }

  qa.setMainWidget(tw);
  tw->show();

  qa.exec();

  delete tw;

  return 0;
}
