/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of Mustajuuri LGPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2004.
 * e-mail: firstname.lastname(at)hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. Extra clauses can be found from the file
 * MUSTAJUURI_LGPL and further explanations from the file
 * MUSTAJUURI_LICENSE. The license text can be found in file
 * "LGPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *    
 */

#ifndef QAWL_PREVIEW_TEST2_H
#define QAWL_PREVIEW_TEST2_H

#include <qwidget.h>

class QAWL_View;

class QSlider;

class QAWL_PreviewTest2 : public QWidget
{
  Q_OBJECT
public:
  QAWL_PreviewTest2(int test = 0);
  virtual ~QAWL_PreviewTest2();

  QAWL_View *view() { return m_view;}

public slots:
  void open();
  void setScale(int);
  void setMagnify(int);

  void setScaleType(int);

signals:
  void emitScaleType(int);

protected:

  double     m_scale;

  QAWL_View *m_view;

  QSlider   *m_slider;
};

#endif
