/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of Mustajuuri LGPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2004.
 * e-mail: firstname.lastname(at)hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
 * This file is licensed under the Lesser General Public License
 * (LGPL) - version 2.1. Extra clauses can be found from the file
 * MUSTAJUURI_LGPL and further explanations from the file
 * MUSTAJUURI_LICENSE. The license text can be found in file
 * "LGPL.txt".
 *
 * If you want a parallel license (for commercial reasons for example),
 * you should negotiate the matter with the author(s).
 *    
 */

#ifndef QAWL_RENDERER_H
#define QAWL_RENDERER_H

#include <sys/types.h>

class QPointArray;
class QPainter;

class QAWL_ColorList;
class QAWL_FileCache;

class QAWL_Renderer
{
public:
  QAWL_Renderer() {}
  ~QAWL_Renderer() {}

  void render(QPainter *painter, 
	      QPointArray *points,
	      QAWL_FileCache *cache, 
	      ulong firstRealFrame, ulong lastRealFrame,
	      uint chan,
	      /// Pixels
	      int left, 
	      /// Pixels
	      int right, 
	      /// Pixels
	      int centerY,
	      /// Pixels
	      float height,
	      /// Clip at this number of pixels
	      int clipPixels,
	      QAWL_ColorList * colors = 0);
  
protected:
};

#endif
