
/* 
   This file contains a function to check the ownership of a paricular 
   process.

   Copyright info:

   Author : Tommi S. Ilmonen - Tommi.Ilmonen@hut.fi
   License: LPGL
   Date   : 28.1.1998
 */

#include <unistd.h>
#include <iostream.h>
#include <strstream.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include <di_types.h>

#include <mj_owns_pid.h>


struct passwd *MJ_pidOwner(pid_t pid)
{
  const int bsize = 1024;
  char      buf[bsize];
  char      buf2[bsize];
  char      buf3[bsize];
  char      buf4[bsize];
  char      buf5[bsize];

  // The fields of the parameters in "/bin/ps -l -p" output
  /* int       uidField = 2;
     int       pidField = 3;
     
     int       maxField = 4; */

  ostrstream tmp;
  tmp << "/bin/ps -l -p " << (int) pid;

  char *cmd = tmp.str();
  if(!cmd) return 0;
  
  FILE *ptr = popen(cmd, "r");

  delete [] cmd;

  char **endptr = 0;

  int round = 0;
  
  if(ptr) {
    while (fgets(buf, bsize, ptr)) {

      if(round) {
	sscanf(buf, "%s %s %s %s", buf2, buf3, buf4, buf5);
	long int psPid = strtol(buf5, endptr, 10);

	cout << " psPid = " << psPid << endl;
	
	long int psUid = strtol(buf4, endptr, 10);
	
	cout << " psUid = " << psUid << endl;
	
	if(psPid == (long int) pid) {
	  pclose(ptr);
	  return getpwuid(psUid);
	}
      }
      round++;
    }
  }
  pclose(ptr);
  return 0;
}
