/* Random Qt-XML tests

   Please do not take this file too seriously.

 */

#include <qdom.h> 
#include <qfile.h> 
#include <qxml.h> 

#include <iostream.h> 

void foo()
{
  QDomDocument doc("Mustajuuri-1.0alpha");
  
  QDomElement docElem = doc.documentElement();
  
  QDomElement n1 = doc.createElement("c1");
  QDomElement n2 = doc.createElement("B1");

  QDomElement elem = doc.createElement("img");
  elem.setAttribute("src", "myimage.png");
  
  QDomElement ded = doc.createElement("floats");
  ded.setAttribute("value", 1.0 / 3.0);

  QDomText det = doc.createTextNode("fuula");
  det.setData("Kissa ja koira menivt kauppaan (!)");

  n1.appendChild(ded);
  n1.appendChild(elem);
  n2.appendChild(det);
  n1.appendChild(n2);

  doc.appendChild(n1);

  QString s = doc.toString();

  cout << s << endl;
}

class StructureParser : public QXmlDefaultHandler
{
public:
    bool startDocument()
    {
        indent = "";
        return TRUE;
    }
    bool startElement( const QString&, const QString&, const QString& qName, const QXmlAttributes& )
    {
        cout << indent << qName << endl;
        indent += " ";
        return TRUE;
    }
    bool endElement( const QString&, const QString&, const QString& )
    {
        indent.remove( 0, 1 );
        return TRUE;
    }

  virtual bool characters ( const QString & ch ) 
  {
    
    cout << indent << "\"" << ch << "\"" << endl;
    return TRUE;
  }

private:
    QString indent;
};

int main(int argc, char **argv)
{
  foo();
  
  puts("Enter qXML SAX test");
  
  for ( int i=1; i<argc; i++ ) {
    StructureParser handler;
    QFile xmlFile( argv[i] );
    QXmlInputSource source( xmlFile );
    QXmlSimpleReader reader;
    reader.setContentHandler( &handler );
    reader.parse( source );
  }
  return 0;

#if 0

  QFile f("mydocument.xml");
  doc.setContent(& f);

  // print out the element names of all elements that are a direct child
  // of the outermost element.
  QDomElement docElem = doc.documentElement();
  
  QDomNode n = docElem.firstChild();
  while( !n.isNull() ) {
      QDomElement e = n.toElement(); // try to convert the node to an element.
      if( !e.isNull() ) { // the node was really an element.
	cout << e.tagName() << endl;
      }
      n = n.nextSibling();
  }

  // lets append a new element to the end of the document
  QDomElement elem = doc.createElement("img");
  elem.setAttribute("src", "myimage.png");

  n.appendChild( elem );
#endif
}
