/* COPYRIGHT
 *
 * This file is part of Mustajuuri GPL modules.
 *
 * Author: Tommi Ilmonen, 1999-2001.
 * Tommi.Ilmonen@hut.fi
 *
 * http://www.tml.hut.fi/~tilmonen/mustajuuri/
 *
  
 * This file is licensed under the GNU Public License (GPL).

 *  
 */

/* WHAT IS IT: 

   It removes useless carriaga returns from the end line.

   No more crap from Bill G.

*/

/*
  CC -n32 -LANG:std remcr.C -o remcr

 */

#include <stdio.h>

#include <fstream>
#include <strstream>

void cleanfile(const char *filename)
{
  FILE *file = fopen(filename, "r");

  if(!file) {
    printf("Could not open file \"%s\"\n", filename);
    fflush(0);
    return;
  }
  
  std::ostrstream tmp;

  int c;

  int removals = 0;

  while( (c = getc(file)) != EOF) {
    if(c != 13)
      tmp << (char) c;
    else
      removals++;
  }
  
  fclose(file);

  if(!removals) {
    printf("File \"%s\" was clean\n", filename);
    fflush(0);
    return;
  }

  std::ofstream out(filename);
  char * str = tmp.str();
  out << str;

  // puts(str);

  delete [] str;

  printf("Cleaned file \"%s\"\n", filename);
  fflush(0);
}

int main(int argc, char **argv) 
{
  if(argc < 2)
    puts("Usage: remcr file1 file2 file3 ... filen");

  for(int i=1; i < argc; i++) {
    cleanfile(argv[i]);  
  }

  return(0);
}

