/* Viena main application logic. */

#ifndef VIENA_APPLICATION_H
#define VIENA_APPLICATION_H

#include <qgl.h>

#include <mj_array2d.h>

class DI_VideoInput;

class VienaApplication : public QGLWidget
{
public:
  enum Foo { CAMERAS = 1 };

  VienaApplication();
  ~VienaApplication();
  
  bool init(const char * configFile);

protected:
  virtual void initializeGL ();
  virtual void resizeGL ( int width, int height );
  virtual void paintGL ();

  void estimateCandleLocation();
  void findImagePeak(int * x, int * y);

  DI_VideoInput * m_camera[CAMERAS];

  float m_candleX, m_candleY;


  MJ_Array2D<uchar> m_image;

  GLuint m_textures[CAMERAS];
  
};


#endif
