#!/bin/zsh

export DATE=`date '+%d-%m-%Y'`
ALL=false

while [ -n "$1" ];
do

  case "$1" in
    -v)
    shift
    DATE="$1"
    ;;

    -a)
    ALL=true
    ;;

  esac

  shift

done


cvs -d /p/projects/vee/CVS checkout vee

mkdir vee/include/Fluid
cp $FLUID_ROOT/src/base/Vector*.hpp vee/include/Fluid/
cp $FLUID_ROOT/src/base/Matrix*.hpp vee/include/Fluid/
cp $FLUID_ROOT/src/base/Math.hpp vee/include/Fluid/
cp $FLUID_ROOT/src/base/TimeStamp.hpp  vee/include/Fluid/
cp $FLUID_ROOT/src/base/TimeStamp.cpp  vee/src/gee


if [ "$ALL" = false ];
then
  echo "Erasing copyrighted material from VEE"
  rm vee/src/test/images/kuva*.png
fi

ln -s -f vee vee-$DATE
tar cfz vee-$DATE.tgz vee-$DATE/*

ls -al  vee-$DATE.tgz

rm -rf vee vee-$DATE

