/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef VEE_MGC_H
#define VEE_MGC_H

#include <Fluid/Vector3.hpp>
#include <Fluid/Matrix3.hpp>

namespace Wml {
  template<class Real> class Vector3;
  template<class Real> class Matrix3;
}

typedef Wml::Vector3<float> WmlVector3;
typedef Wml::Matrix3<float> WmlMatrix3;

inline WmlVector3 * toWml(Fluid::Vector3 *v)
{ return (WmlVector3 *) v; }
inline const WmlVector3 * toWml(const Fluid::Vector3 *v)
{ return (const WmlVector3 *) v; }

inline WmlMatrix3 * toWml(Fluid::Matrix3 *v)
{ return (WmlMatrix3 *) v; }
inline const WmlMatrix3 * toWml(const Fluid::Matrix3 *v)
{ return (const WmlMatrix3 *) v; }

inline Fluid::Vector3 * toFluid(WmlVector3 *v)
{ return (Fluid::Vector3 *) v; }
inline const Fluid::Vector3 * toFluid(const WmlVector3 *v)
{ return (const Fluid::Vector3 *) v; }

inline Fluid::Matrix3 * toFluid(WmlMatrix3 *v)
{ return (Fluid::Matrix3 *) v; }
inline const Fluid::Matrix3 * toFluid(const WmlMatrix3 *v)
{ return (const Fluid::Matrix3 *) v; }

#endif
