/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#include <vee_value_object.h>

#include <vee_object.h>

VEE_ValueObject::VEE_ValueObject(VEE_Object *obj)
  : m_obj(obj)
{}

VEE_ValueObject::~VEE_ValueObject()
{}

VEE_Value * VEE_ValueObject::clone() const
{
  return new VEE_ValueObject(m_obj ? m_obj->clone() : 0);
}

VEE_Object *VEE_ValueObject::newObject()
{
  return m_obj ? m_obj->clone() : 0;
}
