/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#include <vee_bgl_app.h>


VEE_BglApp::VEE_BglApp(VEE_SdlApp * app)
  : m_gld(0),
    m_app(app)
{}

VEE_BglApp::~VEE_BglApp()
{}

void VEE_BglApp::contextInit()
{
  m_gld = new VEE_SdlApp::GlData();
  m_app->initGl(m_gld);
}

void VEE_BglApp::contextCleanup()
{
  delete m_gld;
  m_gld = 0;
}
 
void VEE_BglApp::draw()
{
  glClearColor(1, 0, 0, 1);
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

  glMatrixMode(GL_PROJECTION);
  
  // glLoadIdentity ();
  
  /* gluPerspective (70.0f,
		  1.0f, 
		  0.05,
		  10000.0f);*/
  
  glMatrixMode(GL_MODELVIEW);

  /* glClearDepth(1.0);
  glDepthFunc(GL_LESS);
  glEnable(GL_DEPTH_TEST);

  gluOrtho2D(-1, 1, -1, 1);

  glBegin(GL_TRIANGLES);
    
  glVertex3f(0, 0, 0);
  glVertex3f(1, 0, 0);
  glVertex3f(1, 1, 0);
  
  glEnd();*/
  
  glColor3f(1, 1, 1);

  m_app->draw(m_gld);
}

void VEE_BglApp::preFrame()
{
  m_app->update();
  
  if(m_app->isDone())
    quit();
}
