/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */


#ifndef VEE_POLYGON_CLOUDS_H
#define VEE_POLYGON_CLOUDS_H

#include <vee_color_table.h>
#include <vee_vortex_effect.h>
#include <vee_random.h>

class VEE_PolygonClouds : public VEE_VortexEffect
{
public:
  VEE_PolygonClouds(const VEE_Vector3 &location, 
		    const VEE_Vector3 & velocity,
		    float size,
		    float age,
		    float cloudInterval, 
		    float magnitude);

  virtual ~VEE_PolygonClouds();

  virtual void update(float dt);

protected:

  virtual void emitCloud();

  VEE_RgbaTable m_colorTable;

  double m_cloudInterval;
  double m_sinceLastCloud;
};

#endif
