# Usual initializations:

from vee_init import *
from vee import *
import math

qa = QApplication_newApp()
scene = VEE_SceneBox()
VEE_ObjectFactory_init()

agelimit = 5.0
gravity = 5.0

# object = "cat.lwo";
object = "models/town-5-flat.lwo";
# object = "statue-6-flat.lwo";
# object = "saddle.lwo";
# object = "cupbase.lwo";
# object = "/usr/share/Performer/data/teapot.dxf";
objectscale = 1.0;

# objectLwo = object + ".lwo"
objectField = object + ".vfi"

model = Solar_Model();
model.centralize();
Solar_Loaders_load(model, object);

rebuildField = 0

if rebuildField:
    vgrid = VEE_VectorGrid();
    vgrid.createFromModel(model, 50, 3, 3, -1);
    vgrid.writeGridToFile(objectField)

    saveVfa = 0
    
    if saveVfa:
        vgrid.writeAsciiFile(object + ".vfa", vgrid.layers() / 2);

# res = VEE_VectorGrid_fromModelToFile(objectField, object, 70, 3, 3, 1);

rot = VEE_Matrix3();
rot.identity()

# rot.rotateY(-VEE_HALF_PI)
# rot.rotateZ(1.0)

#############################################################################

rendertype = VEE_RenderClass();

#############################################################################

vgrid = VEE_VectorGrid();

res = vgrid.readGridFromFile(objectField)

gridforce = VEE_GridForce();

gridforce.setGrid(vgrid)
gridforce.setValueFloat("magnitude", 20.0);
gridforce.setValueFloat("scalemul", objectscale);
gridforce.setVisible(0);

objloc = VEE_Vector3();

objloc.make(0.0, 0.0, 0.0);

gridforce.setLocation(objloc);
gridforce.setValueMatrix3("rotation", rot);

scene.addNewObject(gridforce)

print "VISIBLE"
print gridforce.visible();

#############################################################################

# Build a particle with nice colors, lifespan etc:

p = VEE_Particle2()
p.setRenderClass(rendertype);
p.thisown = 1

# p.setAgeLimit(agelimit)

rgbatable = VEE_RgbaTable()
color = VEE_Rgba()

color.set(1.0, 0.3, 0.1, 0.5, 0.9)
rgbatable.appendColor(color)
color.set(0.8, 0.4, 0.3, 0.5, 0.9)
rgbatable.appendColor(color)
color.set(0.7, 0.4, 0.2, 0.5, 0.9)
rgbatable.appendColor(color)
color.set(0.4, 0.3, 0.3, 0.6, 0.9)
rgbatable.appendColor(color)
color.set(0.3, 0.3, 0.3, 0.6, 0.6)
rgbatable.appendColor(color)
color.set(0.1, 0.1, 0.1, 0.4, 0.1)
rgbatable.appendColor(color)
color.set(0.0, 0.0, 0.0, 0.5, 0.0)
rgbatable.appendColor(color)
color.set(0.0, 0.0, 0.0, 0.0, 0.0)
rgbatable.appendColor(color)

# looks = VEE_LooksColorTable2(rgbatable, 3.0)
looks = VEE_LooksColorTable(rgbatable)
looks.thisown = 0

valueLooks = VEE_ValueLooks()
valueLooks.setLooks(looks)

p.setValue("looks", valueLooks)

sizecurve = VEE_ValueCurve2();
sizecurve.setId("size");
sizecurve.appendPoint(0.3, 0.0);
sizecurve.appendPoint(0.3, 0.2);
sizecurve.appendPoint(0.4, 0.6);
sizecurve.appendPoint(1.0, 1.0);
sizecurve.setScaling(VEE_TS_LINEAR);
# sizecurve.setScaling(VEE_TS_AGE_MATCH);

p.appendSelfOperator(sizecurve.clone());

areacurve = VEE_ValueCurve2();
areacurve.setId("area");
areacurve.appendPoint(1.0, 0.0);
areacurve.appendPoint(5.0, 0.3);
areacurve.appendPoint(6.5, 0.6);
areacurve.appendPoint(10.0, 1.5);
areacurve.setScaling(VEE_TS_LINEAR);
# areacurve.setScaling(VEE_TS_AGE_MATCH);

p.appendSelfOperator(areacurve.clone());

texloop = VEE_OperatorTextureLoop();

for i in range(16,23):
    texloop.addTexture(i);

texloop.setTimeScale(VEE_TS_PERIODIC);
texloop.setLoopTime(0.2);

# p.appendSelfOperator(texloop.clone());

#############################################################################

# Now for the flame creator
creator =  VEE_Emitter(p)
creator.thisown = 0;

r = p.setValue("looks", valueLooks)

v1 = VEE_Vector3()
v2 = VEE_Vector3()

range = 0.2

v1.make(-range, -0.5 * range , -range)
v2.make( range,  0.5 * range,  range)

rv = VEE_ValueRandomVector3()

rv.setRanges(v1, v2)

vo = VEE_ValueOperator()

# vo.set("addvelocity", rv.clone())
# creator.appendOperator(vo.clone())

rsv = VEE_OperatorRandomSphereVector()
rsv.setId("velocity");
rsv.setRadius(5.0);
creator.appendOperator(rsv.clone())


vo.set("addlocation", rv.clone())
creator.appendOperator(vo.clone())

rf = VEE_ValueRandomFloat()
rf.set(0.0, 0.1)

vo.set("mass", rf.clone())
creator.appendOperator(vo.clone())
creator.setVisible(0)

orf = VEE_OperatorRandomFloat()
orf.setId("agelimit");
orf.setRadius(1.5);
orf.setOperation(VEE_MATH_ADD);

creator.appendOperator2(orf.clone(), "agerand")

orf = VEE_OperatorRandomFloat()
orf.setId("area");
orf.setRadius(1.0);
orf.setOperation(VEE_MATH_ADD);

creator.appendOperator2(orf.clone(), "arearand")

scene.addNewObject(creator)

#############################################################################



#############################################################################

rigid = VEE_RigidParticle()
rigid.thisown = 0

rigid.setValueFloat("area", 0.9);
rigid.setValueFloat("mass", 2.4);
rigid.setValueFloat("size", 0.2);
rigid.setValueFloat("omega", 2.0);
rigid.setValueFloat("agelimit", 2.0);
#color.set(1.0, 0.3, 0.1, 0.5, 0.8)
#rigid.setColor(color);
rigid.setValueRgbatf("color", 0.5, 0.3, 0.3, 1.0, 0.0);

#############################################################################

creator2 = VEE_Emitter(rigid);

rsv.setId("velocity");
rsv.setRadius(6.0);
creator2.appendOperator(rsv.clone())
creator2.setRate(5.0);

creator2.setValueVector3f("location", 0.0, 5.0, 0.0);

orf = VEE_OperatorRandomFloat()
orf.setId("omega");
orf.setRadius(25.0);
orf.setOperation(VEE_MATH_ADD);

creator2.appendOperator2(orf.clone(), "omega")

rsv = VEE_OperatorRandomSphereVector()
rsv.setId("axis");
rsv.setRadius(1.0);
creator2.appendOperator(rsv.clone())

creator2.setValueFloat("mulrate", 0.1)

orf.setId("size");
orf.setRadius(0.1);
orf.setOperation(VEE_MATH_ADD);

creator2.appendOperator2(orf.clone(), "sizerand")
creator2.setVisible(0);

scene.addNewObject(creator2)


#############################################################################

# Sparks to the scene:

spark = VEE_Particle()
spark.setRenderClass(rendertype);
color.set(1.0, 0.6, 0.2, 0.6, 1.0);
spark.setColor(color);

spark.setValueInt("texture", 15);
spark.setValueFloat("size", 0.1);
spark.setValueFloat("agelimit", 0.5);

sparky = VEE_Emitter(spark.clone());
sparky.setValueFloat("area", 1.0);
sparky.setValueFloat("rate", 40);
sparky.setValueInt("maxcount", 600);
sparky.setValueFloat("agelimit", 4.5);
sparky.setValueFloat("size", 0.08);
sparky.setVelocityUpdate(1)
sparky.thisown = 0
color.set(1.0, 0.0, 0.0, 1.0, 1.0);
sparky.setColor(color);

rsv.setId("velocity");
rsv.setRadius(2.0);

sparky.appendOperator(rsv.clone())

sparkSource = VEE_Emitter(sparky);
sparkSource.setValueFloat("mulrate", 0.04)

rsv.setRadius(4.0);
sparkSource.appendOperator(rsv.clone())
sparkSource.setVisible(0)

scene.addNewObject(sparkSource)


#############################################################################

# Create a few forces:

g = VEE_ObjectFactory_create("gravity")
scene.addNewObject(g)
g.setValueInt("visible", 0);

repel = VEE_ObjectFactory_create("gravitate")
repel.setValueFloat("epsilon", 0.001);
repel.setValueInt("forcetype", VEE_FORCE_DRAG);
scene.addNewObject(repel)
repel.setValueInt("visible", 0);

damp = VEE_ObjectFactory_create("damping")
scene.addNewObject(damp)
damp.setValueInt("visible", 0);

locationFollowers = VEE_ParamTargets()
locationFollowers.append(repel, "location");
locationFollowers.append(creator2, "location");
locationFollowers.append(sparkSource, "location");

rateFollowers = VEE_ParamTargets()
rateFollowers.append(creator2, "rate");
rateFollowers.append(sparkSource, "rate");

#grav = VEE_ObjectFactory_create("gravitate")
#grav.setValueFloat("range", 2.0);
#grav.setValueFloat("magnitude", -200); # Push away from object
#grav.setValueFloat("maxforce", 10);
#grav.setLocation3(1.0, 4.0, 0.0);
#scene.addNewObject(grav)

# scene.addNewObject(VEE_ObjectFactory_create("blow"))

#############################################################################

# Make GUI mappings fo a couple a few parameters:

paramView = VEE_ValueWindow()

paramView.addFloatParameter("Gravity", "gravity", g, -1, -20.0, 20.0,
                            VEE_MAP_LINEAR);

paramView.addFloatParameter("Gravitate decay", "decaypower", repel,
                            1.0, 0.0, 20.0,
                            VEE_MAP_LINEAR);

paramView.addFloatParameter("Gravitate magnitude", "magnitude", repel,
                            -10.0, -200 , 0.0,
                            VEE_MAP_LINEAR);

paramView.addFloatParameter("Gravitate range", "range", repel,
                            1.3, .1 , 10.0,
                            VEE_MAP_LOGARITHMIC);

paramView.addFloatParameter("Gravitate maxforce", "maxforce", repel,
                            10.0, .5 , 100.0,
                            VEE_MAP_LOGARITHMIC);

paramView.addFloatParameter("Grid Bounce distance",
                            "bouncedistance", gridforce,
                            0.2, 0.0, 2.0,
                            VEE_MAP_LINEAR);

paramView.addFloatParameter("Grid flow distance",
                            "flowdistance", gridforce,
                            1.0, 0.0, 4.0,
                            VEE_MAP_LINEAR);

paramView.addFloatParameter("Grid drag distance",
                            "dragdistance", gridforce,
                            0.2, 0.0, 2.0,
                            VEE_MAP_LINEAR);

paramView.addFloatParameter("Grid magnitude", "magnitude", gridforce,
                            400.0, .5, 1000.0,
                            VEE_MAP_LOGARITHMIC);

paramView.addFloatParameter("Grid bounciness", "bounce", gridforce,
                            0.0, 0.0, 1.0,
                            VEE_MAP_LINEAR);

paramView.addFloatParameter("Grid drag", "drag", gridforce,
                            0.0, 0.0, 7.0,
                            VEE_MAP_LINEAR);

paramView.addFloatParameter("Grid drag power", "dragpower", gridforce,
                            2.0, 0.0, 3.0,
                            VEE_MAP_LINEAR);

paramView.addFloatParameter("Grid tangent force", "tangentforce", gridforce,
                            3.0, -100.0, 100.0,
                            VEE_MAP_LINEAR);

paramView.addFloatParameter("Grid tangent grab", "tangentgrab", gridforce,
                            30.0, -100.0, 100.0,
                            VEE_MAP_LINEAR);

paramView.addFloatParameter("Flame agelimit", "type/agelimit",
                            creator, 2.3, .2, 10.0,
                            VEE_MAP_LINEAR);

rateEdit = paramView.addFloatParameter("Flame rate", "rate",
                                       creator, 50.0, 0.0, 3000.0,
                                       VEE_MAP_LINEAR);


rateEdit.addTargets(rateFollowers);

locEdit = paramView.addVector3Parameter("Flame location", "location", creator,
                                        1.27, -7.0, 7.0,
                                        1.0, -7.0, 7.0,
                                        -1.6, -7.0, 7.0);

locEdit.addTargets(locationFollowers);

paramView.addFloatParameter("Spark size", "type/size", sparky,
                            0.2, .02, 4.0,
                            VEE_MAP_LOGARITHMIC);

paramView.addFloatParameter("Trash size", "size", rigid,
                            0.7, .2, 4.0,
                            VEE_MAP_LOGARITHMIC);

paramView.addFloatParameter("Trash agelimit", "agelimit", rigid,
                            2.8, 0.5, 4.0,
                            VEE_MAP_LINEAR);


paramView.addFloatParameter("Damping", "magnitude", damp, 0.1, -2, 6,
                            VEE_MAP_LINEAR);

#############################################################################

# keypoint location = [0.467 0.300 9.545] azi = 3.142, ele = 0.000

# Make it visible:

vq = VEE_Qt(scene, VEE_GL_SL)
# Make force invisible:
vq.resize(500, 430);
q2 = VEE_TestQt(vq, scene, "", 640, 480, VEE_GL_SL, vq)
q2.setMtlFile("vee_materials.mtl");
vq.setGlWidget(q2);

vq.toggleForceMode();
qa.setMainWidget(vq)
vq.show()
vq.setFrameFile("frames/explosion-%.5d.jpg")
# vq.setRenderOrder("1");
vq.setValueFloat("GL/size", 4.0);
vq.setValueFloat("GL/alphamul", 1.0);
vq.setValueInt("GL/subtexture", 10);
vq.setValueFloat("GL/lengthscale", 0.7);
vq.setValueFloat("GL/maxlengthscale", 2.0);
#vq.setValueInt("GL/renderorder", 2);
#vq.setValueInt("GL/blendtype", 2);

vq.setValueInt("fileoversample", 4);

vq.addKeyPoint2(17.396, 2.293, 1.761, 4.542, -0.000)
vq.addKeyPoint2(0.057, 15.082, -13.965, 0.292, -0.800)
vq.addKeyPoint2(11.747, 13.492, -11.995, -0.558, -0.700)
kp = vq.addKeyPoint2(-12.144, 2.834, 0.574, -4.708, -0.000)
vq.selectKeyPoint2(kp);

rendertype.setShader(vq.renderer().shaderNameToId("shaders/depth-fade"));

model = Solar_Model();

ok = Solar_Loaders_load(model, object);

model.centralize();
model.scale(objectscale);
solarobj = Solar_Object()

solarobj.setModel(model)
solarobj.setLocation(objloc)
solarobj.setRotation(rot)

q2.addModel(model);
q2.addObject(solarobj);

paramView.bangValues()

paramView.show()

qa.execute()

