/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#include <vee_image_blender.h>

#include <qimage.h>

#include <strings.h>

VEE_ImageBlender::VEE_ImageBlender()
{}

VEE_ImageBlender::~VEE_ImageBlender()
{}

void VEE_ImageBlender::clear()
{ 
  bzero(&m_image[0], m_image.size() * sizeof(ushort)); 
}

void VEE_ImageBlender::divide(int d)
{
  /* for(ushort * i = & * m_image.begin(); i != & * m_image.end(); i++)
     (*i) /= d; */
  for(uint i=0; i < m_image.size(); i++)
    m_image[i] /= (ushort) d;
}

bool VEE_ImageBlender::add(QImage *image) 
{
  // error:
  if(image->depth() != 32)
    return false;

  uint n = image->numBytes();

  if(n != m_image.size())
    m_image.resize(n);

  const uchar * source = image->scanLine(0);
  ushort * target = & * m_image.begin();

  for(uint i=0; i< n; i++)
    *target++ += (ushort) *source++;
    
  return true;
}

bool VEE_ImageBlender::store(QImage *image) 
{
  // error:
  if(image->depth() != 32)
    return false;

  uint n = image->numBytes();

  if(n != m_image.size())
    return false;

  uchar * target = image->scanLine(0);
  const ushort * source = & * m_image.begin();

  for(uint i=0; i < n; i++)
    *target++ = (uchar) *source++;
  return true;
}
