/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef _VEE_IMAGE_BLENDER_H_
#define _VEE_IMAGE_BLENDER_H_

#include <vector>
#include <di_types.h>

class QImage;

class VEE_ImageBlender
{
public:
  VEE_ImageBlender();
  ~VEE_ImageBlender();

  void clear();

  void divide(int d);

  bool add(QImage *image);

  bool store(QImage *image);

protected:

  std::vector<ushort> m_image;
};

#endif
