/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef VEE_VALUE_GUI_FLOAT_H
#define VEE_VALUE_GUI_FLOAT_H

#include <vee_value_gui.h>

#include <vee_parameters.h>

class VEE_HasValues;


class VEE_ValueGuiFloat : public VEE_ValueGui
{
  Q_OBJECT

public:
  VEE_ValueGuiFloat(QObject * parent = 0,
		    const char * name = 0);

  virtual ~VEE_ValueGuiFloat();

  virtual void build(VEE_ValueWindow *host,
		     VEE_HasValues  *target,
		     const VEE_ParameterFloat &parameter);
  
  virtual void bangValue();


public slots:

  void setValue(double);
  void getValue(double *);

protected:

  VEE_ParameterFloat m_value;
};

#endif
