/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef VEE_VALUE_GUI_VECTOR3_H
#define VEE_VALUE_GUI_VECTOR3_H

#include <vee_value_gui.h>

#include <vee_parameters.h>

class VEE_HasValues;

class VEE_ValueGuiVector3 : public VEE_ValueGui
{
  Q_OBJECT

public:
  VEE_ValueGuiVector3(QObject * parent = 0,
		    const char * name = 0);

  virtual ~VEE_ValueGuiVector3();

  virtual void build(VEE_ValueWindow *host,
		     VEE_HasValues  *target,
		     const VEE_ParameterVector3 &parameter);
  
  virtual void bangValue();

public slots:

  void setValue1(double);
  void getValue1(double *);
  void setValue2(double);
  void getValue2(double *);
  void setValue3(double);
  void getValue3(double *);

protected:

  void setValue(int, double);
  void getValue(int, double *);

  VEE_ParameterVector3 m_value;
};

#endif
