/* COPYRIGHT
 *
 * This file is part of the Visual Effects Engine - VEE
 *
 * Read the "VEE-LICENSE" file for the license.
 *
 * Authors & Copyright:   
 *
 * Tommi Ilmonen, Tuukka Heikura, Marko Myllymaa and 
 * Janne Kontkanen 2001-2004
 *
 * Additional copyrights: Tekes 2003-2004
 *
 * firstname.lastname@hut.fi
 *
 */

#ifndef VEE_VRS_APP_H
#define VEE_VRS_APP_H

#include <VrSmuggler.hpp>

#include <vee_sdl_app.h>

#include <map>

class VEE_VrsApp : public VRS_GlApp
{
public:

  typedef std::map<VRS_Window *, VEE_SdlApp::GlData *> container;
  typedef container::iterator iterator;

  VEE_VrsApp(VEE_SdlApp * app);
  virtual ~VEE_VrsApp();

  VEE_SdlApp & app() { return * m_app; }

protected:
  
  virtual void contextInit(VRS_Window * context);
  virtual void contextCleanup(VRS_Window * context);
  virtual void draw(VRS_Window * context, int eye);
  virtual void preFrame();

  VEE_SdlApp * m_app;
  container m_glData;
};

#endif
