/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Simple Object Loader and Renderer - SOLAR
 *
 * Read the file "SOLAR-LICENSE" for the license.
 *
 * Authors & Copyright:
 *
 * Tommi Ilmonen, 2001-2003, except LWO-code by RJ, 2001-2003
 *
 * Tommi's email: firstname.lastname@hut.fi
 *
 */

#include <Solar/RotatingObject.hpp>

#include <Fluid/Math.hpp>

namespace Solar {

RotatingObject::RotatingObject()
  : m_rotationAxis(0.0f, 1.0f, 0.0f),
    m_angle(0.0),
    m_omega(0.0)
{}

RotatingObject::~RotatingObject()
{}

void RotatingObject::update(float dt)
{
  m_angle += (dt * m_omega);

  if(m_angle > Fluid::Math::PI) m_angle -= Fluid::Math::TWO_PI;
  else if(m_angle < -Fluid::Math::PI) m_angle += Fluid::Math::TWO_PI;

  m_rotation.rotateAroundAxis(m_rotationAxis, m_angle);
}

} // namespace Solar
