/* -*- C++ -*- */

/* COPYRIGHT
 *
 * This file is part of the Simple Object Loader and Renderer - SOLAR
 *
 * Read the file "SOLAR-LICENSE" for the license.
 *
 * Authors & Copyright:
 *
 * Tommi Ilmonen, 2001-2003, except LWO-code by RJ, 2001-2003
 *
 * Tommi's email: firstname.lastname@hut.fi
 *
 */

#ifndef SOLAR_ROTATING_OBJECT_HPP
#define SOLAR_ROTATING_OBJECT_HPP

// #include <Solar/RotatingObject.hpp>
#include <Solar/Object.hpp>


namespace Solar {

/** An object that rotates. */
class RotatingObject : public Object
{
public:
  RotatingObject();
  virtual ~RotatingObject();

  virtual void update(float dt);

  void setRotationAxis(const Fluid::Vector3 &axis) { m_rotationAxis = axis; }
  void setAngle(float radians) { m_angle = radians; }
  void setOmega(float o) { m_omega = o; }

protected:
  Fluid::Vector3 m_rotationAxis;
  float m_angle;
  float m_omega;
};


} // namespace Solar



#endif
