
/* COPYRIGHT
 *
 * This file is part of the Simple Object Loader and Renderer - SOLAR
 *
 * Read the file "SOLAR-LICENSE" for the license.
 *
 * Authors & Copyright:
 *
 * Tommi Ilmonen, 2001-2003, except LWO-code by RJ, 2001-2003
 *
 * Tommi's email: firstname.lastname@hut.fi
 *
 */

#include <Solar/Loaders.hpp>
#include <Solar/Model.hpp>

#include <stdio.h>


#ifdef HAVE_PERFORMER
extern "C"
{
#define PF_C_API 1
#define PF_CPLUSPLUS_API 0 
#include <Performer/pf.h>
}
#endif

int main(int argc, char **argv)
{
  const char * filename = "ball.lwo";

  if(argc > 1) filename = argv[1];

  printf("Preparing to read file \"%s\"\n", filename);
  fflush(0);

  Solar::Model model;

  bool ok = Solar::Loaders::load(&model, filename);

  if(ok) puts("Loaded and converted file successfully");
  else puts("Something failed (could not read file ?"
	    ", could not convert data?)");
  
  fflush(0);
}
